/*
 * Created on Apr 20, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.util.List;

import edu.cs2335.SWATLP.client.clientdata.ApproachData;
import edu.cs2335.SWATLP.client.spacegame.PlayerShip;
import edu.cs2335.SWATLP.client.spacegame.ScreenObject;
import edu.cs2335.SWATLP.client.spacegame.ZoneEngine;
import edu.cs2335.SWATLP.server.port.TradeGood;

/**
 * @author macguy
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class ApproachRender extends GuiRender {

    /**
     * Comment for <code>approachengine</code>
     */
    private ZoneEngine approachengine;

    /**
     * Comment for <code>mainwindow</code>
     */
    private final MainGui mainwindow; 

    /**
     * Comment for <code>main</code>
     */
    private final MainClass main;
    /** The approach data */
    private ApproachData data;
    /** The player ship data */
    private PlayerShip player;
    /** The background image */
    private final Image background;
    /** The object */
    private List zoneobjects;
    /** The gov type */
    private String govtype;
    /** The zone number of the approach */
    private int zonenumber;
    /** The side bar */
    private final Image bar;
    
    /** The planets name */
    private String planetName;
    /** The cargo cargo size */
    private String cargoSize;
    /** the max cargo size */
    private String cargoMax;
    /** The list of cargo */
    private int[] cargo = new int[8];
    
    /**
     * The approach render constructor
     * @param mainwindow MainGui
     * @param main MainClass
     */
    public ApproachRender(MainGui mainwindow, MainClass main) {
        this.mainwindow = mainwindow;
        this.main = main;
        setWindowNumber(8);
        Toolkit tk = Toolkit.getDefaultToolkit();
        background = tk.getImage("pics/approach/star.jpg");
        bar = tk.getImage("pics/approach/statusBar.png");
        zonenumber = 1;
    }
    
    /**
     * This sets up the approach zome
     * @param thedata the approach data
     * @param govt the government type
     */
    public void setupApproachZone(ApproachData thedata, String govt) {
        this.govtype = govt;
        this.data = thedata;
        player = new PlayerShip(thedata.getShiptype(), thedata);
 
        cargoSize = "" + data.getCargoSize();
        cargoMax = "" + data.getMaxCargo();
        List goods = data.getCargo();
        planetName = mainwindow.getCurrentplanet().getName();

        for (int i = 0; i < goods.size(); i++) {
            TradeGood temp = (TradeGood) goods.get(i);
            if (temp.equals("GAMES")) {
                cargo[0] = temp.getAmount();
            } else if (temp.equals("ORE")) {
                cargo[1] = temp.getAmount();
            } else if (temp.equals("MMM")) {
                cargo[2] = temp.getAmount();
            } else if (temp.equals("WEAPONS")) {
                cargo[3] = temp.getAmount();
            } else if (temp.equals("FOOD")) {
                cargo[4] = temp.getAmount();
            } else if (temp.equals("WATER")) {
                cargo[5] = temp.getAmount();
            } else if (temp.equals("MEDS")) {
                cargo[6] = temp.getAmount();
            } else if (temp.equals("ROBOTS")) {
                cargo[7] = temp.getAmount();
            }
        }
        
        approachengine = new ZoneEngine(govtype, player, data, zonenumber);
        zoneobjects = approachengine.getZoneObjects();
        Thread approachthread = new Thread(approachengine);
        approachthread.start();
    }

    
    
    
    /**
     * renders the screen
     * @param g Graphics2D
     */
    public void render(Graphics2D g) {
        Font oldFont = g.getFont();

        approachengine.setUpdating(false);
        if (!approachengine.isRunning()) {
            zonenumber = approachengine.getZonenumber();

            data.setFuelCurrent((int) player.getFuel());
            
            if (zonenumber == 5) {
                // let the server know the cargo, fuel, player loc, etc.
                mainwindow.updateServer(data, "zone5", false);
                
                
                mainwindow.setupLander(data, player);
                //mainwindow.switchWindow(11);
                
                // reset the zone number
                zonenumber = 1;

                return;
            // arrived at: next zone 
            } else {
                // let the server know the cargo, fuel, player loc, etc.
                if (main.getConnection() != null) {
                mainwindow.updateServer(data, "zone" + zonenumber, false);
                }
                // setup the zone
                setupApproachZone(data, govtype);

                return;
            }
        }
        ScreenObject obj = null;
        g.drawImage(background, 0, 20, mainwindow);
        g.drawImage(bar, 600, 20, mainwindow);
        
        //draws the fuel and health bar
        g.setColor(Color.WHITE);
        g.drawRoundRect(620, 150, 160, 25, 10, 10);
        g.drawRoundRect(620, 200, 160, 25, 10, 10);
        g.setColor(Color.RED);
        g.fillRoundRect(622, 152, 
                data.getFuelCurrent() * 160 / data.getFuelMax() - 2, 21, 
                10, 10);
        
        g.setColor(Color.BLUE);
        g.fillRoundRect(622, 202, 
                data.getHitpointsCurrent() * 160 / data.getHitpointsMax() - 2,
                21, 10, 10);
        
        g.setColor(Color.YELLOW);
        //draw the cargo info

        g.drawString(cargoSize, 665, 317);
        g.drawString(cargoMax, 745, 317);
        
        int y = 349; 
        for (int i = 0; i < 8; i++) {
            g.drawString("" + cargo[i], 695, y);
            y += 17;
        }
        
        //draws the planets name and current zone
        g.setFont(oldFont.deriveFont(16.0f));
        g.drawString("" + zonenumber, 735, 575);
        g.drawString(planetName, 660, 525);
        //this draws all the objects on the screen
        for (int i = 0; i < zoneobjects.size(); i++) {
            obj = (ScreenObject) (zoneobjects.get(i));
            obj.render(g);
        }
        approachengine.setUpdating(true);
    }
    
    /**
     * keypressed
     * @param e KeyEvent
     */
    public void keyPressed(KeyEvent e) {
        int code = e.getKeyCode();
        switch(code) {
            case 32:
                player.setFiring(true);
                player.setFired(true);
                break;
            case 37:
                player.setTurningleft(true);
                break;
            case 38:
                player.setAccel(true);
                break;
            case 39:
                player.setTurningright(true);
                break;
            case 40:
                player.setBraking(true);
                break;
            case 84:
                player.changeMode(true);
                break;
            default:
                break;
        }
    }
    
    /**
     * keyreleased 
     * @param e KeyEvent
     */
    public void keyReleased(KeyEvent e) {
        int code = e.getKeyCode();
        //System.out.println(code);
        switch(code) {
            case 32:
                player.setFiring(false);
                break;
            case 37:
                player.setTurningleft(false);
                break;
            case 38:
                player.setAccel(false);
                break;
            case 39:
                player.setTurningright(false);
                break;
            case 40:
                player.setBraking(false);
                break;
            case 84:
                player.changeMode(false);
                break;
            default:
                break;
        }
    }
    /**
     * @return Returns the approachengine.
     */
    public ZoneEngine getApproachengine() {
        return approachengine;
    }
    /**
     * @param approachengine The approachengine to set.
     */
    public void setApproachengine(ZoneEngine approachengine) {
        this.approachengine = approachengine;
    }
    /**
     * @return Returns the background.
     */
    public Image getBackground() {
        return background;
    }
    /**
     * @return Returns the bar.
     */
    public Image getBar() {
        return bar;
    }
    /**
     * @return Returns the cargo.
     */
    public int[] getCargo() {
        return cargo;
    }
    /**
     * @param cargo The cargo to set.
     */
    public void setCargo(int[] cargo) {
        this.cargo = cargo;
    }
    /**
     * @return Returns the cargoMax.
     */
    public String getCargoMax() {
        return cargoMax;
    }
    /**
     * @param cargoMax The cargoMax to set.
     */
    public void setCargoMax(String cargoMax) {
        this.cargoMax = cargoMax;
    }
    /**
     * @return Returns the cargoSize.
     */
    public String getCargoSize() {
        return cargoSize;
    }
    /**
     * @param cargoSize The cargoSize to set.
     */
    public void setCargoSize(String cargoSize) {
        this.cargoSize = cargoSize;
    }
    /**
     * @return Returns the data.
     */
    public ApproachData getData() {
        return data;
    }
    /**
     * @param data The data to set.
     */
    public void setData(ApproachData data) {
        this.data = data;
    }
    /**
     * @return Returns the govtype.
     */
    public String getGovtype() {
        return govtype;
    }
    /**
     * @param govtype The govtype to set.
     */
    public void setGovtype(String govtype) {
        this.govtype = govtype;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @return Returns the mainwindow.
     */
    public MainGui getMainwindow() {
        return mainwindow;
    }
    /**
     * @return Returns the planetName.
     */
    public String getPlanetName() {
        return planetName;
    }
    /**
     * @param planetName The planetName to set.
     */
    public void setPlanetName(String planetName) {
        this.planetName = planetName;
    }
    /**
     * @return Returns the player.
     */
    public PlayerShip getPlayer() {
        return player;
    }
    /**
     * @param player The player to set.
     */
    public void setPlayer(PlayerShip player) {
        this.player = player;
    }
    /**
     * @return Returns the zonenumber.
     */
    public int getZonenumber() {
        return zonenumber;
    }
    /**
     * @param zonenumber The zonenumber to set.
     */
    public void setZonenumber(int zonenumber) {
        this.zonenumber = zonenumber;
    }
    /**
     * @return Returns the zoneobjects.
     */
    public List getZoneobjects() {
        return zoneobjects;
    }
    /**
     * @param zoneobjects The zoneobjects to set.
     */
    public void setZoneobjects(List zoneobjects) {
        this.zoneobjects = zoneobjects;
    }
}
