/*
 * Created on Apr 20, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontFormatException;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.ImageIcon;

/**
 * @author thaile
 *
 */
public class BankDialog extends GuiRender {
    /** the mainGui to draw to */
    private MainGui board;

    /** the MainClass to send msg */
    private MainClass main;
    /** cash amt */
    private String cash;
    /** bank amt */
    private String bank;
    /** debt amt */
    private String debt;
    /** loan amt */
    private String playerworth;
    /** if we can get a loan */
    private boolean loan;

    /** the old window listener to load again */
    private int oldWindow;

    /** the back ground pick to draw */
    private Image bg;

    /** the side button image */
    private Image[] button;

    /** the done button */
    private Image[] doneButton;
    /** FLAG: if the button is armed or not */
    private int[] armed;
    /** buttoned that is armed */
    private int barmed;
    /** The current state that we are in */
    private int state = 0;
    /** the font to use */
    private Font smallfont;
    /** The font to use for buttons */
    private Font largefont;
    /** The amt */
    private String amt;


    /**
     * Constructor
     *
     * @param board MainGui
     * @param main MainClass
     */
    public BankDialog(MainGui board, MainClass main) {

        this.board = board;
        this.main = main;
        setWindowNumber(10);
        
        doneButton = new Image[2];
        button = new Image[2];

        armed = new int[18];
        for (int i = 0; i < 18; i++) {
            armed[i] = 0;
        }
        

        bg = (new ImageIcon("pics/bank.png")).getImage();

        doneButton[0] = (new ImageIcon("pics/done.png")).getImage();
        doneButton[1] = (new ImageIcon("pics/doneArm.PNG")).getImage();
        
        button[0] = (new ImageIcon("pics/sButton.png")).getImage();
        button[1] = (new ImageIcon("pics/sButtonArm.png")).getImage();

        try {
            File tempfont = new File("fonts/Lucida_Console.ttf");
            FileInputStream readFile = new FileInputStream(tempfont);
            Font tempFont = Font.createFont(Font.TRUETYPE_FONT, readFile);
            smallfont = tempFont.deriveFont(12.0f);
            largefont = tempFont.deriveFont(32.0f);
        } catch (FileNotFoundException e) {
            System.out.println("font not found");
        } catch (FontFormatException e) {
            System.out.println("font not formatted");
        } catch (IOException e) {
            System.out.println("error reading in font");
        }
    }

    /**
     * This switches back to the old window
     * 
     * @param window
     *            The window to switch to
     */
    public void setOldWindow(int window) {
        oldWindow = window;
    }

    /**
     * This returns the old window
     * 
     * @return the old window
     */
    public int getOldWindow() {
        return oldWindow;
    }

    /**
     * Renders the error box
     * 
     * @param g
     *            Graphics2D
     */
    public void render(Graphics2D g) {
        int i = 0;
        Font oldFont = g.getFont();
        g.setFont(smallfont);
        g.setColor(Color.white);
        g.drawImage(bg, 200, 50, null);
 
        for (int x = 235; x <= 525; x += 290) {
            for (int y = 165; y < 300; y += 45) {
                g.drawImage(button[armed[i]], x, y, null);
                i++;
            }
        }
        g.setFont(smallfont);
        g.drawString("Bank: " + bank, 445, 360);
        g.drawString("Cash: " + cash, 445, 380);
        switch(state) {
        case 0: //init screen
            g.drawString("Welcome to Glactic Bank ATM", 300, 170);
            g.drawString("Serving      location across", 300, 180);
            g.drawString("the universe", 300, 190);
            g.drawString("English  -->", 420, 280);
            break;
        case 1: //option menu
            g.drawString("How can we help you today?", 300, 170);
            g.drawString("<- Loan", 290, 190);
            g.drawString("<- Pay Debt", 290, 230);
            g.drawString("<- Back", 290, 280);

            g.drawString("Deposit Money ->", 392, 230);
            g.drawString("Withdraw Money ->", 390, 280);
            break;
        case 2: //Deposit money
            g.drawString("Please Enter the amount", 300, 170);
            g.drawString("to deposit::", 300, 200);
            g.drawString(amt, 400, 200);
            g.drawString("<- Back", 290, 280);
            g.drawString("Clear ->", 420, 280);
            break;
        case 3: //withdraw money
            g.drawString("Please Enter the amount", 300, 170);
            g.drawString("to WithDraw::", 300, 200);
            g.drawString(amt, 400, 200);
            g.drawString("<- Back", 290, 280);
            g.drawString("Clear ->", 420, 280);
            break;
        case 4: //loan
            g.drawString("Loan center", 300, 170);
            if (loan && debt.equals("0")) {
                g.drawString("Loan: " + playerworth, 300, 200);
            } else if (loan && !debt.equals("0")) {
                g.drawString("You've already taken", 300, 200);
                g.drawString("out a loan.", 300, 230);
            } else {
                g.drawString("Sorry dude, you have a", 300, 200);
                g.drawString("bad reputation.", 300, 230);
            }
            g.drawString("<- Back", 290, 280);
            break;
        case 5: //pay debt
            g.drawString("Your debt:", 300, 170);
            g.drawString(debt, 380, 170);
            g.drawString("amount:", 300, 200);
            g.drawString(amt, 355, 200);
            g.drawString("<- Back", 290, 280);
            g.drawString("Clear ->", 420, 280);
            break;
        default:
        }
        
        
        g.setFont(largefont);
        for (int y = 355; y < 490; y += 45) {
            for (int x = 265; x < 400; x += 45) {
                g.drawImage(button[armed[i]], x, y, null);
                g.drawString("" + (i - 5), x + 10, y + 30);
                i++;
        }    }


        g.drawImage(doneButton[armed[i]], 440, 400, null);
        i++;
        g.drawImage(doneButton[armed[i]], 440, 465, null);
        i++;
        g.drawImage(button[armed[i]], 310, 490, null);
        g.drawString("0", 320, 520);
        g.drawString("ENTER", 460, 435);
        g.drawString("DONE", 460, 500);
        
        g.setFont(oldFont);
    }

    
    /**
     * Setup the data 
     * @param data Server data
     */
    public void setup(String[] data) {
        bank = data[1];
        cash = data[2];
        debt = data[3];
        playerworth = data[4];
        if (data[5].equals("t")) {
            loan = true;
        } else {
            loan = false;
        }
        
        amt = "0";
    }
    
    /**
     * key type
     * 
     * @param e
     *            KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == '\n') { //enter key
            board.closeErrorBox();
        }
    }

    /**
     * handles mouse presses
     * 
     * @param e
     *            MouseEvent
     */
    public void mousePressed(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();
        // these are the left side buttons3       
        if (x > 235 && x < 275) {
            if (y > 165 && y < 205) {
                armed[0] = 1;
                barmed = 0;
            } else if (y > 210 && y < 250) {
                armed[1] = 1;
                barmed = 1;
            } else if (y > 255 && y < 295) {
                armed[2] = 1;
                barmed = 2;
            }
        // these are the right side buttons
        } else if (x > 525 && x < 565) {
            if (y > 165 && y < 205) {
                armed[3] = 1;
                barmed = 3;
            } else if (y > 210 && y < 250) {
                armed[4] = 1;
                barmed = 4;
            } else if (y > 255 && y < 295) {
                armed[5] = 1;
                barmed = 5;
            }
        }
   
        if (y > 355 && y < 395) {
            if (x > 265 && x < 305) {
                armed[6] = 1;
                barmed = 6;
            } else if (x > 310 && x < 350) {
                armed[7] = 1;
                barmed = 7;
            } else if (x > 355 && x < 395) {
                armed[8] = 1;
                barmed = 8;
            }
        } else if (y > 400 && y < 440) {
            if (x > 265 && x < 305) {
                armed[9] = 1;
                barmed = 9;
            } else if (x > 310 && x < 350) {
                armed[10] = 1;
                barmed = 10;
            } else if (x > 355 && x < 395) {
                armed[11] = 1;
                barmed = 11;
            } 
        } else if (y > 445 && y < 485) {
            if (x > 265 && x < 305) {
                armed[12] = 1;
                barmed = 12;
            } else if (x > 310 && x < 350) {
                armed[13] = 1;
                barmed = 13;
            } else if (x > 355 && x < 395) {
                armed[14] = 1;
                barmed = 14;
            }
        }
        
        if (x > 315 && x < 350 && y > 490 && y < 530) {
            armed[17] = 1;
            barmed = 17;
        } else if (x > 440 && x < 560 && y > 400 && y < 450) {
            armed[15] = 1;
            barmed = 15;
        } else if (x > 440 && x < 560 && y > 465 && y < 515) {
            armed[16] = 1;
            barmed = 16;
        }

    }

    /**
     * mouse handler
     * 
     * @param e
     *            MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();
        if (x > 235 && x < 275) {
            if (y > 165 && y < 205 && barmed == 0) {
                if (state == 1) { // get debt
                    state = 4;
                }
            } else if (y > 210 && y < 250 && barmed == 1) {
                if (state == 1) { // pay debt
                    state = 5;
                }
            } else if (y > 255 && y < 295 && barmed == 2) {
                if (state == 1) {
                    state = 0;
                } else if (state > 1) {
                    state = 1;
                    amt = "0";
                }
            }
        // these are the right side buttons
        } else if (x > 525 && x < 565) {
            if (y > 165 && y < 205 && barmed == 3) {
                 System.out.println("");
            } else if (y > 210 && y < 250 && barmed == 4) {
                if (state == 1) {
                    state = 2;
                }
            } else if (y > 255 && y < 295 && barmed == 5) {
                if (state == 0) {
                    state = 1;
                } else if (state == 1) {
                    state = 3;
                } else if (state > 1) {
                    amt = "0";
                }
            }
        }
        
        if (y > 355 && y < 395) {
            if (x > 265 && x < 305 && barmed == 6) {
                amt("1");
            } else if (x > 310 && x < 350 && barmed == 7) {
                amt("2");
            } else if (x > 355 && x < 395 && barmed == 8) {
                amt("3");
            }
        } else if (y > 400 && y < 440) {
            if (x > 265 && x < 305 && barmed == 9) {
                amt("4");
            } else if (x > 305 && x < 350 && barmed == 10) {
                amt("5");
            } else if (x > 355 && x < 395 && barmed == 11) {
                amt("6");
            }
        } else if (y > 445 && y < 485) {
            if (x > 265 && x < 305 && barmed == 12) {
                amt("7");
            } else if (x > 310 && x < 350 && barmed == 13) {
                amt("8");
            } else if (x > 355 && x < 395 && barmed == 14) {
                amt("9");
            }
        }
        
        if (x > 305 && x < 350 && y > 490 && y < 530 && barmed == 17) {
            amt("0");
        } else if (x > 440 && x < 560 && y > 400 && y < 450 && barmed == 15) {
            String msg = "BANKTRANS~";
            if (!amt.equals("0")) {
                if (state == 2 && Long.parseLong(amt)
                        <= Long.parseLong(cash)) {
                    msg += "deposit~" + amt;
                    main.getConnection().sendMessage(msg); 
                } else if (state == 3 && Long.parseLong(amt)
                        <= Long.parseLong(bank)) {
                    msg += "withdraw~" + amt;
                    main.getConnection().sendMessage(msg);
                } else if (state == 5 && Long.parseLong(amt)
                        <= (Long.parseLong(cash)) 
                         + Long.parseLong(bank)) {
                    msg += "paydebt~" + amt;
                    main.getConnection().sendMessage(msg);
                }
            }
            if (state == 4) {
                msg += "loan";
                main.getConnection().sendMessage(msg);
            }

        } else if (x > 440 && x < 560 && y > 465 && y < 515 && barmed == 16) {
            state = 0;
            board.closeBankWindow();
        }
        
        if (barmed != -1) {
            armed[barmed] = 0;
            barmed = -1;
        }
        System.out.println("x:" + e.getX() + " y:" + e.getY());

    }
    
    /**
     * Add that string to amt
     * @param d String
     */
    public void amt(String d) {
        if (state > 1) {
            if (amt.equals("0")) {
                amt = d;
            } else {
                amt += d;
            }
        }
    }
    /**
     * @return Returns the amt.
     */
    public String getAmt() {
        return amt;
    }
    /**
     * @param amt The amt to set.
     */
    public void setAmt(String amt) {
        this.amt = amt;
    }
    /**
     * @return Returns the armed.
     */
    public int[] getArmed() {
        return armed;
    }
    /**
     * @param armed The armed to set.
     */
    public void setArmed(int[] armed) {
        this.armed = armed;
    }
    /**
     * @return Returns the bank.
     */
    public String getBank() {
        return bank;
    }
    /**
     * @param bank The bank to set.
     */
    public void setBank(String bank) {
        this.bank = bank;
    }
    /**
     * @return Returns the barmed.
     */
    public int getBarmed() {
        return barmed;
    }
    /**
     * @param barmed The barmed to set.
     */
    public void setBarmed(int barmed) {
        this.barmed = barmed;
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @param bg The bg to set.
     */
    public void setBg(Image bg) {
        this.bg = bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @param board The board to set.
     */
    public void setBoard(MainGui board) {
        this.board = board;
    }
    /**
     * @return Returns the button.
     */
    public Image[] getButton() {
        return button;
    }
    /**
     * @param button The button to set.
     */
    public void setButton(Image[] button) {
        this.button = button;
    }
    /**
     * @return Returns the cash.
     */
    public String getCash() {
        return cash;
    }
    /**
     * @param cash The cash to set.
     */
    public void setCash(String cash) {
        this.cash = cash;
    }
    /**
     * @return Returns the debt.
     */
    public String getDebt() {
        return debt;
    }
    /**
     * @param debt The debt to set.
     */
    public void setDebt(String debt) {
        this.debt = debt;
    }
    /**
     * @return Returns the doneButton.
     */
    public Image[] getDoneButton() {
        return doneButton;
    }
    /**
     * @param doneButton The doneButton to set.
     */
    public void setDoneButton(Image[] doneButton) {
        this.doneButton = doneButton;
    }
    /**
     * @return Returns the largefont.
     */
    public Font getLargefont() {
        return largefont;
    }
    /**
     * @param largefont The largefont to set.
     */
    public void setLargefont(Font largefont) {
        this.largefont = largefont;
    }
    /**
     * @return Returns the loan.
     */
    public boolean isLoan() {
        return loan;
    }
    /**
     * @param loan The loan to set.
     */
    public void setLoan(boolean loan) {
        this.loan = loan;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @param main The main to set.
     */
    public void setMain(MainClass main) {
        this.main = main;
    }
    /**
     * @return Returns the playerworth.
     */
    public String getPlayerworth() {
        return playerworth;
    }
    /**
     * @param playerworth The playerworth to set.
     */
    public void setPlayerworth(String playerworth) {
        this.playerworth = playerworth;
    }
    /**
     * @return Returns the smallfont.
     */
    public Font getSmallfont() {
        return smallfont;
    }
    /**
     * @param smallfont The smallfont to set.
     */
    public void setSmallfont(Font smallfont) {
        this.smallfont = smallfont;
    }
    /**
     * @return Returns the state.
     */
    public int getState() {
        return state;
    }
    /**
     * @param state The state to set.
     */
    public void setState(int state) {
        this.state = state;
    }
}
