/*
 * Created on Apr 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.gui;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.List;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.RoundRectangle2D;

import javax.swing.ImageIcon;

/**
 * @author thaile Big file that set up the character creation screen This has a
 *         lot of fields so it takes up alot of room
 */
public class CCreateRender extends GuiRender {
    /** Reference to the control class.     */
    private final MainClass main;
    /** reference to the Main gui window     */
    private final MainGui board;

    /** the back ground image     */
    private final Image bg;
    /** holds all the skill pics */
    private final Image[] skillPic;
    /** Cargo ship pic */
    private final Image cargo;
    /** fighter ship pic */
    private final Image fighter;
    /** buttons */
    private final Image[] button = new Image[2];
    /** selection button */
    private final Image[] leftsButton = new Image[2];
    /** selection button right */
    private final Image[] rightsButton = new Image[2]; 
    /** the armed button for O(1)*/
    private int armedB;
    /** which state the button in */
    private int[] bState;
    
    /** This is important: holds the resulting strings for output */
    private String[] out = new String[3];
    /** The text */
    private final String [] text = {"      NAME:", "  PASSWORD:"
            , "PLANT NAME:", 
            "GOVERNMENT:", "TECHNOLOGY:", " SHIP TYPE:", "     SKILLS", 
            "CREATE", "RESET", "CANCEL"};
    
    /** the government selected     */
    private final String[] gov = {"Anarchy", "Pacifism", "Communism"
            , "Capitalism",
            "Cypernetic", "Feudal"};
    
    /** the tech lvl selected     */
    private final String[][] tech = {{"Medieval", "Low Tech", "High Tech"} ,
                               {"Medieval", "Low Tech"},
                               {"Medieval", "Low Tech"},
                               {"Medieval", "Low Tech", "High Tech"},
                               {"High Tech"},
                               {"Medieval"}};

    /** The skill text */
    private final String[] skilltext = {"SPECIALIZATION:", "      STRENGTH:",
                                  "        NORMAL:", "      WEAKNESS:"};
    
    /** mark the government selected */
    private int govType;
    /** mark the tech lvl selected */
    private int techLvl;
    /** list of skill modifier    */
    private int[] skills;

    /** the player name */
    private String name;
    /** the player password */
    private String pass;
    /** the player planet name */
    private String planet;
    /** The name of the ship */
    private final String[] ship = {"Trader", "Fighter"};
    /** the player shiptype */
    private int shipType;

    /** picked which field is selected */
    private int selected;
    /** select skill */
    private int skillselected;
    /** number of skills that has been picked */
    private int skillsPicked;

    /** the carret timer */
    private long timer;
    /** FLAG: display the carot or not */
    private boolean displayCarot;

    /** if the shift key was pressed or not */
    private boolean shift;
    
    /** list of skills in order */
    private final List skill;

    /** Under transpancy */
    private final RoundRectangle2D under;
    /** Selected button stokes */
    private final BasicStroke dashbox;
    
    /** Constructer
     * @param board MainGui
     * @param main MainClass
     */
    public CCreateRender(MainGui board, MainClass main) {
        skillPic = new Image[4];
        setWindowNumber(3);
        this.board = board;
        this.main = main;
        float[] dash = {2, 3};
        dashbox = new BasicStroke(1.0f, BasicStroke.CAP_SQUARE, 
                BasicStroke.JOIN_BEVEL, 45.0f, dash, 0.0f);
        under = new RoundRectangle2D.Double(50, 50, 700, 500, 20, 20);

        skillPic[0] = (new ImageIcon("pics/Combat.png")).getImage();
        skillPic[1] = (new ImageIcon("pics/pilot.png")).getImage();
        skillPic[2] = (new ImageIcon("pics/repair.png")).getImage();
        skillPic[3] = (new ImageIcon("pics/Trading.png")).getImage();
        
        button[0] = (new ImageIcon("pics/bbutton.png")).getImage();
        button[1] = (new ImageIcon("pics/bbuttonArm.png")).getImage();
        
        leftsButton[0] = (new ImageIcon("pics/leftSelect.png")).getImage();
        leftsButton[1] = (new ImageIcon("pics/leftSelectarm.png")).getImage();
        rightsButton[0] = (new ImageIcon("pics/rightSelect.png")).getImage();
        rightsButton[1] = (new ImageIcon("pics/rightSelectarm.png")).getImage();
        
        cargo = (new ImageIcon("pics/ship/cargo1.png")).getImage();
        fighter = (new ImageIcon("pics/ship/fighter1.png")).getImage();

        bg = (new ImageIcon("pics/bg1.jpg")).getImage();
        
        skills = new int[4];
        skill = new List();
        bState = new int[9];
        reset();
        //TODO FIX RESET
    }

    /**
     * renders the Character creation screen
     * 
     * @param g
     *            Graphics2D
     */
    public void render(Graphics2D g) {
        int x, y;
        Font oldFont = g.getFont();
        g.setFont(g.getFont().deriveFont(24.0f));

        //This draws the back ground
        g.drawImage(bg, 0, 0, null);

        //this draws the green transparency layer
        g.setColor(new Color(21, 113, 23));
        int rule = AlphaComposite.SRC_OVER;
        g.setComposite(AlphaComposite.getInstance(rule, .6f));
        g.fill(under);
        g.setComposite(AlphaComposite.getInstance(rule, 1.0f));
        
        //this draws out the text
        g.setColor(Color.white);
        
        out[0] = text[0] + name;
        out[1] = text[1] + pass;
        out[2] = text[2] + planet;
        if (displayCarot && selected < 3) {
            out[selected] += "|";
        } 
        g.drawString("CHARACTER CREATION", 25, 75);
        x = 75; y = 125;
        for (int i = 0; i < 3; i++) {
            g.drawString(out[i], x, y);
            y += 40;
        }       
        for (int i = 3; i < 7; i++) {
            g.drawString(text[i], x, y);
            y += 40;
        }
        
        //draw the gov and tech selectors
        x = 230; y = 222;
        for (int i = 0; i < 5; i += 2) {
            g.drawRect(x + 30, y, 165, 25);
            g.drawImage(leftsButton[bState[i]], x, y, board);
            g.drawImage(rightsButton[bState[i + 1]], x + 200, y, board);
            y += 40;
        }
        x += 35; y = 222;
        g.drawString(gov[govType], x, y + 20);
        g.drawString(tech[govType][techLvl], x, y + 60);
        g.drawString(ship[shipType], x, y + 100);
        
        //draw the buttons
        x = 600; y = 75;
        for (int i = 6; i < bState.length; i++) {
            g.drawImage(button[bState[i]], x, y, board);
            g.drawString(text[i + 1], x + 20, y + 25);
            y += 40;
        }
               
        //drawing skill icon
        x = 245; y = 340;
        for (int i = 0; i < 4; i++) {
            if (skills[i] == -5) {
                g.drawImage(skillPic[i], x, y, null);
            }
            x += 50;
        }
        
        x = 200; y = 400;
        g.setFont(oldFont.deriveFont(12.0f));
        
        for (int i = 0; i < 4; i++) {
            g.drawString(skilltext[i], x, y);
            if (i < skill.getItemCount()) {
                g.drawString((String) skill.getItem(i), x + 150, y);
            }
            y += 30;
        }
        
        if (selected == 6 && skillsPicked < 4) {
            g.setStroke(dashbox);
            g.drawRect(240 + (skillselected * 50), 335, 42, 42);
        } else if (selected > 6) {
            g.setStroke(dashbox);
            g.drawRect(605, 80 + (40 * (selected - 7)), 115, 25);
        } else if (selected > 2) {
            g.setStroke(dashbox);
            g.drawRect(230, 215 + (40 * (selected - 3)), 230, 35);
        }
        
        
        g.setFont(oldFont);
    }

    /**
     * Controls changes base on time
     * @param delta the time elapse
     */
    public void change(long delta) {
        timer -= delta;
        if (timer <= 0) {
            if (displayCarot) {
                displayCarot = false;
            } else {
                displayCarot = true;
            }
            timer = 300 + timer;
        }
    }
    
    /**
     * handles mouse press events
     * @param e MouseEvent
     */
    public void mousePressed(MouseEvent e) {
       int x = e.getX();
       int y = e.getY();
       int seldif1 = e.getX() - 230;
       int seldif2 = e.getX() - 430;
       if (x > 230 && x < 255 && y > 247 - seldif1 && y < 247) {
           System.out.println("good");
           bState[0] = 1;
           armedB = 0;
       } else if (x > 430 && x < 455 && y > 222 && y < 247 - seldif2) {
           bState[1] = 1;
           armedB = 1;
       } else if (x > 230 && x < 255 && y > 287 - seldif1 && y < 287) {
           bState[2] = 1;
           armedB = 2;
       }  else if (x > 430 && x < 455 && y > 262 && y < 287 - seldif2) {
           bState[3] = 1;
           armedB = 3;
       } else if (x > 230 && x < 255 && y > 327 - seldif1 && y < 327) {
           bState[4] = 1;
           armedB = 4;
       }  else if (x > 430 && x < 455 && y > 302 && y < 327 - seldif2) {
           bState[5] = 1;
           armedB = 5;
       }
    }
    
    
    
    /**
     * handles mouse clicks
     * @param e MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();
        int seldif1 = e.getX() - 230;
        int seldif2 = e.getX() - 430;
        
        System.out.println("id:" + e.getID() + "m:" + e.getModifiers()
                + "other" + e.getClickCount());
        // Handles the left right selector
        if (x > 230 && x < 255 && y > 247 - seldif1 && y < 247 
                && armedB == 0) {
            govType = govType == 0 ? gov.length - 1 : govType - 1;
            techLvl = 0;
        } else if (x > 430 && x < 455 && y > 222 && y < 247 - seldif2
                && armedB == 1) {
            govType = (govType + 1) % gov.length;
            techLvl = 0;
        } else if (x > 230 && x < 255 && y > 287 - seldif1 && y < 287
                && armedB == 2) {
            techLvl = techLvl == 0 ? tech[govType].length - 1 : techLvl - 1;
        }  else if (x > 430 && x < 455 && y > 262 && y < 287 - seldif2 
                && armedB == 3) {
            techLvl = (techLvl + 1) % tech[govType].length; 
        } else if (x > 230 && x < 255 && y > 327 - seldif1 && y < 327
                && armedB == 4) {
            shipType = shipType == 0 ? ship.length - 1 : shipType - 1;
        }  else if (x > 430 && x < 455 && y > 302 && y < 327 - seldif2 
                && armedB == 5) {
            shipType = (shipType + 1) % ship.length; 
        }
            
            
        System.out.println("x:" + x + " y:" + y);

        bState[armedB] = 0;

        // buttons controls
        if (x > 612 && x < 743) {
            if (y > 73 && y < 110) { //Create new player
                int result = main.createPlayer(name, pass, skills, 
                        planet, gov[govType],
                        tech[govType][techLvl], ship[shipType]);
                if (result == 0) {
                    reset();
                    board.switchWindow(MainGui.CONNECT_WINDOW);
                }
            } else if (y > 118 && y < 150) {
                reset();
            } else if (y > 158 && y < 193) {
                board.switchWindow(2);
            }
        }
  
        //skill selector
        if (y > 340 && y < 372) {
            if (x > 245 && x < 277) {
                pickskill("Combat");
            } else if (x > 295 && x < 327) {
                pickskill("Pilot");
            } else if (x > 345 && x < 377) {
                pickskill("Engineer");
            } else if (x > 395 && x < 427) {
                pickskill("Trader");
            }
        }
        

        //text field selector
        if (x > 150 && x < 150 + 15 * out[0].length() && y > 100 && y < 130) {
            selected = 0;
        } else if (x > 101 && x < 101 + 15 * out[1].length() 
                && y > 140 && y < 170) {
            selected = 1;
        } else if (x > 77 && x < 77 + 15 * out[2].length() && y > 180
                && y < 210) {
            selected = 2;
        }
    }




    /**
     * resets the data fields
     */
    public final void reset() {
        selected = 0;
        skillselected = 0;
        armedB = 0;
        name = "";
        pass = "";
        planet = "";
        govType = 3;
        techLvl = 1;
        shipType = 0;
        for (int i = 0; i < 4; i++) {
            skills[i] = -5;
        }
        for (int i = 0; i < bState.length; i++) {
            bState[i] = 0;
        }
        skill.removeAll();
        skillsPicked = 0;
    }

    
    /**
     * handles key presses 
     * @param e KeyEvent
     */
    public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == 16) {
            shift = true;
        }
        
    }
    /**
     * handles key releases
     * @param e KeyEvent
     */
    public void keyReleased(KeyEvent e) {       
        if (e.getKeyCode() == 16) {
            shift = false;
        }
        
        if (e.getKeyCode() == 8) { //backspace
            removeChar();
        } else if (e.getKeyCode() == 9) { //tab
            if (shift) {
                selected = selected == 0 ? selected = 9 : (selected - 1);
                if (selected == 6 && skillsPicked == 4) {
                    selected--;
                }
            } else {
                selected = (selected + 1) % 10;
                if (selected == 6 && skillsPicked == 4) {
                    selected++;
                }
            }
            
        } else if (e.getKeyCode() == 27) {
            board.switchWindow(2);
        }
        
        if (selected > 2 && selected < 7) {
            if (e.getKeyCode() == 37) { //left
                switch(selected) {
                case 3:
                    govType = govType == 0 ? gov.length - 1 : govType - 1;
                    techLvl = 0;
                    break;
                case 4:
                    techLvl = techLvl == 0 ? tech[govType].length - 1 
                            : techLvl - 1;
                    break;
                case 5:
                    shipType = shipType == 0 ? ship.length - 1 : shipType - 1;
                    break;
                case 6:
                    if (skillsPicked < 4) {
                        skillselected = skillselected == 0 ? 3 
                                : skillselected - 1;
                        while (skills[skillselected] != -5) {
                            skillselected = skillselected == 0 ? 3 
                                    : skillselected - 1;
                        }
                    }
                    break;
                default:
                }
            } else if (e.getKeyCode() == 39) { //right

                switch(selected) {
                case 3:
                    govType = (govType + 1) % gov.length;
                    techLvl = 0;
                    break;
                case 4:
                    techLvl = (techLvl + 1) % tech[govType].length;
                    break;
                case 5:
                    shipType = (shipType + 1)  % ship.length;
                    break;
                case 6:
                    if (skillsPicked < 4) {
                        skillselected = (skillselected + 1) % 4;
                        while (skills[skillselected] != -5) {
                            skillselected = (skillselected + 1) % 4;
                        }
                    }
                    break;
                default:
                }
            }
        }

    }

    /**
     * handles key typed
     * 
     * @param e
     *            KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == '\n' || e.getKeyChar() == ' ') {
            if (selected == 9) {
                reset();
                board.switchWindow(2);
            } else if (selected == 8) {
                reset();
            } else if (selected == 6) {
                if (skillselected == 0) {
                    pickskill("Combat");
                } else if (skillselected == 1) {
                    pickskill("Pilot");
                } else if (skillselected == 2) {
                    pickskill("Engineer");
                } else if (skillselected == 3) {
                    pickskill("Trader");    
                }
                

                if (skillsPicked < 4) {
                    skillselected = (skillselected + 1) % 4;
                    while (skills[skillselected] != -5) {
                        skillselected = (skillselected + 1) % 4;
                    }
                } else {
                    selected++;
                }
                
            } else {
                int result = main.createPlayer(name, pass, skills, 
                        planet, gov[govType],
                        tech[govType][techLvl], ship[shipType]);
                if (result == 0) {
                    reset();
                    board.switchWindow(MainGui.CONNECT_WINDOW);
                }
            }
        } else if (e.getKeyChar() != KeyEvent.VK_ESCAPE
                && e.getKeyChar() != '\b' && e.getKeyChar() != '\t') {
            addChar(e.getKeyChar());
        }
    }

    /**
     * Add a char to msg String
     * 
     * @param c
     *            char to add
     */
    private void addChar(char c) {

        switch (selected) {
        case 0:
            name += c;
            break;
        case 1:
            pass += c;
            break;
        case 2:
            planet += c;
            break;
        default:
        }
    }

    /**
     * removes a char from msg String
     */
    private void removeChar() {
        switch (selected) {
        case 0:
            if (name.length() > 0) {
                name = name.substring(0, name.length() - 1);
            }
            break;
        case 1:
            if (pass.length() > 0) {
                pass = pass.substring(0, pass.length() - 1);
            }
            break;
        case 2:
            if (planet.length() > 0) {
                planet = planet.substring(0, planet.length() - 1);
            }
            break;
        default:
        }
    }

    /**
     * update stat based on what icon was clicked
     * 
     * @param skillname
     *            the skill picked
     */
    public void pickskill(String skillname) {
        switch (skillsPicked) {
        case 0:
            setSkill(skillname, 6);
            break;
        case 1:
            setSkill(skillname, 2);
            break;
        case 2:
            setSkill(skillname, 0);
            break;
        case 3:
            setSkill(skillname, -2);
            break;
        default:
        }

    }
    
    /**
     * @param skillname the skill name
     * @param value the skill value
     */
    private void setSkill(String skillname, int value) {
        if (skillname.equals("Combat") && skills[0] == -5) {
            skill.add(skillname);
            skills[0] = value;
            skillsPicked++;
        } else if (skillname.equals("Pilot") && skills[1] == -5) {
            skill.add(skillname);
            skills[1] = value;
            skillsPicked++;
        } else if (skillname.equals("Engineer") && skills[2] == -5) {
            skill.add(skillname);
            skills[2] = value;
            skillsPicked++;
        } else if (skillname.equals("Trader") && skills[3] == -5) {
            skill.add(skillname);
            skills[3] = value;
            skillsPicked++;
        }
    }

    /**
     * @return Returns the armedB.
     */
    public int getArmedB() {
        return armedB;
    }
    /**
     * @param armedB The armedB to set.
     */
    public void setArmedB(int armedB) {
        this.armedB = armedB;
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @return Returns the bState.
     */
    public int[] getBState() {
        return bState;
    }
    /**
     * @param state The bState to set.
     */
    public void setBState(int[] state) {
        bState = state;
    }
    /**
     * @return Returns the button.
     */
    public Image[] getButton() {
        return button;
    }
    /**
     * @return Returns the cargo.
     */
    public Image getCargo() {
        return cargo;
    }
    /**
     * @return Returns the dashbox.
     */
    public BasicStroke getDashbox() {
        return dashbox;
    }
    /**
     * @return Returns the displayCarot.
     */
    public boolean isDisplayCarot() {
        return displayCarot;
    }
    /**
     * @param displayCarot The displayCarot to set.
     */
    public void setDisplayCarot(boolean displayCarot) {
        this.displayCarot = displayCarot;
    }
    /**
     * @return Returns the fighter.
     */
    public Image getFighter() {
        return fighter;
    }
    /**
     * @return Returns the gov.
     */
    public String[] getGov() {
        return gov;
    }
    /**
     * @return Returns the govType.
     */
    public int getGovType() {
        return govType;
    }
    /**
     * @param govType The govType to set.
     */
    public void setGovType(int govType) {
        this.govType = govType;
    }
    /**
     * @return Returns the leftsButton.
     */
    public Image[] getLeftsButton() {
        return leftsButton;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }
    /**
     * @param name The name to set.
     */
    public void setName(String name) {
        this.name = name;
    }
    /**
     * @return Returns the out.
     */
    public String[] getOut() {
        return out;
    }
    /**
     * @param out The out to set.
     */
    public void setOut(String[] out) {
        this.out = out;
    }
    /**
     * @return Returns the pass.
     */
    public String getPass() {
        return pass;
    }
    /**
     * @param pass The pass to set.
     */
    public void setPass(String pass) {
        this.pass = pass;
    }
    /**
     * @return Returns the planet.
     */
    public String getPlanet() {
        return planet;
    }
    /**
     * @param planet The planet to set.
     */
    public void setPlanet(String planet) {
        this.planet = planet;
    }
    /**
     * @return Returns the rightsButton.
     */
    public Image[] getRightsButton() {
        return rightsButton;
    }
    /**
     * @return Returns the selected.
     */
    public int getSelected() {
        return selected;
    }
    /**
     * @param selected The selected to set.
     */
    public void setSelected(int selected) {
        this.selected = selected;
    }
    /**
     * @return Returns the shift.
     */
    public boolean isShift() {
        return shift;
    }
    /**
     * @param shift The shift to set.
     */
    public void setShift(boolean shift) {
        this.shift = shift;
    }
    /**
     * @return Returns the ship.
     */
    public String[] getShip() {
        return ship;
    }
    /**
     * @return Returns the shipType.
     */
    public int getShipType() {
        return shipType;
    }
    /**
     * @param shipType The shipType to set.
     */
    public void setShipType(int shipType) {
        this.shipType = shipType;
    }
    /**
     * @return Returns the skill.
     */
    public List getSkill() {
        return skill;
    }
    /**
     * @return Returns the skillPic.
     */
    public Image[] getSkillPic() {
        return skillPic;
    }
    /**
     * @return Returns the skills.
     */
    public int[] getSkills() {
        return skills;
    }
    /**
     * @param skills The skills to set.
     */
    public void setSkills(int[] skills) {
        this.skills = skills;
    }
    /**
     * @return Returns the skillselected.
     */
    public int getSkillselected() {
        return skillselected;
    }
    /**
     * @param skillselected The skillselected to set.
     */
    public void setSkillselected(int skillselected) {
        this.skillselected = skillselected;
    }
    /**
     * @return Returns the skillsPicked.
     */
    public int getSkillsPicked() {
        return skillsPicked;
    }
    /**
     * @param skillsPicked The skillsPicked to set.
     */
    public void setSkillsPicked(int skillsPicked) {
        this.skillsPicked = skillsPicked;
    }
    /**
     * @return Returns the skilltext.
     */
    public String[] getSkilltext() {
        return skilltext;
    }
    /**
     * @return Returns the tech.
     */
    public String[][] getTech() {
        return tech;
    }
    /**
     * @return Returns the techLvl.
     */
    public int getTechLvl() {
        return techLvl;
    }
    /**
     * @param techLvl The techLvl to set.
     */
    public void setTechLvl(int techLvl) {
        this.techLvl = techLvl;
    }
    /**
     * @return Returns the text.
     */
    public String[] getText() {
        return text;
    }
    /**
     * @return Returns the timer.
     */
    public long getTimer() {
        return timer;
    }
    /**
     * @param timer The timer to set.
     */
    public void setTimer(long timer) {
        this.timer = timer;
    }
    /**
     * @return Returns the under.
     */
    public RoundRectangle2D getUnder() {
        return under;
    }
}