package edu.cs2335.SWATLP.client.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.List;
//import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.client.clientdata.PlayerData;
import edu.cs2335.SWATLP.client.planets.PlanetModel;
import edu.cs2335.SWATLP.client.planets.PlanetTemp;


/**
 * Renders the Short Range Chart
 */
public class ChartRender extends GuiRender {
    /** The main class. */
    private MainClass main;
    /** The main gui. */
    private MainGui board;
    /** The current typeing chat msg */
    private String msg;
    /** The backgroud image */
    private Image bg;
    /** The button */
    private Image[] button;
    /** The armed one */
    private int arm1;
    /** The armed two */
    private int arm2;
    
    /** text for the goods */
    private final String[] text = {"GAMES", "ORE", "MMM", "WEAPONS"
            , "FOOD", "WATER",
            "MEDS", "ROBOTS" };
    
    
    /** The font used for buttons */
    private Font font;
    
    /** Planet data name */
    private String planetName;
    /** Planet data */
    private String planetGov;
    /** Planet data */
    private String planetTech;
    /** planet location */
    private PlanetModel[][] planets;
    
    /** The selected planet x */
    private int selX;
    /** The selected planet y */
    private int selY;
    
    /** the x, y locations */
    private int i, j;
    /** The planets in the radius */
    private PlanetModel[][] inplanets;
    
    /** the playerdata */
    private PlayerData playerData;
    /** the current planet */
    private PlanetModel curPlanet;
    
    /** The planet police pirate merchants */
    private String[] ships = new String[3];
    
    /** the list of prices of goods */
    private int[] prices;
    /**
     * Comment for <code>fuel</code>
     */
    private int fuel;
    
    /**
     * Constructor for chart render
     * @param board  the main gui
     * @param main   the main class
     */
    public ChartRender(MainGui board, MainClass main) {
        this.main = main;
        this.board = board;
        setWindowNumber(9);
        
 //       Toolkit tk = Toolkit.getDefaultToolkit();
   //     Image b0 = tk.getImage("pics/SRC/SRC.png");
     //   Image b1 = tk.getImage("pics/SRC/button.png");
       // Image b2 = tk.getImage("pics/SRC/buttonArm.png");
        
        
        bg = (new ImageIcon("pics/SRC.jpg")).getImage();
        button = new Image[2];
        button[0] =  (new ImageIcon("pics/warpb.png")).getImage();
        button[1] =  (new ImageIcon("pics/warpbarm.png")).getImage();
        arm1 = 0;
        arm2 = 0;
        // init
        msg = ": ";
        planetName = "";
        planetGov = "";
        planetTech = "";
    }
    
    /**
     * Setup the chart and switch to it.
     * @param data  the data the chart needs
     */
    public void setupChart(String[] data) {
        int index = 1;
        boolean loop = true;
        planets = new PlanetModel[50][50];
        playerData = board.getPlayerData();
        fuel = Integer.parseInt(data[index]);

        for (index++; loop; index = index + 3) {
            
            if (data[index].equals("ENDLIST")) {
                loop = false;
                break;
            } else {
                int x = Integer.parseInt(data[index + 1]);
                int y = Integer.parseInt(data[index + 2]);
                
                planets[x][y] = new PlanetTemp(data[index], x , y);
                
            }
        }
        
        curPlanet = board.getCurrentplanet();
        
        
        
        planetName = curPlanet.getName();
        planetGov = curPlanet.getGovType();
        planetTech = curPlanet.getTechLevel();
        ships[0] = "Police: " + curPlanet.getPolice();
        ships[1] = "Merchants: " + curPlanet.getMerchant();
        ships[2] = "Pirates: " + curPlanet.getPirate();
        curPlanet.setPrices();
        prices = curPlanet.getPrices();
        i = curPlanet.getXlocation();
        j = curPlanet.getYlocation();
        selX = (i * 10) + 10;
        selY = (j * 10) + 10;
        
        System.out.println("Start: " + curPlanet.getXlocation()  
                + " " + curPlanet.getYlocation());
        
        
        // This adds in all the planets you have been too
        
        List planetname = playerData.getPlanetsName();
        for (int x = 0; x < planetname.getItemCount(); x++) {
            PlanetModel tempPlanet = playerData.getPlanet((String)
                    planetname.getItem(x));
            int a = tempPlanet.getXlocation();
            int b = tempPlanet.getYlocation();
            planets[a][b] = tempPlanet;
        }
        
        // This takes out all planets out of range
        inplanets = new PlanetModel[50][50];
        for (int x = 0; x < 50; x++) {
            for (int y = 0; y < 50; y++) {
                if (planets[x][y] != null) {
                    if (playerData.lookupPlanet(planets[x][y].getName())) {
                        //PlanetModel temp2 = playerData.getPlanet
                        //((planets[x][y]
                          //      .getName()));
              
                        planets[x][y] = playerData.getPlanet(planets[x][y]
                                .getName());
                    } else {
                        int xdist = (planets[x][y].getXlocation() 
                                - planets[i][j].getXlocation());
                        int ydist = (planets[x][y].getYlocation() 
                                - planets[i][j].getYlocation());
                        int dist = (int) Math.sqrt((xdist * xdist) 
                                + (ydist * ydist));
             
                        int travel = (fuel / 4);
                        if (travel - dist >= 0) {
                            
                            inplanets[x][y] = planets[x][y];
                        } else { //remove planets we haven't been to and not
      
                            planets[x][y] = null;              // in range
                        }
                    }
                } 
            }
        }
        
    }
    
    /**
     * Renders the picture
     * @param g  Graphics2D
     */
    public void render(Graphics2D g) {
        
        Font oldFont = g.getFont();
        font = oldFont.deriveFont(16.0f);
        g.drawImage(bg, 0, 20, board);
        g.drawImage(button[arm1], 550, 520, board);
        g.drawImage(button[arm2], 660, 520, board);
        
        
        g.setColor(Color.yellow);
        
        //g.drawOval((i * 10) - 240, (j * 10) - 220, 500 , 500);
        //g.drawOval((i * 10) + 10, (j * 10) + 30, 20, 20);
        
        /** draw the planets */
        for (int k = 0; k < 50; k++) {
            for (int l = 0; l < 50; l++) {
                if (planets[k][l] != null) {
                    if (planets[k][l].getName().equals(board.getCurrentplanet()
                            .getName())) {
                        g.setColor(Color.RED);
                    } else {
                        g.setColor(Color.GREEN);
                    }
                    
                    g.fillOval((k * 10) + 15, (l * 10) + 35, 10, 10);
                    g.drawOval(selX, selY + 20, 20, 20);
                }    
                if (inplanets[k][l] != null) {   
                    g.setColor(Color.WHITE);
                    g.fillOval((k * 10) + 15, (l * 10) + 35, 10, 10);
                }
            }
        }
        
        
        
        g.setFont(font);
        g.setColor(Color.YELLOW);
        g.drawString(planetName, 550, 80);
        g.drawString("Gov: " + planetGov, 550, 110);
        g.drawString("Tech: " + planetTech, 550, 140);
        g.drawString(ships[0], 550, 180);
        g.drawString(ships[1], 550, 200);
        g.drawString(ships[2], 550, 220);
        
        int a = 260;
        for (int x = 0; x < 8; x++) {
            g.drawString(text[x], 550, a);
            g.drawString("B:" + prices[(x * 2)], 625, a);
            g.drawString("S: " + prices[(x * 2) + 1], 700, a);
            a += 30;
        }
        
        g.setFont(oldFont.deriveFont(32.0f));
        g.drawString("WARP", 560, 555);
        g.drawString("PORT", 670, 555);
        g.setFont(oldFont);
        board.chatRender(g, 0, 530, 3);
        g.drawString(msg, 10, 605);
    }
    
    /**
     * The mouse Pressed button
     * @param e MouseEvnet
     */
    public void mousePressed(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();

        
        if (x > 550 && x < 645 && y > 520 && y < 565) {
            arm1 = 1;
        } else if (x > 660 && x < 755 && y > 520 && y < 565) {
            arm2 = 1;
        }
    }
    
    /**
     * handles mouse clicked events
     * @param e  MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
        int x = e.getX();
        int y = e.getY();
        
        if (x > 5 && x < 510 && y > 15 && y < 535) {
            int xr = round(x - 20);
            int yr = round(y - 40);
            if (xr < 0) {
                xr = 0;
            }
            if (yr < 0) {
                yr = 0;
            }
            if (planets[xr / 10][yr / 10] != null) {
                int iprime = xr / 10; int jprime = yr / 10;
                planetName = planets[iprime][jprime].getName();
                planetGov = planets[iprime][jprime].getGovType();
                planetTech = planets[iprime][jprime].getTechLevel();
                ships[0] = "Police: " + planets[iprime][jprime].getPolice();
                ships[1] = "Merchants: " + planets[iprime][jprime]
                                                           .getMerchant();
                ships[2] = "Pirates:" + planets[iprime][jprime].getPirate();
                planets[iprime][jprime].setPrices();
                prices = planets[iprime][jprime].getPrices();
                selX = xr + 10;
                selY = yr + 10;
            }
            
        }
        
        
        if (x > 550 && x < 645 && y > 520 && y < 565 && arm1 == 1) {
            
        
            int xdist = curPlanet.getXlocation() 
                        - planets[(selX - 10) / 10][(selY - 10) 
                                                    / 10].getXlocation();
            int ydist = curPlanet.getYlocation() 
                    - planets[(selX - 10) / 10][(selY - 10) / 10]
                                                .getYlocation();
            int dist = (int) Math.sqrt((xdist * xdist) 
                    + (ydist * ydist));
                
            int travel = (fuel / 4);
            if (dist == 0) {
                main.displayMessage("You're already there");
            } else if (travel - dist > 0) {
                main.getConnection().sendMessage("PLANETDATA~" + planetName
                    + "~f");
            } else {
                main.displayMessage("OUT OF RANGE");
            }
        } else if (x > 660 && x < 755 && y > 520 && y < 565 && arm2 == 1) {
            board.switchWindow(MainGui.PORT_WINDOW);
        }
        arm1 = 0;
        arm2 = 0;
    }
    
    /**
     * It rounds the given value to nearest ten
     * @param value the value to round
     * @return the rounded value
     */
    public int round(int value) {
        int temp = value;
        if (temp % 10 <= 5) {
            temp -= (temp % 10);
        } else {
            temp += (10 - temp % 10);
        }
        return temp;
    }
    
    /**
     * handles keypresses
     * 
     * @param e
     *            KeyEvent
     */
    public void keyReleased(KeyEvent e) {
        if (e.getKeyCode() == 8) {
            if (msg.length() > 1) {
                msg = msg.substring(0, msg.length() - 1);
            }
        }
    }
    
    /**
     * handles key typed events
     * 
     * @param e
     *            KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == '\n' && msg.length() > 2) {
            //board.addMsg(msg);
            main.getConnection().sendMessage("MAINMSG~" + msg);
            msg = ": ";
            
        } else if (e.getKeyChar() != '\b') {
            if (msg.length() < 60) {
                msg = msg + e.getKeyChar();
            }
        }
    }
    /**
     * @return Returns the arm1.
     */
    public int getArm1() {
        return arm1;
    }
    /**
     * @param arm1 The arm1 to set.
     */
    public void setArm1(int arm1) {
        this.arm1 = arm1;
    }
    /**
     * @return Returns the arm2.
     */
    public int getArm2() {
        return arm2;
    }
    /**
     * @param arm2 The arm2 to set.
     */
    public void setArm2(int arm2) {
        this.arm2 = arm2;
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @param bg The bg to set.
     */
    public void setBg(Image bg) {
        this.bg = bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @param board The board to set.
     */
    public void setBoard(MainGui board) {
        this.board = board;
    }
    /**
     * @return Returns the button.
     */
    public Image[] getButton() {
        return button;
    }
    /**
     * @param button The button to set.
     */
    public void setButton(Image[] button) {
        this.button = button;
    }
    /**
     * @return Returns the curPlanet.
     */
    public PlanetModel getCurPlanet() {
        return curPlanet;
    }
    /**
     * @param curPlanet The curPlanet to set.
     */
    public void setCurPlanet(PlanetModel curPlanet) {
        this.curPlanet = curPlanet;
    }
    /**
     * @return Returns the font.
     */
    public Font getFont() {
        return font;
    }
    /**
     * @param font The font to set.
     */
    public void setFont(Font font) {
        this.font = font;
    }
    /**
     * @return Returns the fuel.
     */
    public int getFuel() {
        return fuel;
    }
    /**
     * @param fuel The fuel to set.
     */
    public void setFuel(int fuel) {
        this.fuel = fuel;
    }
    /**
     * @return Returns the i.
     */
    public int getI() {
        return i;
    }
    /**
     * @param i The i to set.
     */
    public void setI(int i) {
        this.i = i;
    }
    /**
     * @return Returns the inplanets.
     */
    public PlanetModel[][] getInplanets() {
        return inplanets;
    }
    /**
     * @param inplanets The inplanets to set.
     */
    public void setInplanets(PlanetModel[][] inplanets) {
        this.inplanets = inplanets;
    }
    /**
     * @return Returns the j.
     */
    public int getJ() {
        return j;
    }
    /**
     * @param j The j to set.
     */
    public void setJ(int j) {
        this.j = j;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @param main The main to set.
     */
    public void setMain(MainClass main) {
        this.main = main;
    }
    /**
     * @return Returns the msg.
     */
    public String getMsg() {
        return msg;
    }
    /**
     * @param msg The msg to set.
     */
    public void setMsg(String msg) {
        this.msg = msg;
    }
    /**
     * @return Returns the planetGov.
     */
    public String getPlanetGov() {
        return planetGov;
    }
    /**
     * @param planetGov The planetGov to set.
     */
    public void setPlanetGov(String planetGov) {
        this.planetGov = planetGov;
    }
    /**
     * @return Returns the planetName.
     */
    public String getPlanetName() {
        return planetName;
    }
    /**
     * @param planetName The planetName to set.
     */
    public void setPlanetName(String planetName) {
        this.planetName = planetName;
    }
    /**
     * @return Returns the planets.
     */
    public PlanetModel[][] getPlanets() {
        return planets;
    }
    /**
     * @param planets The planets to set.
     */
    public void setPlanets(PlanetModel[][] planets) {
        this.planets = planets;
    }
    /**
     * @return Returns the planetTech.
     */
    public String getPlanetTech() {
        return planetTech;
    }
    /**
     * @param planetTech The planetTech to set.
     */
    public void setPlanetTech(String planetTech) {
        this.planetTech = planetTech;
    }
    /**
     * @return Returns the playerData.
     */
    public PlayerData getPlayerData() {
        return playerData;
    }
    /**
     * @param playerData The playerData to set.
     */
    public void setPlayerData(PlayerData playerData) {
        this.playerData = playerData;
    }
    /**
     * @return Returns the selX.
     */
    public int getSelX() {
        return selX;
    }
    /**
     * @param selX The selX to set.
     */
    public void setSelX(int selX) {
        this.selX = selX;
    }
    /**
     * @return Returns the selY.
     */
    public int getSelY() {
        return selY;
    }
    /**
     * @param selY The selY to set.
     */
    public void setSelY(int selY) {
        this.selY = selY;
    }
}
