/*
 * Created on Apr 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.gui;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.RoundRectangle2D;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.client.clientdata.PlayerData;

/**
 * @author thaile Draws the connect to server screen
 */
public class ConnectRender extends GuiRender {
    /** reference to the control class     */
    private MainClass main;
    /** reference to the main gui     */
    private MainGui board;

    /** the image itself     */
    private Image bg;
    /** Image buttons */
    private Image[] button = new Image[2];
    /** The name of the player */
    private String name;
    /** string password     */
    private String password;

    /**  String text */
    private String[] text = {"NAME:", "PASSWORD:", "LOGIN", 
            "NEW GAME", "CANCEL"};
    
    /**private String output */
    private String[] output = new String[2];
    /** the selected field     */
    private int selected;
    /** the armed button */
    private int[] arm = new int[3];

    
    /** the carret timer */
    private long timer;
    /** FLAG: display the carot or not */
    private boolean displayCarot;
    
    /** Under transpancy */
    private RoundRectangle2D under;
    /** Selected button stokes */
    private BasicStroke dashbox;
    /**
     * Constructor
     * 
     * @param board MainGui
     * @param main MainClass
     */
    public ConnectRender(MainGui board, MainClass main) {
        this.board = board;
        this.main = main;
        setWindowNumber(2);
        //Loading images here
        
        bg = (new ImageIcon("pics/bg1.jpg")).getImage();
        button[0] = (new ImageIcon("pics/bbutton.png")).getImage();
        button[1] = (new ImageIcon("pics/bbuttonArm.png")).getImage();
        float[] dash = {2, 3};
        dashbox = new BasicStroke(1.0f, BasicStroke.CAP_SQUARE, 
                BasicStroke.JOIN_BEVEL, 45.0f, dash, 0.0f);
        under = new RoundRectangle2D.Double(250, 150, 300, 400, 20, 20);
        
        //loading fonts and setting up strings
        selected = 0;
        name = "";
        password = "";

        output[0] = text[0] + name + "|";
        output[1] = text[1] + password;
        displayCarot = true;
        timer = 300;
        arm[0] = 0;
        arm[1] = 0;
        arm[2] = 0;
    }

    /**
     * Controls changes base on time
     * @param delta the time elapse
     */
    public void change(long delta) {
        timer -= delta;
        if (timer <= 0) {
            if (displayCarot) {
                displayCarot = false;
            } else {
                displayCarot = true;
            }
            timer = 300 + timer;
        }
    }
    /**
     * Renders the login window
     * 
     * @param g the graphic context
     */
    public void render(Graphics2D g) {
        g.setFont(g.getFont().deriveFont(24.0f));
        
        g.drawImage(bg, 0, 20, board);

        g.setColor(new Color(21, 113, 23));
        int rule = AlphaComposite.SRC_OVER;
        
        g.setComposite(AlphaComposite.getInstance(rule, .6f));
        g.fill(under);
        
        g.setComposite(AlphaComposite.getInstance(rule, 1.0f));
        g.setColor(Color.white);
        output[0] = text[0] + name;
        output[1] = text[1] + password;
        
        if (displayCarot && selected == 0) {
            output[0] += "|";
        } else if (displayCarot && selected == 1) {
            output[1] += "|";
        }
        
        g.drawString(output[0], 260, 232);
        g.drawString(output[1], 260, 292);

        int i = 0;
        for (int y = 350; y <= 430; y += 40) {
            g.drawImage(button[arm[i]], 260, y, board);
            g.drawString(text[i + 2], 270, y + 25);
            i++;
        }
        
        if (selected == 2) {
            g.setStroke(dashbox);
            g.drawRect(265, 355, 115, 25);
        } else if (selected == 3) {
            g.setStroke(dashbox);
            g.drawRect(265, 395, 115, 25);
        } else if (selected == 4) {
            g.setStroke(dashbox);
            g.drawRect(265, 435, 115, 25);
        }
    }

    /**
     * Mouse pressed handler
     * @param e MouseEvent
     */
    public void mousePressed(MouseEvent e) {
        if (e.getX() > 260 && e.getX() < 385) {
            if (e.getY() > 350 && e.getY() < 385) { //login
                arm[0] = 1;
            } else if (e.getY() > 390 && e.getY() < 425) { //cancel
                arm[1] = 1;
            } else if (e.getY() > 430 && e.getY() < 465) {
                arm[2] = 1;
            }
        }
    }
    /**
     * Mouse Click handler
     * @param e MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
        System.out.println("x:" + e.getX() + " y:" + e.getY());
        if (e.getX() > 260 && e.getX() < 385) {
            if (e.getY() > 350 && e.getY() < 385 && arm[0] == 1) { //ok
                PlayerData data = board.getPlayerData();
                data.setName(name);
                data.setPass(password);
                board.setPlayerData(data);
                main.startGame(name, password);
            } else if (e.getY() > 390 && e.getY() < 425  //new player
                    && arm[1] == 1) { 
                board.switchWindow(3);
            } else if (e.getY() > 430 && e.getY() < 465
                    && arm[2] == 1) { //cancel
                main.getConnection().shutdownClient();
                board.switchWindow(0);        
            }
        }

        arm[0] = 0;
        arm[1] = 0;
        arm[2] = 0;
        if (e.getX() > 260 && e.getX() < (350 + (15 * name.length()))
                && e.getY() > 205 && e.getY() < 245) {
            selected = 0;
        } else if (e.getX() > 260 && e.getX() < (400 + (15 * password.length()))
                && e.getY() > 265 && e.getY() < 305) {
            selected = 1;
        }
    }

    
    /**
     * handler key presses
     * @param e KeyEvent
     */
    public void keyReleased(KeyEvent e) {
        if (e.getKeyCode() == 8) { //backspace
            removeChar();
        } else if (e.getKeyCode() == 9) {
            selected = (selected + 1) % 5;
        } else if (e.getKeyCode() == 27) { //esc
            board.switchWindow(0);
        }

    }

    /**
     * Handles keyTyped events
     * 
     * @param e
     *            KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == '\n' || e.getKeyChar() == ' ') {
            if (selected == 4) {
                board.switchWindow(MainGui.LOGIN_WINDOW);
            } else if (selected == 3) {
                board.switchWindow(MainGui.CREATE_WINDOW);
            } else {
                PlayerData data = board.getPlayerData();
                data.setName(name);
                data.setPass(password);
                board.setPlayerData(data);
                main.startGame(name, password);
            }
        } else if (e.getKeyChar() != KeyEvent.VK_ESCAPE
                && e.getKeyChar() != '\b' && e.getKeyChar() != '\t') {
            addChar(e.getKeyChar());
        }
    }

    /**
     * adds a char to msg string
     * 
     * @param c
     *            char
     */
    private void addChar(char c) {

        switch (selected) {
        case 0:
            name += c;
            break;
        case 1:
            password += c;
            break;
        default:
        }
    }

    /**
     * Removes a char from msg string
     */
    private void removeChar() {
        switch (selected) {
        case 0:
            if (name.length() > 0) {
                name = name.substring(0, name.length() - 1);
            }
            break;
        case 1:
            if (password.length() > 0) {
                password = password.substring(0, password.length() - 1);
            }
            break;
        default:
        }
    }
    
    
    /**
     * This sets the username and password
     * @param username new username
     * @param pass new password
     */
    public void setUser(String username, String pass) {
        this.name = username;
        this.password = pass;
        selected = 2;
    }   
    /**
     * @return Returns the arm.
     */
    public int[] getArm() {
        return arm;
    }
    /**
     * @param arm The arm to set.
     */
    public void setArm(int[] arm) {
        this.arm = arm;
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @param bg The bg to set.
     */
    public void setBg(Image bg) {
        this.bg = bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @param board The board to set.
     */
    public void setBoard(MainGui board) {
        this.board = board;
    }
    /**
     * @return Returns the button.
     */
    public Image[] getButton() {
        return button;
    }
    /**
     * @param button The button to set.
     */
    public void setButton(Image[] button) {
        this.button = button;
    }
    /**
     * @return Returns the dashbox.
     */
    public BasicStroke getDashbox() {
        return dashbox;
    }
    /**
     * @param dashbox The dashbox to set.
     */
    public void setDashbox(BasicStroke dashbox) {
        this.dashbox = dashbox;
    }
    /**
     * @return Returns the displayCarot.
     */
    public boolean isDisplayCarot() {
        return displayCarot;
    }
    /**
     * @param displayCarot The displayCarot to set.
     */
    public void setDisplayCarot(boolean displayCarot) {
        this.displayCarot = displayCarot;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @param main The main to set.
     */
    public void setMain(MainClass main) {
        this.main = main;
    }
    /**
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }
    /**
     * @param name The name to set.
     */
    public void setName(String name) {
        this.name = name;
    }
    /**
     * @return Returns the output.
     */
    public String[] getOutput() {
        return output;
    }
    /**
     * @param output The output to set.
     */
    public void setOutput(String[] output) {
        this.output = output;
    }
    /**
     * @return Returns the password.
     */
    public String getPassword() {
        return password;
    }
    /**
     * @param password The password to set.
     */
    public void setPassword(String password) {
        this.password = password;
    }
    /**
     * @return Returns the selected.
     */
    public int getSelected() {
        return selected;
    }
    /**
     * @param selected The selected to set.
     */
    public void setSelected(int selected) {
        this.selected = selected;
    }
    /**
     * @return Returns the text.
     */
    public String[] getText() {
        return text;
    }
    /**
     * @param text The text to set.
     */
    public void setText(String[] text) {
        this.text = text;
    }
    /**
     * @return Returns the timer.
     */
    public long getTimer() {
        return timer;
    }
    /**
     * @param timer The timer to set.
     */
    public void setTimer(long timer) {
        this.timer = timer;
    }
    /**
     * @return Returns the under.
     */
    public RoundRectangle2D getUnder() {
        return under;
    }
    /**
     * @param under The under to set.
     */
    public void setUnder(RoundRectangle2D under) {
        this.under = under;
    }
}