/*
 * Created on Apr 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontFormatException;
import java.awt.Graphics2D;
import java.awt.Image;
//import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import javax.swing.ImageIcon;

/**
 * @author macguy <p/>TODO To change the template for this generated type
 *         comment go to Window - Preferences - Java - Code Style - Code
 *         Templates
 */
public class ErrorDialog extends GuiRender {
    /** the mainGui to draw to */
    private MainGui board;

    /** msg to be displayed */
    private String[] msg = {"" };

    /** title to display */
    private String title = "";

    /** the old window listener to load again */
    private int oldWindow;

    /** the back ground pick to draw */
    private Image bg;

    /** the button image */
    private Image[] button = new Image[2];

    /** FLAG: if the button is armed or not */
    private int armed;

    /** the font to use */
    private Font font;

    /**
     * Constructor
     * 
     * @param board
     *            MainGui
     */
    public ErrorDialog(MainGui board) {
        this.board = board;
        setWindowNumber(15);
        //Toolkit tk = Toolkit.getDefaultToolkit();

        bg = (new ImageIcon("pics/errorBox.png")).getImage();
        button[0] = (new ImageIcon("pics/bbutton.png")).getImage();
        button[1] = (new ImageIcon("pics/bbuttonArm.png")).getImage();
        armed = 0;

        try {
            File tempfont = new File("fonts/Lucida_Console.ttf");
            FileInputStream readFile = new FileInputStream(tempfont);
            Font tempFont = Font.createFont(Font.TRUETYPE_FONT, readFile);
            font = tempFont.deriveFont(12.0f);
        } catch (FileNotFoundException e) {
            System.out.println("font not found");
        } catch (FontFormatException e) {
            System.out.println("font not formatted");
        } catch (IOException e) {
            System.out.println("error reading in font");
        }
    }

    /**
     * The text to be displayed
     * 
     * @param titl
     *            the title to display
     * @param text
     *            the text to display
     */
    public void setText(String titl, String[] text) {

        if (title == null) {
            title = "";
        } else {
            this.title = titl;
        }
        if (text == null) {
            String[] temp = {"" };
            msg = temp;
        } else {
            msg = text;
        }
    }

    /**
     * This switches back to the old window
     * 
     * @param window
     *            The window to switch to
     */
    public void setOldWindow(int window) {
        oldWindow = window;
    }

    /**
     * This returns the old window
     * 
     * @return the old window
     */
    public int getOldWindow() {
        return oldWindow;
    }

    /**
     * Renders the error box
     * 
     * @param g
     *            Graphics2D
     */
    public void render(Graphics2D g) {
        Font oldFont = g.getFont();
        g.setFont(font);
        g.setColor(Color.white);
        g.drawImage(bg, 250, 200, board);
        
        g.drawString(title, 400 - ((title.length() * 7) / 2), 225);
        for (int i = 0; i < msg.length; i++) {
            g.drawString(msg[i], 265, 255 + (i * 20));
        }
        
        g.setFont(oldFont.deriveFont(32.0f));
        g.drawImage(button[armed], 340, 355, board);
        g.drawString("OK", 385, 382);
        g.setFont(oldFont);
    }

    /**
     * key type
     * 
     * @param e
     *            KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == '\n' || e.getKeyChar() == ' ') { //enter key
            board.closeErrorBox();
            board.getPortwindow().setMessagedisplaying(false);
        }
    }

    /**
     * handles mouse presses
     * 
     * @param e
     *            MouseEvent
     */
    public void mousePressed(MouseEvent e) {

        if (e.getX() > 350 && e.getY() < 450 && e.getY() > 360
                && e.getY() < 390) {
            armed = 1;
        }
    }

    /**
     * mouse handler
     * 
     * @param e
     *            MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
        armed = 0;
        if (e.getX() > 350 && e.getY() < 450 && e.getY() > 360
                && e.getY() < 390) {
            board.closeErrorBox();
            board.getPortwindow().setMessagedisplaying(false);
        }
    }
    
    /**
     * @return Returns the armed.
     */
    public int getArmed() {
        return armed;
    }
    /**
     * @param armed The armed to set.
     */
    public void setArmed(int armed) {
        this.armed = armed;
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @param bg The bg to set.
     */
    public void setBg(Image bg) {
        this.bg = bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @param board The board to set.
     */
    public void setBoard(MainGui board) {
        this.board = board;
    }
    /**
     * @return Returns the button.
     */
    public Image[] getButton() {
        return button;
    }
    /**
     * @param button The button to set.
     */
    public void setButton(Image[] button) {
        this.button = button;
    }
    /**
     * @return Returns the font.
     */
    public Font getFont() {
        return font;
    }
    /**
     * @param font The font to set.
     */
    public void setFont(Font font) {
        this.font = font;
    }
    /**
     * @return Returns the msg.
     */
    public String[] getMsg() {
        return msg;
    }
    /**
     * @param msg The msg to set.
     */
    public void setMsg(String[] msg) {
        this.msg = msg;
    }
    /**
     * @return Returns the title.
     */
    public String getTitle() {
        return title;
    }
    /**
     * @param title The title to set.
     */
    public void setTitle(String title) {
        this.title = title;
    }
}