/*
 * Created on Apr 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.gui;

import java.awt.AlphaComposite;
import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.geom.RoundRectangle2D;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.client.clientdata.PlayerData;

/**
 * @author thaile <p/>TODO To change the template for this generated type
 *         comment go to Window - Preferences - Java - Code Style - Code
 *         Templates
 */
public class LoginRender extends GuiRender {
    /** reference to the control class     */
    private MainClass main;
    /** reference to the main gui     */
    private MainGui board;
    /** the image itself     */
    private Image bg;
    /** Image buttons */
    private Image[] button = new Image[2];
    /**String text */
    private String[] text = {"HOST:" , "PORT NUM:", "CONNECT", "CANCEL"};
    /** string host     */
    private String host;
    /** string port     */
    private String port;
    /**private String output */
    private String[] output = new String[2];
    /** the selected field     */
    private int selected;
    /** the armed button */
    private int[] arm = new int[2];

    
    /** the carret timer */
    private long timer;
    /** FLAG: display the carot or not */
    private boolean displayCarot;
    
    /** Under transpancy */
    private RoundRectangle2D under;
    /** Selected button stokes */
    private BasicStroke dashbox;
    /**
     * Constructor
     * 
     * @param board MainGui
     * @param main MainClass
     */
    public LoginRender(MainGui board, MainClass main) {
        this.board = board;
        this.main = main;
        setWindowNumber(1);
        //Loading images here
        
        bg = (new ImageIcon("pics/bg1.jpg")).getImage();
        button[0] = (new ImageIcon("pics/bbutton.png")).getImage();
        button[1] = (new ImageIcon("pics/bbuttonArm.png")).getImage();
        float[] dash = {2, 3};
        dashbox = new BasicStroke(1.0f, BasicStroke.CAP_SQUARE, 
                BasicStroke.JOIN_BEVEL, 45.0f, dash, 0.0f);
        under = new RoundRectangle2D.Double(250, 150, 300, 400, 20, 20);
        
        //loading fonts and setting up strings
        selected = 0;
        host = "localhost";
        port = "30303";

        output[0] = text[0] + host + "|";
        output[1] = text[1] + port;
        displayCarot = true;
        timer = 300;
        arm[0] = 0;
        arm[1] = 0;
    }

    /**
     * Controls changes base on time
     * @param delta the time elapse
     */
    public void change(long delta) {
        timer -= delta;
        if (timer <= 0) {
            if (displayCarot) {
                displayCarot = false;
            } else {
                displayCarot = true;
            }
            timer = 300 + timer;
        }
    }
    /**
     * Renders the login window
     * 
     * @param g the graphic context
     */
    public void render(Graphics2D g) {
        g.setFont(g.getFont().deriveFont(24.0f));
        
        g.drawImage(bg, 0, 20, board);

        g.setColor(new Color(21, 113, 23));
        int rule = AlphaComposite.SRC_OVER;
        
        g.setComposite(AlphaComposite.getInstance(rule, .6f));
        g.fill(under);
        
        g.setComposite(AlphaComposite.getInstance(rule, 1.0f));
        g.setColor(Color.white);
        output[0] = text[0] + host;
        output[1] = text[1] + port;
        
        if (displayCarot && selected == 0) {
            output[0] += "|";
        } else if (displayCarot && selected == 1) {
            output[1] += "|";
        }
        
        g.drawString(output[0], 260, 232);
        g.drawString(output[1], 260, 292);

        int i = 0;
        for (int y = 350; y <= 390; y += 40) {
            g.drawImage(button[arm[i]], 260, y, board);
            g.drawString(text[i + 2], 275, y + 25);
            i++;
        }
        
        if (selected == 2) {
            g.setStroke(dashbox);
            g.drawRect(265, 355, 115, 25);
        } else if (selected == 3) {
            g.setStroke(dashbox);
            g.drawRect(265, 395, 115, 25);
        }
    }

    /**
     * Setup the host and port names
     * @param newHost host
     * @param newPort port
     */
    public void setUp(String newHost, String newPort) {
        this.host = newHost;
        this.port = newPort;
    }
    
    
    /**
     * Mouse pressed handler
     * @param e MouseEvent
     */
    public void mousePressed(MouseEvent e) {
        if (e.getX() > 260 && e.getX() < 385) {
            if (e.getY() > 350 && e.getY() < 385) { //login
                arm[0] = 1;
            } else if (e.getY() > 390 && e.getY() < 425) { //cancel
                arm[1] = 1;
            }
        }
    }
    
    /**
     * Mouse Click handler
     * @param e MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
        System.out.println("x:" + e.getX() + " y:" + e.getY());
        if (e.getX() > 260 && e.getX() < 385) {
            if (e.getY() > 350 && e.getY() < 385 && arm[0] == 1) { //login
                System.out.println("LOGIN_RENDER:Logging into the server...");
                int result = main.loginPlayer(host, port);
                if (result == 0) {
                    board.switchWindow(2);
                    PlayerData data = board.getPlayerData();
                    data.setHost(host);
                    data.setPort(port);
                    board.setPlayerData(data);
                }
            } else if (e.getY() > 390 && e.getY() < 425 
                    && arm[1] == 1) { //cancel
                board.switchWindow(0);
            }
        }

        arm[0] = 0;
        arm[1] = 0;
        if (e.getX() > 260 && e.getX() < (350 + (15 * host.length()))
                && e.getY() > 205 && e.getY() < 245) {
            selected = 0;
        } else if (e.getX() > 260 && e.getX() < (400 + (15 * port.length()))
                && e.getY() > 265 && e.getY() < 305) {
            selected = 1;
        }
    }

    
    /**
     * handler key presses
     * @param e KeyEvent
     */
    public void keyReleased(KeyEvent e) {
        if (e.getKeyCode() == 8) { //backspace
            removeChar();
        } else if (e.getKeyCode() == 9) {
            selected = (selected + 1) % 4;
        } else if (e.getKeyCode() == 27) { //esc
            board.switchWindow(0);
        }

    }

    /**
     * Handles keyTyped events
     * 
     * @param e
     *            KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == '\n' || e.getKeyChar() == ' ') {
            if (selected == 3) {
                board.switchWindow(MainGui.START_WINDOW);
            } else {
            
                System.out.println("LOGIN_RENDER:Logging into the server...");
                int result = main.loginPlayer(host, port);
                if (result == 0) {
                    board.switchWindow(2);
                    PlayerData data = board.getPlayerData();
                    data.setHost(host);
                    data.setPort(port);
                    board.setPlayerData(data);
                    
                }
            }
        } else if (e.getKeyChar() != KeyEvent.VK_ESCAPE
                && e.getKeyChar() != '\b' && e.getKeyChar() != '\t') {
            addChar(e.getKeyChar());
        }
    }

    /**
     * adds a char to msg string
     * 
     * @param c
     *            char
     */
    private void addChar(char c) {

        switch (selected) {
        case 0:
            host += c;
            break;
        case 1:
            port += c;
            break;
        default:
        }
    }

    /**
     * Removes a char from msg string
     */
    private void removeChar() {
        switch (selected) {
        case 0:
            if (host.length() > 0) {
                host = host.substring(0, host.length() - 1);
            }
            break;
        case 1:
            if (port.length() > 0) {
                port = port.substring(0, port.length() - 1);
            }
            break;
        default:
        }
    }
    /**
     * @return Returns the arm.
     */
    public int[] getArm() {
        return arm;
    }
    /**
     * @param arm The arm to set.
     */
    public void setArm(int[] arm) {
        this.arm = arm;
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @param bg The bg to set.
     */
    public void setBg(Image bg) {
        this.bg = bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @param board The board to set.
     */
    public void setBoard(MainGui board) {
        this.board = board;
    }
    /**
     * @return Returns the button.
     */
    public Image[] getButton() {
        return button;
    }
    /**
     * @param button The button to set.
     */
    public void setButton(Image[] button) {
        this.button = button;
    }
    /**
     * @return Returns the dashbox.
     */
    public BasicStroke getDashbox() {
        return dashbox;
    }
    /**
     * @param dashbox The dashbox to set.
     */
    public void setDashbox(BasicStroke dashbox) {
        this.dashbox = dashbox;
    }
    /**
     * @return Returns the displayCarot.
     */
    public boolean isDisplayCarot() {
        return displayCarot;
    }
    /**
     * @param displayCarot The displayCarot to set.
     */
    public void setDisplayCarot(boolean displayCarot) {
        this.displayCarot = displayCarot;
    }
    /**
     * @return Returns the host.
     */
    public String getHost() {
        return host;
    }
    /**
     * @param host The host to set.
     */
    public void setHost(String host) {
        this.host = host;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @param main The main to set.
     */
    public void setMain(MainClass main) {
        this.main = main;
    }
    /**
     * @return Returns the output.
     */
    public String[] getOutput() {
        return output;
    }
    /**
     * @param output The output to set.
     */
    public void setOutput(String[] output) {
        this.output = output;
    }
    /**
     * @return Returns the port.
     */
    public String getPort() {
        return port;
    }
    /**
     * @param port The port to set.
     */
    public void setPort(String port) {
        this.port = port;
    }
    /**
     * @return Returns the selected.
     */
    public int getSelected() {
        return selected;
    }
    /**
     * @param selected The selected to set.
     */
    public void setSelected(int selected) {
        this.selected = selected;
    }
    /**
     * @return Returns the text.
     */
    public String[] getText() {
        return text;
    }
    /**
     * @param text The text to set.
     */
    public void setText(String[] text) {
        this.text = text;
    }
    /**
     * @return Returns the timer.
     */
    public long getTimer() {
        return timer;
    }
    /**
     * @param timer The timer to set.
     */
    public void setTimer(long timer) {
        this.timer = timer;
    }
    /**
     * @return Returns the under.
     */
    public RoundRectangle2D getUnder() {
        return under;
    }
    /**
     * @param under The under to set.
     */
    public void setUnder(RoundRectangle2D under) {
        this.under = under;
    }
}