/*
 * Created on Apr 27, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.gui;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.client.clientdata.ApproachData;
import edu.cs2335.SWATLP.client.spacegame.PlayerShip;

/**
 * @author thaile
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class LunarRender extends GuiRender {
    /** The main gui */
    private MainGui board;
    /** the main class */
    private MainClass main;
    /** the approach data */
    private ApproachData data; 
    /** the player data */
    private PlayerShip player;
    
    /** the land */
    private int[] land = new int[800];
    
    /** the pic of the ship to use */
    private Image ship;
    /** the background pic */
    private Image bg;
    /** the current x position of the ship */
    private float x;
    /** the current y position of the ship */
    private float y;
    
    //boost of pressing a button */
    /** boost accent power */
    private float uboost = 3.0f; //meter per sec?
    /** side booster power */
    private float sboost = 1.0f; //meter per sec
    /** max ascent speed */
    private float maxuSpeed = 15f; //meter per sec
    /** max side speed */
    private float maxsSpeed = 5f; //meter per sec
    /** The current ascent speed */
    private float curuSpeed;
    /** the current side speed */
    private float cursSpeed;
    
    //button pressed? */
    /** up pressed */
    private boolean up;
    /** left pressed */
    private boolean left;
    /** right pressed */
    private boolean right;
    /** not landed */
    private boolean notLanded;
    /** your current fuel */
    private float fuel;
    /** your max fuel */
    private int maxfuel;
    /** your current hit */
    private float hit; 
    /** your max health */
    private int maxhit;
    /** the start point of the landing zone */
    private int landingZone;
    /** the lowest point in the landing zone */
    private int lowest;
    /** the landing pad pic */
    private Image pad;
    /**
     * Constructer
     * @param board MainGui
     * @param main MainClass
     */
    public LunarRender(MainGui board, MainClass main) {
        this.board = board;
        this.main = main;
        bg = (new ImageIcon("pics/lander.jpg")).getImage();
        pad = (new ImageIcon("pics/landingPad.png")).getImage();
    }
    
    /**
     * Setups the lander
     * @param ndata the ship to use
     * @param nplayer PlayerShip
     */
    public void setupLander(ApproachData ndata, PlayerShip nplayer) {
        this.data = ndata;
        this.player = nplayer;
        x = 30;
        y = 30;
        curuSpeed = 0;
        cursSpeed = 0;
        up = false;
        left = false;
        right = false;
        notLanded = true;
        
        fuel = data.getFuelCurrent();
        hit = data.getHitpointsCurrent();
        maxfuel = data.getFuelMax();
        maxhit = data.getHitpointsMax();
        
        int a = 100;
        for (int i = 0; i < 800; i++) {
            int g = (int) (Math.random() * 50);
            //System.out.println(g);
            if (g > 25) {
                land[i] = (int) a + 1;
                a = land[i];
            } else {
                land[i] = (int) a - 1;
                a = land[i];    
            }
        }
        
        landingZone = (int) (Math.random() * 750);
        //System.out.println("landingZone " + landingZone);
        int highest = 0;
        lowest = 620;
        for (int i = landingZone; i < landingZone + 50; i++) {
            if (land[i] > highest) {
                highest = land[i];
            }
            if (land[i] < lowest) {
                lowest = land[i];
            }
        }
        for (int i = landingZone; i < landingZone + 50; i++) {
            land[i] = highest;
        }
        //System.out.println(highest);
        
        ship = player.getImage();
        
    }
    
    /**
     * Draws the picture 
     * @param g Graphics2D
     */
    public void render(Graphics2D g) {
        g.drawImage(bg, 0, 20, board);
        
        g.setColor(Color.BLUE);
        g.fillRoundRect(600, 30, maxfuel + 4, 20, 10, 10);
        g.fillRoundRect(600, 60, maxhit + 4, 20, 10, 10);
        
        g.setColor(Color.GREEN);
        g.fillRoundRect(602, 32, (int) fuel, 16, 5, 5);
        g.setColor(Color.RED);
        g.fillRoundRect(602, 62, (int) hit, 16, 5, 5);
        
        g.setColor(new Color(90, 79, 49));
        for (int i = 0; i < 800; i++) {
            g.drawLine(i, 620, i, 620 - land[i]);
        }
        g.setColor(Color.BLACK);
        for (int i = 0; i < 800; i++) {
            g.drawLine(i, 620 - land[i] + 2, i, 620 - land[i]);
        }
        
        g.drawImage(pad, landingZone, 600 - land[landingZone], board);
        g.setColor(Color.BLUE);

        g.drawString("  fuel:" + fuel, 500, 60);
        g.drawString("Energy:" + hit, 500, 80);
        
        g.drawImage(ship, (int) x, (int) y, board);

    }
    
    /**
     * changes the obj position base on time 
     * @param delta elapse time 
     */
    public void change(long delta) {
        if (notLanded) {
        curuSpeed += (delta * 1.5f) / 1000; //subtract gravity
        }
        
        if (up) {
            curuSpeed -= (delta * uboost) / 1000;
            // -.03 + .003*(-2,0,2,6,etc.)
            fuel = fuel - (uboost / 100) + (data.getPiloting() * .003f);
        }
        
        if (left && notLanded) {
            cursSpeed -= (delta * sboost) / 1000;
            // -.01 + .001*(-2,0,2,6,etc.)
            fuel = fuel - (sboost / 100) + (data.getPiloting() * .001f);
        }
        
        if (right && notLanded) {
            cursSpeed += (delta * sboost) / 1000;
            // -.01 + .001*(-2,0,2,6,etc.)
            fuel = fuel - (sboost / 100) + (data.getPiloting() * .001f);
        }
        
        if (fuel < 0) {
            System.out.println("out of fuel");
            data.setFuelCurrent(-1);
            board.updateServer(data, "port", true);
            board.setupPort();
        }
        
        
        if (cursSpeed > maxsSpeed) {
            cursSpeed = maxsSpeed;
        }
        
        if (curuSpeed > maxuSpeed) {
            curuSpeed = maxuSpeed;
        }
        
        x += cursSpeed;
        y += curuSpeed;
        detectCollision();
    }
    
    /**
     * keyPressed
     * @param e KeyEvent
     */
    public void keyPressed(KeyEvent e) {
        if (e.getKeyCode() == 37) {
            left = true;
            right = false;
        } else if (e.getKeyCode() == 38) {
            up = true;
        } else if (e.getKeyCode() == 39) {
            right = true;
            left = false;
        } 
        
    }
    
    /**
     * keyReleased
     * @param e KeyEvent
     */
    public void keyReleased(KeyEvent e) {
        if (e.getKeyCode() == 37) {
            left = false;
        } else if (e.getKeyCode() == 38) {
            up = false;
        } else if (e.getKeyCode() == 39) {
            right = false;
        } 
    }
    
    
    /**
     * Detect Collisions 
     *
     */
    public void detectCollision() {
        if (x < 0) {
            x = 0;
            cursSpeed = -cursSpeed;
        } else if (x > 800 - ship.getWidth(board)) {
            x = 799 - ship.getWidth(board);
            cursSpeed = -cursSpeed;
        }
        if (y < ship.getHeight(board) / 2) {
            y = ship.getHeight(board) / 2;
            curuSpeed = -curuSpeed;
        }
    

        if (land[(int) x] >= (600 - (int) y) - ship.getHeight(board) / 2) {
           /* if (curuSpeed > 0) {
                System.out.println(curuSpeed);
            }*/
            if (curuSpeed > 1) {
                System.out.println("take damage");

                hit -= (curuSpeed - 1) * 20;
                
                
                
                if (hit < 0) {
                    data.setHitpointsCurrent((int) hit);
                    board.updateServer(data, "port", true);
                    board.setupPort();
                }
            }
            
            
            if (x > landingZone && x < landingZone + 50) {
                System.out.println("win");
                data.setHitpointsCurrent((int) hit);
                data.setFuelCurrent((int) fuel);
                board.updateServer(data, "port", true);
                board.setupPort();
            }
            notLanded = false;
            curuSpeed = 0;
            cursSpeed = 0;
        } else {
            notLanded = true;
        }
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @param bg The bg to set.
     */
    public void setBg(Image bg) {
        this.bg = bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @param board The board to set.
     */
    public void setBoard(MainGui board) {
        this.board = board;
    }
    /**
     * @return Returns the cursSpeed.
     */
    public float getCursSpeed() {
        return cursSpeed;
    }
    /**
     * @param cursSpeed The cursSpeed to set.
     */
    public void setCursSpeed(float cursSpeed) {
        this.cursSpeed = cursSpeed;
    }
    /**
     * @return Returns the curuSpeed.
     */
    public float getCuruSpeed() {
        return curuSpeed;
    }
    /**
     * @param curuSpeed The curuSpeed to set.
     */
    public void setCuruSpeed(float curuSpeed) {
        this.curuSpeed = curuSpeed;
    }
    /**
     * @return Returns the data.
     */
    public ApproachData getData() {
        return data;
    }
    /**
     * @param data The data to set.
     */
    public void setData(ApproachData data) {
        this.data = data;
    }
    /**
     * @return Returns the fuel.
     */
    public float getFuel() {
        return fuel;
    }
    /**
     * @param fuel The fuel to set.
     */
    public void setFuel(float fuel) {
        this.fuel = fuel;
    }
    /**
     * @return Returns the hit.
     */
    public float getHit() {
        return hit;
    }
    /**
     * @param hit The hit to set.
     */
    public void setHit(float hit) {
        this.hit = hit;
    }
    /**
     * @return Returns the land.
     */
    public int[] getLand() {
        return land;
    }
    /**
     * @param land The land to set.
     */
    public void setLand(int[] land) {
        this.land = land;
    }
    /**
     * @return Returns the landingZone.
     */
    public int getLandingZone() {
        return landingZone;
    }
    /**
     * @param landingZone The landingZone to set.
     */
    public void setLandingZone(int landingZone) {
        this.landingZone = landingZone;
    }
    /**
     * @return Returns the left.
     */
    public boolean isLeft() {
        return left;
    }
    /**
     * @param left The left to set.
     */
    public void setLeft(boolean left) {
        this.left = left;
    }
    /**
     * @return Returns the lowest.
     */
    public int getLowest() {
        return lowest;
    }
    /**
     * @param lowest The lowest to set.
     */
    public void setLowest(int lowest) {
        this.lowest = lowest;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @param main The main to set.
     */
    public void setMain(MainClass main) {
        this.main = main;
    }
    /**
     * @return Returns the maxfuel.
     */
    public int getMaxfuel() {
        return maxfuel;
    }
    /**
     * @param maxfuel The maxfuel to set.
     */
    public void setMaxfuel(int maxfuel) {
        this.maxfuel = maxfuel;
    }
    /**
     * @return Returns the maxhit.
     */
    public int getMaxhit() {
        return maxhit;
    }
    /**
     * @param maxhit The maxhit to set.
     */
    public void setMaxhit(int maxhit) {
        this.maxhit = maxhit;
    }
    /**
     * @return Returns the maxsSpeed.
     */
    public float getMaxsSpeed() {
        return maxsSpeed;
    }
    /**
     * @param maxsSpeed The maxsSpeed to set.
     */
    public void setMaxsSpeed(float maxsSpeed) {
        this.maxsSpeed = maxsSpeed;
    }
    /**
     * @return Returns the maxuSpeed.
     */
    public float getMaxuSpeed() {
        return maxuSpeed;
    }
    /**
     * @param maxuSpeed The maxuSpeed to set.
     */
    public void setMaxuSpeed(float maxuSpeed) {
        this.maxuSpeed = maxuSpeed;
    }
    /**
     * @return Returns the notLanded.
     */
    public boolean isNotLanded() {
        return notLanded;
    }
    /**
     * @param notLanded The notLanded to set.
     */
    public void setNotLanded(boolean notLanded) {
        this.notLanded = notLanded;
    }
    /**
     * @return Returns the pad.
     */
    public Image getPad() {
        return pad;
    }
    /**
     * @param pad The pad to set.
     */
    public void setPad(Image pad) {
        this.pad = pad;
    }
    /**
     * @return Returns the player.
     */
    public PlayerShip getPlayer() {
        return player;
    }
    /**
     * @param player The player to set.
     */
    public void setPlayer(PlayerShip player) {
        this.player = player;
    }
    /**
     * @return Returns the right.
     */
    public boolean isRight() {
        return right;
    }
    /**
     * @param right The right to set.
     */
    public void setRight(boolean right) {
        this.right = right;
    }
    /**
     * @return Returns the sboost.
     */
    public float getSboost() {
        return sboost;
    }
    /**
     * @param sboost The sboost to set.
     */
    public void setSboost(float sboost) {
        this.sboost = sboost;
    }
    /**
     * @return Returns the ship.
     */
    public Image getShip() {
        return ship;
    }
    /**
     * @param ship The ship to set.
     */
    public void setShip(Image ship) {
        this.ship = ship;
    }
    /**
     * @return Returns the uboost.
     */
    public float getUboost() {
        return uboost;
    }
    /**
     * @param uboost The uboost to set.
     */
    public void setUboost(float uboost) {
        this.uboost = uboost;
    }
    /**
     * @return Returns the up.
     */
    public boolean isUp() {
        return up;
    }
    /**
     * @param up The up to set.
     */
    public void setUp(boolean up) {
        this.up = up;
    }
    /**
     * @return Returns the x.
     */
    public float getX() {
        return x;
    }
    /**
     * @param x The x to set.
     */
    public void setX(float x) {
        this.x = x;
    }
    /**
     * @return Returns the y.
     */
    public float getY() {
        return y;
    }
    /**
     * @param y The y to set.
     */
    public void setY(float y) {
        this.y = y;
    }
}
