package edu.cs2335.SWATLP.client.gui;

import java.awt.AlphaComposite;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.WindowEvent;

import javax.swing.ImageIcon;

/**
 * @author thaile
 */
public class PortRender extends GuiRender {
    /** reference to the main gui */
    private MainGui board;
    /** refernence to main class */
    private MainClass main;

    /** backgroup picture */
    private Image bg;
    /** The toolbar at the bottom */
    private Image bar;
    /** The text of the screen */
    private String[] text = {"BANK", "MARKET", "SCHOOL",
            "WAREHOUSE", "SHIPYARD"};
    /** The buttons */
    private Image[] button = new Image[2];
    /** arm */
    private int arm1;
    /** arm */
    private int arm2;
    /** arm */
    private int arm3;
    
    /** The buttons text */
    private String[] btext = {"SHORT RANGE CHART", "SEND" , "QUIT"};
    
    /** This is the name of the planet */
    private String planet;
    
    /** The selected option */
    private int selected;
    
    /** The current typeing chat msg */
    private String msg;
    /** this is for transparency stuff */
    private int rule = AlphaComposite.SRC_OVER;
    
    /** FLAG: if this is the home planets or not */
    private boolean homePlanet;

    /** current image */
    private int currentImage;
    /** sprite 1 */
    private Image sprite1;
    /** sprite 2 */
    private Image sprite2;
    /** sprite 3 */
    private Image sprite3;
    /** direction */
    private double dirfacing;
    /** message */
    private boolean messagedisplaying;

    /**
     * Constructer
     * 
     * @param board
     *            MainGui
     * @param main
     *            MainClass
     */
    public PortRender(MainGui board, MainClass main) {
        this.board = board;
        this.main = main;
        setWindowNumber(4);
        //Loading images here
        button[0] = (new ImageIcon("pics/bbutton.png")).getImage();
        button[1] = (new ImageIcon("pics/bbuttonArm.png")).getImage();
        bg = (new ImageIcon("pics/star-panorama.jpg")).getImage();
        bar = (new ImageIcon("pics/toolbar.png")).getImage();
        arm1 = 0;
        arm2 = 0;
        arm3 = 0;

        // animated sprite
        sprite1 = (new ImageIcon("pics/ship/sat1.png")).getImage();
        sprite2 = (new ImageIcon("pics/ship/sat2.png")).getImage();
        sprite3 = (new ImageIcon("pics/ship/sat3.png")).getImage();
        currentImage = 1;
        dirfacing = (Math.random() * Math.PI * 2);
        messagedisplaying = false;
        //init
        msg = ": ";
        planet = "";
    }

    /**
     * Render a bg depending on planet gov and tech
     * @param name name of planet
     */
    public void setupPort(String name) {
        planet = name;
        if (planet.equals(board.getPlayerData().getPlanet())) {
            homePlanet = true;
        } else {
            homePlanet = false;
        }
        
    }

    /**
     * Renders the picture
     * 
     * @param g
     *            Graphics2D
     */
    public void render(Graphics2D g) {
        Font oldFont = g.getFont();
        g.drawImage(bg, 25, 35, board);
        g.drawImage(bar, 0, 360, board);
        g.setColor(Color.yellow);
        board.chatRender(g, 10, 430, 7);
        g.drawString(msg, 12, 605);
        
        g.setFont(oldFont.deriveFont(32.0f));
        g.setColor(Color.YELLOW);
        g.drawString("CHAT     Port: " + planet, 25, 400);
        
        g.setFont(oldFont.deriveFont(16.0f));
        
        
        
        int i = 0;
        for (int x = 150; x < 650; x += 100) {
            g.setColor(new Color(21, 113, 23));
            g.setComposite(AlphaComposite.getInstance(rule, .6f));
            g.fillRect(x + 1, 101, 99, 99);
            g.setComposite(AlphaComposite.getInstance(rule, 1.0f));
            g.setColor(Color.WHITE);
            g.drawString(text[i], x + 10, 120);
            i++;
        } 
       
        g.drawRect(150 + (selected * 100), 100, 100, 100);
        
        g.setFont(oldFont.deriveFont(36.0f));
        g.setColor(Color.BLUE);
        int j = 536; int k = 538;
        g.drawImage(button[arm1], j + 130, k, board);
        g.drawString("WARP", j + 147, k + 29);
        g.drawImage(button[arm2], j, k + 40, board);
        g.drawString("SEND", j + 16, k + 70);
        g.drawImage(button[arm3], j + 130, k + 40, board);
        g.drawString("QUIT", j + 152, k + 70);
        
        g.setFont(oldFont);

        // animated sprite
        if (!messagedisplaying) {
        int xpos = 675;
        int ypos = 425;
        if ((currentImage / 25) % 4 == 0) {
            int width1 = sprite1.getWidth(null);
            int height1 = sprite1.getHeight(null);
            g.rotate(-dirfacing, xpos + width1 / 2, ypos + height1 / 2);
            g.drawImage(sprite1, xpos, ypos, null);
            g.rotate(dirfacing, -(xpos + width1 / 2), -(ypos + height1 / 2));
            currentImage++;
            dirfacing += Math.PI / 36;
        } else if ((currentImage / 25) % 4 == 1) {
            int width2 = sprite2.getWidth(null);
            int height2 = sprite2.getHeight(null);
            g.rotate(-dirfacing, xpos + width2 / 2, ypos + height2 / 2);
            g.drawImage(sprite2, xpos, ypos, null);
            g.rotate(dirfacing, -(xpos + width2 / 2), -(ypos + height2 / 2));
            currentImage++;
            dirfacing += Math.PI / 36;
        } else if ((currentImage / 25) % 4 == 2) {
            int width3 = sprite3.getWidth(null);
            int height3 = sprite3.getHeight(null);
            g.rotate(-dirfacing, xpos + width3 / 2, ypos + height3 / 2);
            g.drawImage(sprite3, xpos, ypos, null);
            g.rotate(dirfacing, -(xpos + width3 / 2), -(ypos + height3 / 2));
            currentImage++;
            dirfacing += Math.PI / 36;
        } else {
            int width2 = sprite2.getWidth(null);
            int height2 = sprite2.getHeight(null);
            g.rotate(-dirfacing, xpos + width2 / 2, ypos + height2 / 2);
            g.drawImage(sprite2, xpos, ypos, null);
            g.rotate(dirfacing, -(xpos + width2 / 2), -(ypos + height2 / 2));
            currentImage++;
            dirfacing += Math.PI / 36;
        }
    }
    }

    
    /**
     * Mouse moved too
     * @param e MouseEvent
     */
    public void mouseMoved(MouseEvent e) {
        int x = e.getX(), y = e.getY();
        if (y > 100 && y < 200) {
            if (x > 150 && x < 250) {
                selected = 0;
            } else if (x > 250 && x < 350) {
                selected = 1;
            } else if (x > 350 && x < 450) {
                selected = 2;
            } else if (x > 450 && x < 550 && homePlanet) {
                selected = 3;
            } else if (x > 550 && x < 650) {
                selected = 4;
            }
        }
    }
    
    
    /**
     * handles mouse clicked events
     * @param e MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
        int x = e.getX(), y = e.getY();
        System.out.println("x:" + x + " Y:" + y);
        //goto different port places
        
        if (y > 100 && y < 200) {
            if (x > 150 && x < 250 && selected == 0) {
                main.getConnection().sendMessage("BANKDATA");
            } else if (x > 250 && x < 350 && selected == 1) {
                main.getConnection().sendMessage("MARKETDATA");
            } else if (x > 350 && x < 450 && selected == 2) {
                main.getConnection().sendMessage("SCHOOLDATA");
            } else if (x > 450 && x < 550 && homePlanet && selected == 3) {
                main.getConnection().sendMessage("WAREHOUSEDATA");
            } else if (x > 550 && x < 650 && selected == 4) {
                main.getConnection().sendMessage("SHIPYARDDATA");
            }
        }
        
        // buttons
        if (x > 667 && x < 790 && y > 537 && y < 573 && arm1 == 1) {
            main.getConnection().sendMessage("RANGECHARTDATA");
        } else if (x > 535 && x < 660 && y > 578 && y < 613
                && msg.length() > 2 && arm2 == 1) {
            main.getConnection().sendMessage("MAINMSG~" + msg);
            msg = ": ";
        } else if (x > 665 && x < 795 && y > 578 && y < 623 && arm3 == 1) {
            board.dispatchEvent(new WindowEvent(board, 201));
        }
        arm1 = 0;
        arm2 = 0;
        arm3 = 0;
    }

    /**
     * When a mouse button is pressed
     * @param e MouseEvent
     */
    public void mousePressed(MouseEvent e) {
//      buttons
        int x = e.getX(); int y = e.getY();
        if (x > 667 && x < 790 && y > 537 && y < 573) {
            arm1 = 1;
        } else if (x > 535 && x < 660 && y > 578 && y < 613) {
            arm2 = 1;
        } else if (x > 665 && x < 795 && y > 578 && y < 613) {
            arm3 = 1;
        }
    }
    
    /**
     * handles keypresses
     * 
     * @param e
     *            KeyEvent
     */
    public void keyReleased(KeyEvent e) {
        if (e.getKeyCode() == 8) {
            if (msg.length() > 1) {
                msg = msg.substring(0, msg.length() - 1);
            }
        }
    }

    /**
     * handles key typed events
     * 
     * @param e
     *            KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == '\n' && msg.length() > 2) {
            main.getConnection().sendMessage("MAINMSG~" + msg);
            msg = ": ";

        } else if (e.getKeyChar() != '\b') {
            if (msg.length() < 60) {
                msg = msg + e.getKeyChar();
            }
        }
    }
    /**
     * @return Returns the arm1.
     */
    public int getArm1() {
        return arm1;
    }
    /**
     * @param arm1 The arm1 to set.
     */
    public void setArm1(int arm1) {
        this.arm1 = arm1;
    }
    /**
     * @return Returns the arm2.
     */
    public int getArm2() {
        return arm2;
    }
    /**
     * @param arm2 The arm2 to set.
     */
    public void setArm2(int arm2) {
        this.arm2 = arm2;
    }
    /**
     * @return Returns the arm3.
     */
    public int getArm3() {
        return arm3;
    }
    /**
     * @param arm3 The arm3 to set.
     */
    public void setArm3(int arm3) {
        this.arm3 = arm3;
    }
    /**
     * @return Returns the bar.
     */
    public Image getBar() {
        return bar;
    }
    /**
     * @param bar The bar to set.
     */
    public void setBar(Image bar) {
        this.bar = bar;
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @param bg The bg to set.
     */
    public void setBg(Image bg) {
        this.bg = bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @param board The board to set.
     */
    public void setBoard(MainGui board) {
        this.board = board;
    }
    /**
     * @return Returns the btext.
     */
    public String[] getBtext() {
        return btext;
    }
    /**
     * @param btext The btext to set.
     */
    public void setBtext(String[] btext) {
        this.btext = btext;
    }
    /**
     * @return Returns the button.
     */
    public Image[] getButton() {
        return button;
    }
    /**
     * @param button The button to set.
     */
    public void setButton(Image[] button) {
        this.button = button;
    }
    /**
     * @return Returns the homePlanet.
     */
    public boolean isHomePlanet() {
        return homePlanet;
    }
    /**
     * @param homePlanet The homePlanet to set.
     */
    public void setHomePlanet(boolean homePlanet) {
        this.homePlanet = homePlanet;
    }
    
    /**
     * @param messagedisplaying The messagedisplaying to set.
     */
    public void setMessagedisplaying(boolean messagedisplaying) {
        this.messagedisplaying = messagedisplaying;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @param main The main to set.
     */
    public void setMain(MainClass main) {
        this.main = main;
    }
    /**
     * @return Returns the msg.
     */
    public String getMsg() {
        return msg;
    }
    /**
     * @param msg The msg to set.
     */
    public void setMsg(String msg) {
        this.msg = msg;
    }
    /**
     * @return Returns the planet.
     */
    public String getPlanet() {
        return planet;
    }
    /**
     * @param planet The planet to set.
     */
    public void setPlanet(String planet) {
        this.planet = planet;
    }
    /**
     * @return Returns the rule.
     */
    public int getRule() {
        return rule;
    }
    /**
     * @param rule The rule to set.
     */
    public void setRule(int rule) {
        this.rule = rule;
    }
    /**
     * @return Returns the selected.
     */
    public int getSelected() {
        return selected;
    }
    /**
     * @param selected The selected to set.
     */
    public void setSelected(int selected) {
        this.selected = selected;
    }
    /**
     * @return Returns the text.
     */
    public String[] getText() {
        return text;
    }
    /**
     * @param text The text to set.
     */
    public void setText(String[] text) {
        this.text = text;
    }
    /**
     * @return Returns the currentImage.
     */
    public int getCurrentImage() {
        return currentImage;
    }
    /**
     * @param currentImage The currentImage to set.
     */
    public void setCurrentImage(int currentImage) {
        this.currentImage = currentImage;
    }
    /**
     * @return Returns the dirfacing.
     */
    public double getDirfacing() {
        return dirfacing;
    }
    /**
     * @param dirfacing The dirfacing to set.
     */
    public void setDirfacing(double dirfacing) {
        this.dirfacing = dirfacing;
    }
    /**
     * @return Returns the sprite1.
     */
    public Image getSprite1() {
        return sprite1;
    }
    /**
     * @param sprite1 The sprite1 to set.
     */
    public void setSprite1(Image sprite1) {
        this.sprite1 = sprite1;
    }
    /**
     * @return Returns the sprite2.
     */
    public Image getSprite2() {
        return sprite2;
    }
    /**
     * @param sprite2 The sprite2 to set.
     */
    public void setSprite2(Image sprite2) {
        this.sprite2 = sprite2;
    }
    /**
     * @return Returns the sprite3.
     */
    public Image getSprite3() {
        return sprite3;
    }
    /**
     * @param sprite3 The sprite3 to set.
     */
    public void setSprite3(Image sprite3) {
        this.sprite3 = sprite3;
    }
}