/*
 * Created on Apr 29, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.gui;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.util.ArrayList;
import java.util.List;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.client.clientdata.Blaster;
import edu.cs2335.SWATLP.client.clientdata.Target;

/**
 * @author thaile
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class SchoolRender extends GuiRender {
    /** */
    private String[] msg = new String[1];
    /** MainGui */
    private MainGui board;
    /** MainClass */
    private MainClass main;
    /** The background pic */
    private Image bg;
    /** buttons for something */
    private Image[] button = new Image[2];
    /** training ship */
    private Image ship;
    /** armed button */
    private int arm;
    /** int school */
    private int school;
    /** degree we are facing */
    private int dFacing;
    /** boolean up */
    private boolean up;
    /** boolean left */
    private boolean left;
    /** boolean right */
    private boolean right;
    /** boolean wait for key */
    private boolean keyPress;
    /** list of objects */
    private List objList;
    /** current skill list */
    private int[] skills = new int[4];
    /** money */
    private int money;
    /** bullet list */
    private List blastObj;
    /** the timer */
    private long timer;
    /**
     * Main Constructor
     * @param board MainGui
     * @param main Mainclass
     */
    public SchoolRender(MainGui board, MainClass main) {
        this.board = board;
        this.main = main;
        arm = 0;
        bg = (new ImageIcon("pics/school.jpg")).getImage();
        button[0] = (new ImageIcon("pics/bbutton.png")).getImage();
        button[1] = (new ImageIcon("pics/bbuttonArm.png")).getImage();
        ship = (new ImageIcon("pics/approach/fighter1.png")).getImage();
        school = 0;
        dFacing = 0;
        up = false;
        left = false;
        right = false;
        keyPress = false;
        msg[0] = "";
    }
    
    
    /**
     * Renders the school graphics
     * @param g Graphics2D
     */
    public void render(Graphics2D g) {
        switch(school) {
        case 0:
            g.drawImage(bg, 0, 20, board);
            g.drawRect(280, 297 + (arm * 37), 230, 37);
            break;
        case 1:
            board.switchWindow(MainGui.PORT_WINDOW);
            break;
        case 2:
            board.switchWindow(MainGui.PORT_WINDOW);
            break;
        case 3:
            board.switchWindow(MainGui.PORT_WINDOW);
            break;
        case 4:
            
            if (!keyPress) {
                g.setColor(Color.YELLOW);
                g.drawString("Shoot all the target with in the time limit to"
                    + "adavance to the next level.", 180, 200);
         
            }
            g.translate(400, 300);
            g.rotate(dFacing * (Math.PI / 180));
            g.drawImage(ship, -ship.getWidth(board) / 2, 
                     -ship.getHeight(board) / 2, board);
            g.rotate(-(dFacing * (Math.PI / 180)));
            g.translate(-400, -300);
            
            try {
                    for (int i = 0; i < objList.size(); i++) {   
                        ((Target) objList.get(i)).render(g);
                    }
                    for (int i = 0; i < blastObj.size(); i++) {   
                        ((Blaster) blastObj.get(i)).render(g);
                    }
                } catch (NullPointerException e) {
                    System.err.println("lost an object");
                }     
            
            g.setColor(Color.YELLOW);
            g.drawString("" + (timer / 1000), 700, 40);
            g.drawString(msg[0], 50, 40);
            break;
        default:
        }
        
    }
    
    /** 
     * sets up the school renderer
     * @param data String[]
     */
    public void setUp(String[] data) {
        arm = 0;
        school = 0;
        dFacing = 0;
        up = false;
        left = false;
        right = false;
        keyPress = false;
        money = Integer.parseInt(data[1]);
        skills[0] = Integer.parseInt(data[2]);
        skills[1] = Integer.parseInt(data[3]);
        skills[2] = Integer.parseInt(data[4]);
        skills[3] = Integer.parseInt(data[5]);
    }
    
    /**
     * changes the obj position base on time 
     * @param delta elapse time 
     */
    public void change(long delta) {
        if (school == 4) {
            //moves all the blasts along
            for (int i = 0; i < blastObj.size(); i++) {
                if (!((Blaster) blastObj.get(i)).move(delta)) {
                    blastObj.remove(i);
                    System.out.println("edge");
                }
            }
        }
            
        if (school == 4) {
            //check for collusions 
            for (int i = 0; i < blastObj.size(); i++) {
                Blaster blast = (Blaster) blastObj.get(i);
                for (int j = 0; j < objList.size(); j++) {
                    if (blast.checkCollision((Target) objList.get(j))) {
                        System.out.println("collusion");
                        objList.remove(j);
                        blastObj.remove(i);
                    }
                }
            }
            
            turning();
            
            winTest(delta);
        }
            
        }
    /**
     * @param delta elapse time
     */
    private void winTest(long delta) {
        if (keyPress) {
            timer -= delta;
        }
        
        if (objList.size() == 0) {
            msg[0] = "Combat skills increase";
            timer -= delta;
        }
        
        if (timer < 0) {
            if (objList.size() == 0) {
                skills[3]++;
            } else { 
                msg[0] = "YOU LOSE";
            }
            school = 0;
        }

    }


    /**
     * turning the ship
     */
    private void turning() {
        //changes the direction of fighter
        if (left) {
            dFacing -= 2;
            if (dFacing < 0) {
                dFacing = 360;
            }
        }
        if (right) {
            dFacing = (dFacing + 2) % 360;
        }
    }


    /**
     * This sets up the combat screen
     *
     */
    public void setupCombat() {
        objList = new ArrayList();
        int skill = skills[3 ];
        if (skills[3] < 1) {
            skill = 1;
        }
        for (int i = 0; i < skill * 2; i++) {
            int x = (int) (Math.random() * 800);
            int y = (int) (Math.random() * 600);
            System.out.println("added at " + x + " " + y);
            objList.add(new Target(x, y, 15 - skill));
        }
        blastObj = new ArrayList();
        timer = 30000;
        school = 4;
    }
    
    /**
     * mouse moved events
     * @param e MouseEvent
     */
    public void mouseMoved(MouseEvent e) {
        int x = e.getX(); int y = e.getY();

        if (x > 280 && x < 510) {
            if (y > 297 && y < 334) {
                arm = 0;
            } else if (y > 337 && y < 374) {
                arm = 1;
            } else if (y > 374 && y < 411) {
                arm = 2;
            } else if (y > 411 && y < 448) {
                arm = 3;
            } else if (y > 448 && y < 485) {
                arm = 4;
            }
        }
    }
    
    /**
     * mouse Released 
     * @param e MouseEvent 
     */
    public void mouseReleased(MouseEvent e) {
        int x = e.getX(); int y = e.getY();
        if (x > 280 && x < 510) {
            if (y > 297 && y < 334) {
                school = 1;
            } else if (y > 337 && y < 374) {
                school = 2;
            } else if (y > 374 && y < 411) {
                school = 3;
            } else if (y > 411 && y < 448) {
                setupCombat();
            } else if (y > 448 && y < 485) {
                board.switchWindow(MainGui.PORT_WINDOW);
            }
        }
    }
    
    /**
     * keyPressed
     * @param e KeyEvent
     */
    public void keyPressed(KeyEvent e) {
        keyPress = true;
        if (e.getKeyCode() == 37) {
            left = true;
            right = false;
        } else if (e.getKeyCode() == 38) {
            up = true;
        } else if (e.getKeyCode() == 39) {
            right = true;
            left = false;
        } 
        
    }
    
    /**
     * keyReleased
     * @param e KeyEvent
     */
    public void keyReleased(KeyEvent e) {
        if (e.getKeyCode() == 37) {
            left = false;
        } else if (e.getKeyCode() == 38) {
            up = false;
        } else if (e.getKeyCode() == 39) {
            right = false;
        } 
    }
    
    /**
     * the key typed event
     * @param e KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == ' ') {
            System.out.println("shooting");
            blastObj.add(new Blaster(400, 300, dFacing));
        }
    }
}
