package edu.cs2335.SWATLP.client.gui;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Font;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.client.clientdata.ShipInfo;
//import edu.cs2335.SWATLP.client.clientdata.ShipyardData;

/**
 * @author thaile
 * 
 */
public class ShipyardRender extends GuiRender {
    /** reference to the main gui */
    private final MainGui board;
    /** refernence to main class */
    private final MainClass main;
    
    /** backgroup picture */
    private Image bg;
    /** Image button */
    private final Image[] button = new Image[2];
    /** arming button */
    private int[] arm = new int[9];
    /** the button that armed */
    private int armI;
    /** The current typeing chat msg */
    private String msg;
    /**
     * Comment for <code>shiptype</code>
     */
    private String shiptype;
    /**
     * Comment for <code>selectedship</code>
     */
    private String selectedship;
    
    /** Shipyard data */
 //   private ShipyardData data;
    
    /** 1 - buynewship */
    private int actionscreen;
    
    /**
     * Comment for <code>transferweapons</code>
     */
    private boolean transferweapons;
    
    
    /** The ship Image */
    private final Image shipPic;
    /** */
    private Image shipimage;
    /** ShipInfo */
    private String[] shipinfo;
    
    /** The cash in the bank */
    private String bank;
    /** The cash on hand */
    private String cash;
    /** The shield strength */
    private int shieldstrength;
    /** The gunslots on the ship */
    private String gunSlots;
    /** The max cargo size */
    private String maxCargo;
    /** The current fuel lvl */
    private int fuel;
    /** The max fuel */
    private int maxFuel;
    /** the current hitpoint */
    private int hitpoint;
    /** The max hit point */
    private int maxHit;
    /** The size of the shield */
    private BasicStroke shield;
    /**
     * Constructor
     * 
     * @param board
     *            MainGui
     * @param main
     *            MainClass
     */
    public ShipyardRender(MainGui board, MainClass main) {
        this.board = board;
        this.main = main;
        transferweapons = false;
        setWindowNumber(6);
        actionscreen = 0;
        button[0] =  (new ImageIcon("pics/bbutton.png")).getImage();
        button[1] = (new ImageIcon("pics/bbuttonArm.png")).getImage();      
        shipPic = (new ImageIcon("pics/ship_grid.png")).getImage();
        arm[0] = 0;
        arm[1] = 0;
        selectedship = "Ultimate";
        msg = ":";
        maxCargo = "";
        this.shieldstrength = 0;
    }

    /**
     * this changes the screen base on gov and tech
     * 
     * @param shipdata  a bunch of shipyard data
     */
    public void setupShipyard(String[] shipdata) {
        bg = (new ImageIcon("pics/toolbar.png")).getImage();

        bank = shipdata[1];
        cash = shipdata[2];
        shiptype = shipdata[3];
        
        if (shipdata[3].equals("Trader")) {
            shipinfo = ShipInfo.TRADER;
        } else if (shipdata[3].equals("Fighter")) {
            shipinfo = ShipInfo.FIGHTER;
        } else {
            shipinfo = ShipInfo.ULTIMATE;
        }
        
        shieldstrength = Integer.parseInt(shipdata[4]);
        gunSlots = shipdata[5];
        maxCargo = shipdata[6];
        fuel = Integer.parseInt(shipdata[7]);
        maxFuel = Integer.parseInt(shipdata[8]);
        hitpoint = Integer.parseInt(shipdata[9]);
        maxHit = Integer.parseInt(shipdata[10]);
        
        shield = new BasicStroke(2);
    }

    /**
     * Draws the shipyard
     * 
     * @param g
     *            Graphics2D
     */
    public void render(Graphics2D g) {
        
        //Chat stuff
        g.setColor(Color.YELLOW);
        board.chatRender(g, 10, 430, 7);
        g.drawString(msg, 12, 605);
        
        Font oldFont = g.getFont();
        g.drawImage(bg, 0, 360, board);
        
        g.setColor(Color.WHITE);
        g.drawString("Cash: $" + cash, 27, 390);
        g.drawString("Bank Account: $" + bank, 27, 410);
        g.drawString("Current Ship Stats:", 625, 390);
        g.drawString("Ship Type: " + shiptype, 625, 420);
        g.drawString("Current Gunslots: " + gunSlots, 625, 435);
        g.drawString("Max Gunslots: " + shipinfo[3], 625, 450);
        g.drawString("Current Fuel: " + fuel, 625, 465);
        g.drawString("Fuel Capacity: " + maxFuel, 625, 480);
        g.drawString("Current Hitpoints: " + hitpoint, 625, 495);
        g.drawString("Max Hitpoints: " + maxHit, 625, 510);
        g.drawString("Shield Strength: " + shieldstrength, 625, 525);
        
        
        //Chat stuff
        g.setColor(Color.YELLOW);
        board.chatRender(g, 10, 430, 7);
        g.drawString(msg, 12, 605);
        
        g.setFont(oldFont.deriveFont(36.0f));
        g.setColor(Color.BLUE);
        g.drawImage(button[arm[0]], 536, 578, board);
        g.drawString("SEND", 552, 608);
        g.drawImage(button[arm[1]], 665, 578, board);
        g.drawString("PORT", 688, 608);
        g.setColor(Color.GREEN);
        g.drawString("SHIPYARD", 10, 60);
        g.setFont(oldFont);
        
        if (actionscreen == 1) {
            render1(g);
            return;
        } else if (actionscreen == 2) {
            render2(g);
            return;
        }
                
        g.setColor(Color.CYAN);
        
        g.setStroke(shield);
        g.drawOval(200, 50, 300, 300);
        
        g.setColor(new Color(21, 113, 23));
        g.setStroke(new BasicStroke(1));
        
        //upgrade shields
        if (arm[2] == 1) {
            g.setColor(Color.GREEN);
        }
        g.drawRect(10, 90, 130, 30);
        g.drawLine(140, 120, 180, 160);
        g.drawLine(180, 160, 205, 160);
        g.drawString("Upgrade Shields", 20, 110);
        g.setColor(new Color(21, 113, 23));
        
        
        //reorder weapons
        if (arm[3] == 1) {
            g.setColor(Color.GREEN);
        }
        g.drawRect(10, 140, 130, 30);
        g.drawLine(140, 170, 160, 190);
        g.drawLine(160, 190, 350, 190);
        g.drawString("Reorder Weapons", 20, 160);
        g.setColor(new Color(21, 113, 23));
        
        //repair
        if (arm[4] == 1) {
            g.setColor(Color.GREEN);
        }
        g.drawRect(10, 240, 130, 30);
        g.drawLine(140, 240, 160, 220);
        g.drawLine(160, 220, 350, 220);
        g.drawString("Repair Ship", 30, 260);
        g.setColor(new Color(21, 113, 23));
        
        //fuel
        if (arm[5] == 1) {
            g.setColor(Color.GREEN);
        }
        g.drawRect(10, 290, 130, 30);
        g.drawLine(140, 290, 180, 250);
        g.drawLine(180, 250, 210, 250);
        g.drawString("Refuel Ship", 35, 310);
        g.setColor(new Color(21, 113, 23));
        
        //Buy new ship
        if (arm[6] == 1) {
            g.setColor(Color.GREEN);
        }
        g.drawRect(500, 250, 130, 30);
        g.drawString("Buy New Ship", 520, 270);
        g.setColor(new Color(21, 113, 23));
        
        //Buy Weapons
        if (arm[7] == 1) {
            g.setColor(Color.GREEN);
        }
        g.drawRect(470, 300, 130, 30);
        g.drawString("Buy New Weapons", 480, 320);
        g.setColor(new Color(21, 113, 23));
        
        //Buy gadgets
        if (arm[8] == 1) {
            g.setColor(Color.GREEN);
        }
        g.drawRect(420, 350, 130, 30);
        g.drawString("Buy New Gadgets", 430, 370);
        g.setColor(new Color(21, 113, 23));
        
        g.drawImage(shipPic, 275, 127, board);
        
        g.setFont(oldFont);
    }
    
    /**
     * @param g g
     */
    public void render1(Graphics2D g) {
        
        //general
        g.drawString("Select Ship Type:", 35, 90);
        g.drawString("Ship Stats:", 275, 90);
        g.drawString("Description:", 510, 90);
        g.setColor(new Color(21, 113, 23));
        g.setStroke(new BasicStroke(1));
        g.drawRect(30, 125, 130, 30);
        g.drawString("Ultimate", 66, 145);
        g.drawRect(30, 175, 130, 30);
        g.drawString("Fighter", 69, 195);
        g.drawRect(30, 225, 130, 30);
        g.drawString("Trader", 72, 245);
        
        String[] shipdata = null;
        if (selectedship.equals("Ultimate")) {
            shipdata = ShipInfo.ULTIMATE;
            shipimage = ShipInfo.ULTIMATEPIC;
        } else if (selectedship.equals("Fighter")) {
            shipdata = ShipInfo.FIGHTER;
            shipimage = ShipInfo.FIGHTERPIC;
        } else {
            shipdata = ShipInfo.TRADER;
            shipimage = ShipInfo.TRADERPIC;
        }
        g.drawImage(shipimage, 270, 110, board);
        g.drawString(selectedship, 330, 130);
        g.drawString("Max Gunslots:", 280, 190);
        g.drawString(shipdata[3], 410, 190);
        g.drawString("Starting Gunslots:", 280, 210);
        g.drawString(shipdata[4], 410, 210);
        g.drawString("Cargo Size:", 280, 230);
        g.drawString(shipdata[5], 410, 230);
        g.drawString("Hit Points:", 280, 250);
        g.drawString(shipdata[6], 410, 250);
        g.drawString("Fuel Capacity:", 280, 270);
        g.drawString(shipdata[7], 410, 270);
        g.drawString("Cost: $" + shipdata[2], 280, 320);
        g.drawString("Buy", 400, 320);
        g.drawRect(389, 306, 40, 20);
        g.drawString("Transfer Weapons/Gadgets? ($500 extra)", 300, 350);
        g.drawRect(280, 338, 15, 15);
        if (transferweapons) {
            g.fillRect(280, 338, 15, 15);
        }
        int height = 120;
        for (int i = 8; i < shipdata.length; i++) {
            g.drawString(shipdata[i], 510, height);
            height += 15;
        }
    }
    
   /**
    * 
    * @param g graph
    */
    public void render2(Graphics2D g) {
        g.setColor(Color.GREEN);
        g.drawString("Escape Pod", 60, 100);
        g.drawString("Navigation System", 240, 100);
        g.drawString("Mechanics Skill", 410, 100);
        g.drawString("Negotiations Chip", 575, 100);
        g.drawString("Targetting System", 60, 240);
        g.drawString("Cargo Compressor", 240, 240);
        g.drawString("External Turret", 410, 240);
        g.setColor(new Color(21, 113, 23));
        g.setStroke(new BasicStroke(1));
        g.drawString("Allows continuation", 60, 120);
        g.drawString("of mission after,", 60, 135);
        g.drawString("ship destruction.", 60, 150);
        g.drawString("Cost: $1000", 60, 175);
        g.drawString("Buy", 160, 175);
        g.drawRect(150, 160, 40, 20);
        
        g.drawString("Adds to players's", 240, 120);
        g.drawString("piloting skill.", 240, 135);
        g.drawString("Cost: $500", 240, 175);
        g.drawString("Buy", 340, 175);
        g.drawRect(330, 160, 40, 20);
        
        g.drawString("Adds to players's", 410, 120);
        g.drawString("engineering skill.", 410, 135);
        g.drawString("Cost: $500", 410, 175);
        g.drawString("Buy", 510, 175);
        g.drawRect(500, 160, 40, 20);
        
        g.drawString("Adds to players's", 575, 120);
        g.drawString("trading skill.", 575, 135);
        g.drawString("Cost: $500", 575, 175);
        g.drawString("Buy", 675, 175);
        g.drawRect(665, 160, 40, 20);
        
        g.drawString("Adds to players's", 60, 260);
        g.drawString("combat skill.", 60, 275);
        g.drawString("Cost: $500", 60, 305);
        g.drawString("Buy", 160, 305);
        g.drawRect(150, 290, 40, 20);
        
        g.drawString("Increases ship", 240, 260);
        g.drawString("cargo space.", 240, 275);
        g.drawString("Cost: $750", 240, 305);
        g.drawString("Buy", 340, 305);
        g.drawRect(330, 290, 40, 20);
        
        g.drawString("Increases available", 410, 260);
        g.drawString("gun slots.", 410, 275);
        g.drawString("Cost: $900", 410, 305);
        g.drawString("Buy", 510, 305);
        g.drawRect(500, 290, 40, 20);
    }
    /**
     * Detect where the mouse is 
     * @param e MouseEvent 
     */
    public void mouseMoved(MouseEvent e) {
        int x = e.getX(); int y = e.getY();
        if (x > 10 && x < 140) {
            if (y > 90 && y < 120) {
                arm[2] = 0;
                armI = 2;
            }
        } else {
            arm[armI] = 0;
        }
    }
    
    
    /** (non-Javadoc)
     * @see java.awt.event.MouseListener
     * #mousePressed(java.awt.event.MouseEvent)
     */
    public void mousePressed(MouseEvent e) {
        int x = e.getX(); int y = e.getY();
        if (y > 580 && y < 620) {
            if (x > 536 && x < 661) {
                arm[0] = 1;
            } else if (x > 665 && x < 790) {
                arm[1] = 1;
            }
        }
    }

    /**
     * handles mouse clicked events
     * 
     * @param e
     *            MouseEvent
     */
    public void mouseReleased(MouseEvent e) {
        int x = e.getX(), y = e.getY();
        //goto different port places
        System.out.println("x" + x + " y" + y);
        // buttons
        
        if (y > 580 && y < 620) {
            if (x > 536 && x < 661 && arm[0] == 1 && msg.length() > 2) {
                main.getConnection().sendMessage("MAINMSG~" + msg);
                msg = ": ";
            } else if (x > 665 && x < 790 && arm[1] == 1) {
                actionscreen = 0;
                board.switchWindow(MainGui.PORT_WINDOW);
            }
        } else {
            switch (actionscreen) {
                case 0:
                    processMainInput(x, y);
                    break;
                case 1:
                    processBuyShipInput(x, y);
                    break;
                case 2:
                    processBuyGadgetInput(x, y);
                default:
            }
        }
        arm[0] = 0;
        arm[1] = 0;
    }
    
    /**
     * 
     * @param x var
     * @param y var
     */
    public void processMainInput(int x, int y) {
        if (x > 10 && x < 140) {
            if (y > 92 && y < 121) {
                main.getConnection().sendMessage(
                        "SHIPYARDTRANS~upgradeshields");
                // upgrade shields
            } else if (y > 142 && y < 172) {
                System.out.println("WEAPONS");
                // reorder weapons
            } else if (y > 242 && y < 272) {
                System.out.println("REPAIR");
                if (hitpoint != maxHit) {
                main.getConnection()
                .sendMessage("SHIPYARDTRANS~repairship");
                }
            } else if (y > 292 && y < 322) {
                if (fuel != maxFuel) {
                    main.getConnection()
                    .sendMessage("SHIPYARDTRANS~refuelship");
                    }
            }
        } else if (x > 500 && x < 630 && y > 252 && y < 282) {
            actionscreen = 1;
        } else if (x > 470 && x < 600 && y > 302 && y < 332) {
            System.out.println("NEW WEAPONS");
            // buy new weapons
        } else if (x > 420 && x < 550 && y > 352 && y < 382) {
            actionscreen = 2;
          //  actionscreen
        }
        arm[0] = 0;
        arm[1] = 0;
    }
    
    /**
     * 
     * @param x x 
     * @param y y
     */
    public void processBuyShipInput(int x, int y) {
        if (x > 30 && x < 160) {
            if (y > 126 && y < 156) {
                selectedship = "Ultimate";
            } else if (y > 176 && y < 206) {
                selectedship = "Fighter";
            } else if (y > 228 && y < 258) {
                selectedship = "Trader";
            }
        } else if (x > 280 && x < 295 && y > 340 && y < 355) {
            if (transferweapons) {
                transferweapons = false;
            } else {
                transferweapons = true;
            }
        } else if (x > 390 && x < 430 && y > 308 && y < 328) {
            String transfer = "";
            if (transferweapons) {
                transfer = "yes";
            } else {
                transfer = "no";                        
            }
            main.getConnection().sendMessage(
                    "SHIPYARDTRANS~buyship~" 
                    + selectedship + "~" + transfer);
        }
    }
    
    /**
     * 
     * @param x x 
     * @param y y
     */
    public void processBuyGadgetInput(int x, int y) {
        if (y > 162 && y < 182) {
            if (x > 151 && x < 191) {
                main.getConnection().sendMessage(
                        "SHIPYARDTRANS~buygadget~escapepod");
            } else if (x > 332 && x < 372) {
                main.getConnection().sendMessage(
                "SHIPYARDTRANS~buygadget~navigationalsystem");
            } else if (x > 500 && x < 540) {
                main.getConnection().sendMessage(
                "SHIPYARDTRANS~buygadget~mechanicskit");
            } else if (x > 666 && x < 706) {
                main.getConnection().sendMessage(
                "SHIPYARDTRANS~buygadget~negotiationschip");
            }
        } else if (y > 293 && y < 313) {
            if (x > 151 && x < 191) {
                main.getConnection().sendMessage(
                "SHIPYARDTRANS~buygadget~targetingsystem");
            } else if (x > 332 && x < 372) {
                main.getConnection().sendMessage(
                "SHIPYARDTRANS~buygadget~cargocompressor");
            } else if (x > 500 && x < 540) {
                main.getConnection().sendMessage(
                "SHIPYARDTRANS~buygadget~externalturrets");
            }
        }
    }

    /**
     * handles keypresses
     * 
     * @param e
     *            KeyEvent
     */
    public void keyReleased(KeyEvent e) {
        if (e.getKeyCode() == 8) {
            if (msg.length() > 1) {
                msg = msg.substring(0, msg.length() - 1);
            }
        }
    }

    /**
     * handles key typed events
     * @param e KeyEvent
     */
    public void keyTyped(KeyEvent e) {
        if (e.getKeyChar() == '\n' && msg.length() > 2) {
            main.getConnection().sendMessage("MAINMSG~" + msg);
            msg = ": ";

        } else if (e.getKeyChar() != '\b') {
            if (msg.length() < 45) {
                msg = msg + e.getKeyChar();
            }
        }
    }

    /**
     * @return Returns the actionscreen.
     */
    public int getActionscreen() {
        return actionscreen;
    }
    /**
     * @param actionscreen The actionscreen to set.
     */
    public void setActionscreen(int actionscreen) {
        this.actionscreen = actionscreen;
    }
    /**
     * @return Returns the arm.
     */
    public int[] getArm() {
        return arm;
    }
    /**
     * @param arm The arm to set.
     */
    public void setArm(int[] arm) {
        this.arm = arm;
    }
    /**
     * @return Returns the armI.
     */
    public int getArmI() {
        return armI;
    }
    /**
     * @param armI The armI to set.
     */
    public void setArmI(int armI) {
        this.armI = armI;
    }
    /**
     * @return Returns the bank.
     */
    public String getBank() {
        return bank;
    }
    /**
     * @param bank The bank to set.
     */
    public void setBank(String bank) {
        this.bank = bank;
    }
    /**
     * @return Returns the bg.
     */
    public Image getBg() {
        return bg;
    }
    /**
     * @param bg The bg to set.
     */
    public void setBg(Image bg) {
        this.bg = bg;
    }
    /**
     * @return Returns the board.
     */
    public MainGui getBoard() {
        return board;
    }
    /**
     * @return Returns the button.
     */
    public Image[] getButton() {
        return button;
    }
    /**
     * @return Returns the cash.
     */
    public String getCash() {
        return cash;
    }
    /**
     * @param cash The cash to set.
     */
    public void setCash(String cash) {
        this.cash = cash;
    }
    /**
     * @return Returns the fuel.
     */
    public int getFuel() {
        return fuel;
    }
    /**
     * @param fuel The fuel to set.
     */
    public void setFuel(int fuel) {
        this.fuel = fuel;
    }
    /**
     * @return Returns the gunSlots.
     */
    public String getGunSlots() {
        return gunSlots;
    }
    /**
     * @param gunSlots The gunSlots to set.
     */
    public void setGunSlots(String gunSlots) {
        this.gunSlots = gunSlots;
    }
    /**
     * @return Returns the hitpoint.
     */
    public int getHitpoint() {
        return hitpoint;
    }
    /**
     * @param hitpoint The hitpoint to set.
     */
    public void setHitpoint(int hitpoint) {
        this.hitpoint = hitpoint;
    }
    /**
     * @return Returns the main.
     */
    public MainClass getMain() {
        return main;
    }
    /**
     * @return Returns the maxCargo.
     */
    public String getMaxCargo() {
        return maxCargo;
    }
    /**
     * @param maxCargo The maxCargo to set.
     */
    public void setMaxCargo(String maxCargo) {
        this.maxCargo = maxCargo;
    }
    /**
     * @return Returns the maxFuel.
     */
    public int getMaxFuel() {
        return maxFuel;
    }
    /**
     * @param maxFuel The maxFuel to set.
     */
    public void setMaxFuel(int maxFuel) {
        this.maxFuel = maxFuel;
    }
    /**
     * @return Returns the maxHit.
     */
    public int getMaxHit() {
        return maxHit;
    }
    /**
     * @param maxHit The maxHit to set.
     */
    public void setMaxHit(int maxHit) {
        this.maxHit = maxHit;
    }
    /**
     * @return Returns the msg.
     */
    public String getMsg() {
        return msg;
    }
    /**
     * @param msg The msg to set.
     */
    public void setMsg(String msg) {
        this.msg = msg;
    }
    /**
     * @return Returns the selectedship.
     */
    public String getSelectedship() {
        return selectedship;
    }
    /**
     * @param selectedship The selectedship to set.
     */
    public void setSelectedship(String selectedship) {
        this.selectedship = selectedship;
    }
    /**
     * @return Returns the shield.
     */
    public BasicStroke getShield() {
        return shield;
    }
    /**
     * @param shield The shield to set.
     */
    public void setShield(BasicStroke shield) {
        this.shield = shield;
    }
    /**
     * @return Returns the shipimage.
     */
    public Image getShipimage() {
        return shipimage;
    }
    /**
     * @param shipimage The shipimage to set.
     */
    public void setShipimage(Image shipimage) {
        this.shipimage = shipimage;
    }
    /**
     * @return Returns the shipinfo.
     */
    public String[] getShipinfo() {
        return shipinfo;
    }
    /**
     * @param shipinfo The shipinfo to set.
     */
    public void setShipinfo(String[] shipinfo) {
        this.shipinfo = shipinfo;
    }
    /**
     * @return Returns the shipPic.
     */
    public Image getShipPic() {
        return shipPic;
    }
    /**
     * @return Returns the shiptype.
     */
    public String getShiptype() {
        return shiptype;
    }
    /**
     * @param shiptype The shiptype to set.
     */
    public void setShiptype(String shiptype) {
        this.shiptype = shiptype;
    }
    /**
     * @return Returns the transferweapons.
     */
    public boolean isTransferweapons() {
        return transferweapons;
    }
    /**
     * @param transferweapons The transferweapons to set.
     */
    public void setTransferweapons(boolean transferweapons) {
        this.transferweapons = transferweapons;
    }
}