package edu.cs2335.SWATLP.client.planets;

import java.io.Serializable;

/**
 * @author Andy Thompson <p/>this is the abstract class for the planets to fit
 *         OOP
 */
public abstract class PlanetModel implements Serializable {
    /**
     * Comment for <code>drugBuyBase</code>
     */
    public static final int DRUGBUYBASE = 600;

    /**
     * Comment for <code>drugSellBase</code>
     */
    public static final int DRUGSELLBASE = 900;

    /**
     * Comment for <code>foodBuyBase</code>
     */
    public static final int FOODBUYBASE = 600;

    /**
     * Comment for <code>foodSellBase</code>
     */
    public static final int FOODSELLBASE = 400;

    /**
     * Comment for <code>gameBuyBase</code>
     */
    public static final int GAMEBUYBASE = 200;

    /**
     * Comment for <code>gameSellBase</code>
     */
    public static final int GAMESELLBASE = 300;

    /**
     * Comment for <code>gunBuyBase</code>
     */
    public static final int GUNBUYBASE = 600;

    /**
     * Comment for <code>gunSellBase</code>
     */
    public static final int GUNSELLBASE = 900;

    /**
     * Comment for <code>medBuyBase</code>
     */
    public static final int MEDBUYBASE = 200;

    /**
     * Comment for <code>medSellBase</code>
     */
    public static final int MEDSELLBASE = 300;

    /**
     * Comment for <code>oreBuyBase</code>
     */
    public static final int OREBUYBASE = 400;

    /**
     * Comment for <code>oreSellBase</code>
     */
    public static final int ORESELLBASE = 600;

    /**
     * Comment for <code>robotBuyBase</code>
     */
    public static final int ROBOTBUYBASE = 900;

    /**
     * Comment for <code>robotSellBase</code>
     */
    public static final int ROBOTSELLBASE = 1200;

    /**
     * Comment for <code>waterBuyBase</code>
     */
    public static final int WATERBUYBASE = 200;

    /**
     * Comment for <code>waterSellBase</code>
     */
    public static final int WATERSELLBASE = 300;

    /**
     * Comment for <code>drugBuy</code>
     */
    protected int drugBuy;

    /**
     * Comment for <code>drugBuyMult</code>
     */
    protected float drugBuyMult;

    /**
     * Comment for <code>drugSell</code>
     */
    protected int drugSell;

    /**
     * Comment for <code>drugSellMult</code>
     */
    protected float drugSellMult;

    /**
     * Comment for <code>event</code>
     */
    protected String event;

    /**
     * Comment for <code>foodBuy</code>
     */
    protected int foodBuy;

    /**
     * Comment for <code>foodBuyMult</code>
     */
    protected float foodBuyMult;

    /**
     * Comment for <code>foodSell</code>
     */
    protected int foodSell;

    /**
     * Comment for <code>foodSellMult</code>
     */
    protected float foodSellMult;

    /**
     * Comment for <code>gameBuy</code>
     */
    protected int gameBuy;

    /**
     * Comment for <code>gameBuyMult</code>
     */
    protected float gameBuyMult;

    /**
     * Comment for <code>gameSell</code>
     */
    protected int gameSell;

    /**
     * Comment for <code>gameSellMult</code>
     */
    protected float gameSellMult;

    /**
     * Comment for <code>govType</code>
     */
    protected String govType;

    /**
     * Comment for <code>gunBuy</code>
     */
    protected int gunBuy;

    /**
     * Comment for <code>gunBuyMult</code>
     */
    protected float gunBuyMult;

    /**
     * Comment for <code>gunSell</code>
     */
    protected int gunSell;

    /**
     * Comment for <code>gunSellMult</code>
     */
    protected float gunSellMult;

    /**
     * Comment for <code>medBuy</code>
     */
    protected int medBuy;

    /**
     * Comment for <code>medBuyMult</code>
     */
    protected float medBuyMult;

    /**
     * Comment for <code>medSell</code>
     */
    protected int medSell;

    /**
     * Comment for <code>medSellMult</code>
     */
    protected float medSellMult;

    /**
     * Comment for <code>name</code>
     */
    protected String name;

    /**
     * Comment for <code>oreBuy</code>
     */
    protected int oreBuy;

    /**
     * Comment for <code>oreBuyMult</code>
     */
    protected float oreBuyMult;

    /**
     * Comment for <code>oreSell</code>
     */
    protected int oreSell;

    /**
     * Comment for <code>oreSellMult</code>
     */
    protected float oreSellMult;

    /**
     * Comment for <code>robotBuy</code>
     */
    protected int robotBuy;

    /**
     * Comment for <code>robotBuyMult</code>
     */
    protected float robotBuyMult;

    /**
     * Comment for <code>robotSell</code>
     */
    protected int robotSell;

    /**
     * Comment for <code>robotSellMult</code>
     */
    protected float robotSellMult;

    /**
     * Comment for <code>techLevel</code>
     */
    protected String techLevel;

    /**
     * Comment for <code>waterBuy</code>
     */
    protected int waterBuy;

    /**
     * Comment for <code>waterBuyMult</code>
     */
    protected float waterBuyMult;

    /**
     * Comment for <code>waterSell</code>
     */
    protected int waterSell;

    /**
     * Comment for <code>waterSellMult</code>
     */
    protected float waterSellMult;

    /**
     * Comment for <code>xLoc</code>
     */
    protected int xLoc;

    /**
     * Comment for <code>yLoc</code>
     */
    protected int yLoc;
    /** police preserance */
    protected String police;
    /** pirate preserance */
    protected String pirate;
    /** merchent preserance */
    protected String merchant; 

    /**
     * @param gov
     *            the gov type
     * @param tech
     *            the tech level
     */
    public PlanetModel(String gov, String tech) {
        govType = gov;
        techLevel = tech;
    }

    
    /**
     * The lvl of merchents 
     * @return String 
     */
    public String getMerchant() {
        return merchant;
    }
    /**
     * The lvl of pirates
     * @return String
     */
    public String getPirate() {
        return pirate;
    }
    /**
     * The lvl of police 
     * @return String
     */
    public String getPolice() {
        return police;
    }
    /**
     *  
     */
    public abstract void event();

    /**
     *  
     */
    public abstract void setMult();

    /**
     *  
     */
    public final void setPrices() {
        gameSell = (int) (gameSellMult * GAMESELLBASE);
        gameBuy = (int) (gameBuyMult * GAMEBUYBASE);
        oreSell = (int) (oreSellMult * ORESELLBASE);
        oreBuy = (int) (oreBuyMult * OREBUYBASE);
        drugSell = (int) (drugSellMult * DRUGSELLBASE);
        drugBuy = (int) (drugBuyMult * DRUGBUYBASE);
        gunSell = (int) (gunSellMult * GUNSELLBASE);
        gunBuy = (int) (gunBuyMult * GUNBUYBASE);
        foodSell = (int) (foodSellMult * FOODSELLBASE);
        foodBuy = (int) (foodBuyMult * FOODBUYBASE);
        waterSell = (int) (waterSellMult * WATERSELLBASE);
        waterBuy = (int) (waterBuyMult * WATERBUYBASE);
        medSell = (int) (medSellMult * MEDSELLBASE);
        medBuy = (int) (medBuyMult * MEDBUYBASE);
        robotSell = (int) (robotSellMult * ROBOTSELLBASE);
        robotBuy = (int) (robotBuyMult * ROBOTBUYBASE);
    }
    
    /**
     * @return price array
     */
    public int[] getPrices() {
        int[] prices = {gameSell, gameBuy, oreSell, oreBuy, drugSell, drugBuy,
                gunSell, gunBuy, foodSell, foodBuy, waterSell, waterBuy, 
                medSell, medBuy, robotSell, robotBuy}; 
        return prices;
    }

    /**
     * @return Returns the event.
     */
    public String getEvent() {
        return event;
    }

    /**
     * @param event
     *            The event to set.
     */
    public void setEvent(String event) {
        this.event = event;
    }

    /**
     * @return Returns the govType.
     */
    public String getGovType() {
        return govType;
    }

    /**
     * @param govType
     *            The govType to set.
     */
    public void setGovType(String govType) {
        this.govType = govType;
    }

    /**
     * @return Returns the techLevel.
     */
    public String getTechLevel() {
        return techLevel;
    }

    /**
     * @param techLevel
     *            The techLevel to set.
     */
    public void setTechLevel(String techLevel) {
        this.techLevel = techLevel;
    }

    /**
     * @return Returns the name.
     */
    public String getName() {
        return name;
    }

    /**
     * @param name
     *            The name to set.
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return Returns the drugBuy.
     */
    public int getDrugBuy() {
        return drugBuy;
    }

    /**
     * @return Returns the drugSell.
     */
    public int getDrugSell() {
        return drugSell;
    }

    /**
     * @return Returns the foodBuy.
     */
    public int getFoodBuy() {
        return foodBuy;
    }

    /**
     * @return Returns the foodSell.
     */
    public int getFoodSell() {
        return foodSell;
    }

    /**
     * @return Returns the gameBuy.
     */
    public int getGameBuy() {
        return gameBuy;
    }

    /**
     * @return Returns the gameSell.
     */
    public int getGameSell() {
        return gameSell;
    }

    /**
     * @return Returns the gunBuy.
     */
    public int getGunBuy() {
        return gunBuy;
    }

    /**
     * @return Returns the gunSell.
     */
    public int getGunSell() {
        return gunSell;
    }

    /**
     * @return Returns the medBuy.
     */
    public int getMedBuy() {
        return medBuy;
    }

    /**
     * @return Returns the medSell.
     */
    public int getMedSell() {
        return medSell;
    }

    /**
     * @return Returns the oreBuy.
     */
    public int getOreBuy() {
        return oreBuy;
    }

    /**
     * @return Returns the oreSell.
     */
    public int getOreSell() {
        return oreSell;
    }

    /**
     * @return Returns the robotBuy.
     */
    public int getRobotBuy() {
        return robotBuy;
    }

    /**
     * @return Returns the robotSell.
     */
    public int getRobotSell() {
        return robotSell;
    }

    /**
     * @return Returns the waterBuy.
     */
    public int getWaterBuy() {
        return waterBuy;
    }

    /**
     * @return Returns the waterSell.
     */
    public int getWaterSell() {
        return waterSell;
    }
    
    /**
     * @return x loc
     */
    public int getXlocation() {
        return xLoc;
    }
    
    /**
     * @return y loc
     */
    public int getYlocation() {
        return yLoc;
    }
    /**
     * set the merchant
     * @param merchant String
     */
    public void setMerchant(String merchant) {
        this.merchant = merchant;
    }
    /**
     * Set the pirates 
     * @param pirate String
     */
    public void setPirate(String pirate) {
        this.pirate = pirate;
    }
    /**
     * Set the police
     * @param police String
     */
    public void setPolice(String police) {
        this.police = police;
    }
}