package edu.cs2335.SWATLP.client.spacegame;

import java.util.Random;

/**
 * @author jonathan <p/>
 */
public class ApproachPlanet {

    /**
     * Comment for <code>xsize</code>
     */
    private static final int XSIZE = 600;

    /**
     * Comment for <code>ysize</code>
     */
    private static final int YSIZE = 600;

    /**
     * Comment for <code>asteroidvars</code>
     */
    private static final double[] ASTEROIDVARS = {0.65, 0.4, 0.25, 0.1 };

    /**
     * Comment for <code>merchantvars</code>
     */
    private static final double[][] MERCHANTVARS = {{0.0, 0.0, 0.15, 0.25 },
            {0.15, 0.3, 0.45, 0.6 }, {0.15, 0.25, 0.35, 0.5 },
            {0.15, 0.3, 0.45, 0.6 }, {0.15, 0.25, 0.35, 0.5 },
            {0.15, 0.3, 0.45, 0.6 } };

    /**
     * Comment for <code>policevars</code>
     */
    private static final double[][] POLICEVARS = {{0.0, 0.0, 0.1, 0.2 },
            {0.1, 0.2, 0.35, 0.55 }, {0.1, 0.25, 0.4, 0.65 },
            {0.15, 0.3, 0.45, 0.6 }, {0.1, 0.20, 0.3, 0.4 },
            {0.1, 0.15, 0.25, 0.4 } };

    /**
     * Comment for <code>piratevars</code>
     */
    private static final double[][] PIRATEVARS = {{0.5, 0.4, 0.25, 0.1 },
            {0.4, 0.25, 0.1, 0.0 }, {0.25, 0.15, 0.1, 0.0 },
            {0.5, 0.5, 0.3, 0.15 }, {0.4, 0.3, 0.20, 0.1 },
            {0.4, 0.25, 0.15, 0.1 } };

    /**
     * Comment for <code>zonenumber</code>
     */
    private static int zonenumber;

    /**
     * Comment for <code>govtype</code>
     */
    private static int govtype;

    /**
     * Comment for <code>generator</code>
     */
    private static Random generator = new Random(System.currentTimeMillis());

    /**
     * Comment for <code>pirategenerated</code>
     */
    private static boolean pirategenerated;
    
    /**
     * Comment for <code>pirategenerated</code>
     */
    private static boolean merchantgenerated;

    /**
     * Default Constructor
     */
    private ApproachPlanet() {
    }

    /**
     * @param govType
     *            g
     * @param zonenum
     *            z
     * @return blah
     */
    public static Zone approachZone(String govType, int zonenum) {

        Zone currzone = new Zone();
        zonenumber = zonenum - 1;
        govtype = getGovType(govType);
        pirategenerated = false;
        merchantgenerated = false;
        generateObjects(currzone);
        System.out.println(currzone.getObjectList().size());
        return currzone;
    }


    /**
     * @param currzone z
     */
    private static void generateObjects(Zone currzone) {
        for (int i = 0; i < 5; i++) {
            generatePirate(currzone);
        }
        if (!pirategenerated) {
            for (int i = 0; i < 5; i++) {
                if (!merchantgenerated) {
                    generateMerchant(currzone);
                }
                generatePolice(currzone);
            }
        } 
        for (int i = 0; i < 5; i++) {
        generateAsteroid(currzone);
        }
    }

    /**
     * @param govname
     *            g
     * @return blah
     */
    private static int getGovType(String govname) {
        if (govname.equals("Anarchy")) {
            return 0;
        } else if (govname.equals("Capitalism")) {
            return 1;
        } else if (govname.equals("Communism")) {
            return 2;
        } else if (govname.equals("Cybernetic")) {
            return 3;
        } else if (govname.equals("Feudal")) {
            return 4;
        } else if (govname.equals("Pacifism")) {
            return 5;
        }
        return -1;
    }

    /**
     * @param currzone c
     */
    private static void generateAsteroid(Zone currzone) {
        double value = generator.nextDouble();
        if (value < ASTEROIDVARS[zonenumber]) {
                int xloc = generator.nextInt(XSIZE - 60);
                int yloc = generator.nextInt(YSIZE - 55);
                System.out.println(xloc + "  -  " + yloc);
                Asteroid newasteroid = new Asteroid("large");
                newasteroid.setPosition(xloc, yloc);
                currzone.addToObjects(newasteroid);
        }
    }

    /**
     * @param currzone zone
     */
    private static void generateMerchant(Zone currzone) {
        double value = generator.nextDouble();
        if (value < MERCHANTVARS[govtype][zonenumber]) {
            merchantgenerated = true;
            int xloc = generator.nextInt(XSIZE);
            int yloc = generator.nextInt(YSIZE);
            MerchantShip newmerchant = new MerchantShip(govtype);
            newmerchant.setPosition(xloc, yloc);
            currzone.addToObjects(newmerchant);
        }
    }

    /**
     * @param currzone zone
     */
    private static void generatePirate(Zone currzone) {
        double value = generator.nextDouble();
        if (value < PIRATEVARS[govtype][zonenumber]) {
                pirategenerated = true;
                int xloc = generator.nextInt(XSIZE);
                int yloc = generator.nextInt(YSIZE);
                PirateShip newpirate = new PirateShip();
                newpirate.setPosition(xloc, yloc);
                currzone.addToObjects(newpirate);
        }
    }

    /**
     * @param currzone c
     */
    private static void generatePolice(Zone currzone) {
        double value = generator.nextDouble();
        if (value < POLICEVARS[govtype][zonenumber]) {
                int xloc = generator.nextInt(XSIZE);
                int yloc = generator.nextInt(YSIZE);
                PoliceShip newpolice = new PoliceShip();
                newpolice.setPosition(xloc, yloc);
                currzone.addToObjects(newpolice);
        }
    }

}