package edu.cs2335.SWATLP.client.spacegame;

import javax.swing.ImageIcon;

/**
 * @author macguy <p/>
 */
public class Bullet extends ScreenObject {

    /**
     * Comment for <code>firing</code>
     */
    private boolean firing;

    /**
     *  
     */
    public Bullet() {
        super("bullet");
        objectimage = new ImageIcon("pics/approach/bullet.png").getImage();
        firing = true;
        setRadius();
    }

    /**
     * Sets the bullet to be firing or not
     * @param firing  firing?
     */
    public void setFiring(boolean firing) {
        this.firing = firing;
    }
    
    /** (non-Javadoc)
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject#tick()
     */
    public void tick() {
        double newX = xloc + xspeed;

        double newY = yloc + yspeed;

        //wraping around the screen
        if (newX < 0) {
            newX += maxX;
        }
        if (newX > maxX) {
            newX -= maxX;
        }
        if (newY > maxY) {
            firing = false;
        }
        if (newY < 0)  {
            firing = false;
        }
        setPosition(newX, newY);
    }
    
    /** (non-Javadoc)
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     * #takeDamage(int)
     */
    public int takeDamage(int damageDone) {
        return 0;
    }

    /**
     * @return Returns the firing.
     */
    public boolean isFiring() {
        return firing;
    }

    /** (non-Javadoc)
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     * #operateAI(edu.cs2335.SWATLP.client.spacegame.PlayerShip)
     */
    public boolean operateAI(PlayerShip playership) {
        return true;
    }
}