package edu.cs2335.SWATLP.client.spacegame;

import java.util.Random;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.server.port.TradeGood;

/**
 * Cargo
 */
public class Cargo extends ScreenObject {

    /** the trade good of the cargo */
    private TradeGood good;

    /**
     * Cargo Constructor
     * @param good the good in the cargo
     */
    public Cargo(TradeGood good) {
        super("cargo");
        this.good = good;
        objectimage = new ImageIcon("pics/approach/cargo.png").getImage();
        //dirfacing = Math.PI / 2;

        setRadius();
        Random randomizer = new Random(System.currentTimeMillis());
        turningspeed = 0.02;
        accelerating = false;
        turningleft = false;
        turningright = false;
        int xneg = randomizer.nextInt(2);
        int yneg = randomizer.nextInt(2);
        xspeed = Math.random();
        yspeed = Math.random();
        if (xneg == 1) {
            xspeed = -xspeed;
        }
        if (yneg == 1) {
            yspeed = -yspeed;
        }
    }

    /** (non-Javadoc)
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     * #operateAI(edu.cs2335.SWATLP.client.spacegame.PlayerShip)
     */
    public boolean operateAI(PlayerShip playership) {
        return true;
    }
    
    /** (non-Javadoc)
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     * #takeDamage(int)
     */
    public int takeDamage(int damageDone) {
        return 0;
    }

    /**
     * @return Returns the good.
     */
    public TradeGood getGood() {
        return good;
    }
    /**
     * @param good The good to set.
     */
    public void setGood(TradeGood good) {
        this.good = good;
    }
}