/*
 * Created on Apr 6, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.spacegame;

import java.awt.Color;
import java.awt.Graphics2D;
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.server.port.TradeGood;

/**
 * @author jonathan <p/>
 */
public class MerchantShip extends ScreenObject {

    /**
     * Comment for <code>asking</code>
     */
    private boolean asking;
    
    /**
     * Comment for <code>playerShip</code>
     */
    private PlayerShip playerShip;
    
    /**
     * Comment for <code>lastTurn</code>
     */
    private int lastTurn;
    
    /**
     * Comment for <code>asked</code>
     */
    private boolean asked;
    
    /**
     * Comment for <code>running</code>
     */
    private boolean running;
    
    /**
     * The merchant's trade goods.
     */
    private List cargo;

    /**
     * Comment for <code>trade</code>
     */
    private boolean trade;

    /**
     * @return Returns the trade.
     */
    public boolean isTrade() {
        return trade;
    }
    /**
     * @param trade The trade to set.
     */
    public void setTrade(boolean trade) {
        this.trade = trade;
    }
    /** exploding? */
    private boolean exploding;

    /**
     * MerchantShip Constructor
     * @param govtype   gov for cargo gen
     */
    public MerchantShip(int govtype) {
        super("merchant");
        cargo = generateCargo(govtype);
        trade = false;
        objectimage = new ImageIcon("pics/approach/merchant.png").getImage();
        turningspeed = 0.03;
        dirfacing = (Math.random() * Math.PI * 2);
        exploding = false;
        hitpoints = 200;
        setRadius();
        running = false;
        this.maxspeed = 5;
        asked = false;
        asking = false;
    }


    /**
     * @return cargo
     * @param govtype   gov for cargo gen
     */
    private List generateCargo(int govtype) {
        List cargos = new ArrayList();
        Random rand = new Random(System.currentTimeMillis());
        // Anarchy
        if (govtype == 0) {
            switch (rand.nextInt(3)) {
            case 0:
                cargos.add(new TradeGood("MMM", 1 + rand.nextInt(5)));
                break;
            case 1:
                cargos.add(new TradeGood("WEAPONS", 1 + rand.nextInt(5)));
                break;
            case 2:
                cargos.add(new TradeGood("MMM", 1 + rand.nextInt(5)));
                cargos.add(new TradeGood("WEAPONS", 1 + rand.nextInt(5)));
                break;
            default:
                break;
        }
        // Capitalism
        } else if (govtype == 1) {
            switch (rand.nextInt(8)) {
                case 0:
                    cargos.add(new TradeGood("GAME", 1 + rand.nextInt(5)));
                    break;
                case 1:
                    cargos.add(new TradeGood("ORE", 1 + rand.nextInt(5)));
                    break;
                case 2:
                    cargos.add(new TradeGood("FOOD", 1 + rand.nextInt(5)));
                    break;
                case 3:
                    cargos.add(new TradeGood("WATER", 1 + rand.nextInt(5)));
                    break;
                case 4:
                    cargos.add(new TradeGood("MEDICINE", 1 + rand.nextInt(5)));
                    break;
                case 5:
                    cargos.add(new TradeGood("ROBOTS", 1 + rand.nextInt(5)));
                    break;
                case 6:
                    cargos.add(new TradeGood("MMM", 1 + rand.nextInt(5)));
                    break;
                case 7:
                    cargos.add(new TradeGood("WEAPONS", 1 + rand.nextInt(5)));
                    break;
                default:
                    break;
            }
        // Communismn
        } else if (govtype == 2) {
            cargos.add(new TradeGood("FOOD", 1 + rand.nextInt(5)));
            cargos.add(new TradeGood("WATER", 1 + rand.nextInt(5)));
        // Cybernetic
        } else if (govtype == 3) {
            cargos.add(new TradeGood("ORE", 1 + rand.nextInt(5)));
            cargos.add(new TradeGood("ROBOTS", 1 + rand.nextInt(2)));
        // Fuedal
        } else if (govtype == 4) {
            switch (rand.nextInt(4)) {
                case 0:
                    cargos.add(new TradeGood("MEDICINE", 1 + rand.nextInt(5)));
                    break;
                case 1:
                    cargos.add(new TradeGood("WEAPONS", 1 + rand.nextInt(5)));
                    break;
                case 2:
                    cargos.add(new TradeGood("WEAPONS", 1 + rand.nextInt(2)));
                    cargos.add(new TradeGood("FOOD", 1 + rand.nextInt(5)));
                    break;
                case 3:
                    cargos.add(new TradeGood("FOOD", 1 + rand.nextInt(2)));
                    cargos.add(new TradeGood("WATER", 1 + rand.nextInt(5)));
                    break;
                default:
                    break;
            }
        // Pacifism
        } else if (govtype == 5) {
            cargos.add(new TradeGood("GAMES", 1 + rand.nextInt(5)));
            cargos.add(new TradeGood("MEDICINE", 1 + rand.nextInt(5)));
        }
        return cargos;
    }

    /**
     * @return Returns the cargo.
     */
    public List getCargo() {
        return cargo;
    }

    /**
     *  
     */
    public void inviteTrade() {
        if (cargo.size() >= 0) {
            trade = true;
        }
    }

    /**
     *  
     */
    public void processTradeOffer() {
        if (cargo.size() > 0) {
            cargo.remove(0);
        }
        trade = false;
    }

    /**
     * @return Returns the trade.
     */
    public boolean isTrading() {
        return trade;
    }

    /**
     * 
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     *      #operateAI(edu.cs2335.SWATLP.client.spacegame.PlayerShip)
     */
    public boolean operateAI(PlayerShip playership) {
        if (playership.getReputation() > 3) {
            running = true;
        }
        playerShip = playership;
        int turn = turnToPlayer(playership);
        shouldTrade(playership);
        boolean initiateTrade = processTradeRequest(playership);
        while (trade) {
            trade = playership.getData().getGui().getDispError();
        }
        if (initiateTrade) {
            System.out.println("We need to implement trading");
        }
        switch (turn) {
        case -1:
            this.setTurningleft(true);
            this.setTurningright(false);
            lastTurn = -1;
            break;
        case 0:
            this.setTurningleft(false);
            this.setTurningright(false);
            lastTurn = 0;
            break;
        case 1:
            this.setTurningleft(false);
            this.setTurningright(true);
            lastTurn = 1;
            break;
        default:
            break;
        } //turn alg

        int ac = shouldAccel(playership);
        switch (ac) {
        case -1:
            this.setBraking(true);
            this.setAccel(false);
            break;
        case 0:
            this.setBraking(false);
            this.setAccel(false);
            break;
        case 1:
            this.setBraking(false);
            this.setAccel(true);
            break;
        default:
            break;
        } //accel alg
        
        //setFiring(shouldFire(playership));
        return true;
    }

    /**
     * @return Returns the exploding.
     */
    public boolean isExploding() {
        return exploding;
    }
    /**
     * explodes
     */
    public void explode() {
        exploding = true;
    }
    

    /**
     * @param damageDone The damage done.
     *  Returns if the ship is alive or not
     * @return dmg done
     */
    public int takeDamage(int damageDone) {
        hitpoints -= damageDone;
        running = true;
        return 0;
    }
    
    /**
     * @param playership
     *            p
     * @return j
     */
    private int shouldAccel(PlayerShip playership) {
        if (asked) {
            return 1;
        }
        
        double xdistance = Math.abs(xloc - playership.getXLoc());
        double ydistance = Math.abs(yloc - playership.getYLoc());
        double distance = Math.sqrt(xdistance * xdistance + ydistance
                * ydistance);

        if (running) {
            return 1;
        }
        
        if (distance > 100) {
            return 1;
        }
        if (distance < 100 && (yspeed > 0.1)) {
            yspeed *= .5;
            if (yspeed < 0.4) {
                yspeed = 0;
            }
            return -1;
        }
        if (distance < 100 && (xspeed > 0.1)) {
            xspeed *= .5;
            if (xspeed < 0.4) {
                xspeed = 0;
            }
            return -1;
        }
        return 0;
    }
    
    /**
     * @param playership
     *            p
     * @return -1 left 0 straight 1 right
     */
    private int turnToPlayer(PlayerShip playership) {
        if (running) {
           this.setDirfacing(Math.PI / 2);
           return 0;
        }
        
        if (asked) {
            if (Math.random() > 0.75) {
                 return ((int) (Math.random() * 3)) - 1;
            } else {
                return lastTurn;
            }
        }
        
        double xdistance = Math.abs(xloc - playership.getXLoc());
        double ydistance = Math.abs(yloc - playership.getYLoc());
        //double distance = Math.sqrt(xdistance * xdistance + ydistance
          //      * ydistance);
        double toPlayer = 0;
        
        double playerX = playership.getXLoc() 
             + playership.getScreenWidth() / 2;
        double playerY = playership.getYLoc() 
             + playership.getScreenHeight() / 2;
        
        if (getYLoc() == playerY) {
            if (getXLoc() > playerX) {
                toPlayer = 0;
            } else {
                toPlayer = Math.PI;
            }
        }
        
        if (getXLoc() == playerX) {
            if (getYLoc() > playerY) {
                toPlayer = 3 * Math.PI / 2;
            } else {
                toPlayer = Math.PI / 2;
            }
        }
        
        if (getXLoc() < playerX) {
            if (getYLoc() < playerY) {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer = Math.PI / 2 - toPlayer;
                toPlayer += 3 * Math.PI / 2;
            } else {
                toPlayer = Math.atan2(ydistance, xdistance);
            }
        }
        
        if (getXLoc() > playerX) {
            if (getYLoc() < playerY) {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer += Math.PI;
            } else {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer = Math.PI / 2 - toPlayer;
                toPlayer += Math.PI / 2;
            }
        }

        if (this.dirfacing > toPlayer) {
            return 1;
        } else if (this.dirfacing < toPlayer) {
            return -1;
        }
        return 0;
    }
    
    /**
     *  
     */
    public void tick() {
        this.maxspeed = 5;
        double accelx;
        double accely;
        if (accelerating || braking) {
             if ((dirfacing > 0) && (dirfacing <= Math.PI / 2)) {
                 accelx = Math.cos(dirfacing) * rateofaccel;
                 accely = -Math.sin(dirfacing) * rateofaccel;
             } else  if ((dirfacing > Math.PI / 2) && (dirfacing <= Math.PI)) {
                 accelx = -Math.cos(Math.PI - dirfacing) * rateofaccel;
                 accely = -Math.sin(Math.PI - dirfacing) * rateofaccel;
             } else  if ((dirfacing > Math.PI) && (dirfacing 
                     <= 3 * Math.PI / 2)) {
                 accelx = -Math.sin((3 * Math.PI / 2)
                         - dirfacing) * rateofaccel;
                 accely = Math.cos((3 * Math.PI / 2) - dirfacing) * rateofaccel;
             } else {
                 accelx = Math.cos(2 * Math.PI - dirfacing) * rateofaccel;
                 accely = Math.sin(2 * Math.PI - dirfacing) * rateofaccel;
             }
             if (Math.sqrt(((yspeed + accely) * (yspeed + accely))
                     + ((xspeed + accelx) * (xspeed + accelx))) <= maxspeed) {
                 if (accelerating) {
                     xspeed += accelx;
                     yspeed += accely;
                 } else {
                     xspeed -= accelx;
                     yspeed -= accely;
                 }
             }
             
        }
        double newX = xloc + xspeed;
        double newY = yloc + yspeed;

        //wraping around the screen
        if (newX <= 0) {
            newX += maxX;
        }
        if (newX >= maxX) {
            newX -= maxX;
        }
        if (newY <= 0) {
            newY += maxY;
        }
        if (newY >= maxY) {
            newY -= maxY;
        }
        if (newY >= maxY) {
            newY = yloc - 2 * (yloc - maxY);
            yspeed = -yspeed / 2;
        }

        setPosition(newX, newY);
    }
    
    /**
     * @param playership p
     * @return trade
     */
    private boolean shouldTrade(PlayerShip playership) {
        double xdistance = Math.abs(xloc - playership.getXLoc());
        double ydistance = Math.abs(yloc - playership.getYLoc());
        double distance = Math.sqrt(xdistance * xdistance + ydistance
                * ydistance);
        if (!asked && distance <= 100 && !running) {
            boolean should = false;
            asked = true;
            asking = true;
            //playership.changeMode(true);
            trade = true;
            String[] msg = {"TRADE REQUESTED"};
            playership.getData().getGui().
                displayErrorBox("TRADE REQUESTED", msg);
            //TODO ask to trade
            return should;
        }
        return false;
    }
    
    /**
     * @param playership the player
     * @return if wants to trade
     */
    private boolean processTradeRequest(PlayerShip playership) {
        if (playership.isTrade() /*&& !asked*/) {
            playership.changeMode(false);
            System.out.println("TRADE");
            if ((Math.random() * 5) > playership.getReputation()) {
                //TODO accept
                trade = true;
                String[] msg = {"TRADE ACCEPTED"};
                playership.getData().getGui().
                    displayErrorBox("TRADE ACCEPTED", msg);
                asked = true;
                //TODO initiate trade
                return true;
            } else if (asking) {
                trade = true;
                asked = true;
                asking = false;
                return true;
            } else {
                trade = true;
                String[] msg = {"TRADE REFUSED"};
                playership.getData().getGui().
                    displayErrorBox("TRADE REFUSED", msg);
                return true;
            }
        }
        return false;
    }
    
    /** (non-Javadoc)
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     * #render(java.awt.Graphics2D)
     */
    public void render(Graphics2D g) {
             double xpos = xloc;
             double ypos = yloc;
             
             int width = objectimage.getWidth(null);
             int height = objectimage.getHeight(null);
             g.translate(xpos + width / 2, ypos + height / 2);
             g.rotate(-dirfacing);
             g.drawImage(objectimage, -width / 2, -height / 2, null);
             g.rotate(dirfacing);
             g.translate(-(xpos + width / 2), -(ypos + height / 2));
             
             if (trade) {
                 g.setColor(Color.GREEN);
                 g.drawOval((int) playerShip.getXLoc() 
                             + playerShip.getScreenWidth() / 2 
                             - playerShip.getRadius(),
                         (int) playerShip.getYLoc()
                             + playerShip.getScreenHeight() / 2 
                             - playerShip.getRadius(), 
                         2 * playerShip.getRadius(),
                         2 * playerShip.getRadius());
             }
         }
    /**
     * @return Returns the asked.
     */
    public boolean isAsked() {
        return asked;
    }
    /**
     * @param asked The asked to set.
     */
    public void setAsked(boolean asked) {
        this.asked = asked;
    }
    /**
     * @return Returns the asking.
     */
    public boolean isAsking() {
        return asking;
    }
    /**
     * @param asking The asking to set.
     */
    public void setAsking(boolean asking) {
        this.asking = asking;
    }
    /**
     * @return Returns the lastTurn.
     */
    public int getLastTurn() {
        return lastTurn;
    }
    /**
     * @param lastTurn The lastTurn to set.
     */
    public void setLastTurn(int lastTurn) {
        this.lastTurn = lastTurn;
    }
    /**
     * @return Returns the playerShip.
     */
    public PlayerShip getPlayerShip() {
        return playerShip;
    }
    /**
     * @param playerShip The playerShip to set.
     */
    public void setPlayerShip(PlayerShip playerShip) {
        this.playerShip = playerShip;
    }
    /**
     * @return Returns the running.
     */
    public boolean isRunning() {
        return running;
    }
    /**
     * @param running The running to set.
     */
    public void setRunning(boolean running) {
        this.running = running;
    }
    /**
     * @param cargo The cargo to set.
     */
    public void setCargo(List cargo) {
        this.cargo = cargo;
    }
    /**
     * @param exploding The exploding to set.
     */
    public void setExploding(boolean exploding) {
        this.exploding = exploding;
    }
}