/*
 * Created on Apr 6, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.spacegame;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.Image;
import java.util.List;

import javax.swing.ImageIcon;

import edu.cs2335.SWATLP.client.clientdata.ApproachData;
import edu.cs2335.SWATLP.server.main.Weapon;

/**
 * @author jonathan <p/>
 */
public class PlayerShip extends ScreenObject {

    /**
     * Comment for <code>currentImage</code>
     */
    private int currentImage;

    /**
     * Comment for <code>objectimage</code>
     */
    private Image objectimage2;

    /**
     * Comment for <code>objectimage</code>
     */
    private Image objectimage3;

    /**
     * Comment for <code>mode</code>
     */
    private String mode;

    /**
     * Comment for <code>transition</code>
     */
    private boolean transition;

    /**
     * @return Returns the transition.
     */
    public boolean isTransition() {
        return transition;
    }

    /**
     * Comment for <code>cargo</code>
     */
    private int cargo = 0;
    /**
     * 
     */
    private boolean living;

    /**
     * Comment for <code>shiptype</code>
     */
    private String shiptype;

    /** approach data */
    private ApproachData data;

    /**
     * Comment for <code>trade</code>
     */
    private boolean trade;

    /**
     * Comment for <code>colliding</code>
     */
    private boolean colliding;

    /**
     * Comment for <code>lastCollided</code>
     */
    private long lastCollided;

    /** fuel */
    private float fuel;

    /**
     * @param shiptype
     *                  s
     * @param thedata
     *                  all the approach data
     */
    public PlayerShip(String shiptype, ApproachData thedata) {
        super("player");
        this.shiptype = shiptype;
        data = thedata;
        fuel = data.getFuelCurrent();
        mode = "peace";
        if (shiptype.equals("Fighter")) {
            objectimage = new ImageIcon("pics/approach/fighter1.png")
                    .getImage();
            objectimage2 = new ImageIcon("pics/approach/fighter2.png")
                    .getImage();
            objectimage3 = new ImageIcon("pics/approach/fighter3.png")
                    .getImage();
        } else if (shiptype.equals("Trader")) {
            objectimage = new ImageIcon("pics/approach/trader1.png")
                    .getImage();
            objectimage2 = new ImageIcon("pics/approach/trader2.png")
                    .getImage();
            objectimage3 = new ImageIcon("pics/approach/trader3.png")
                    .getImage();
        } else if (shiptype.equals("Ultimate")) {
            objectimage = new ImageIcon("pics/approach/ultimate1.png")
                    .getImage();
            objectimage2 = new ImageIcon("pics/approach/ultimate2.png")
                    .getImage();
            objectimage3 = new ImageIcon("pics/approach/ultimate3.png")
                    .getImage();
        } else {
            throw new IllegalArgumentException();
        }
        living = true;
        dirfacing = Math.PI / 2;
        xloc = 300;
        yloc = 560;
        setRadius();
        // Piloting
        rateofaccel = 0.053 + (data.getPiloting() * 0.005); // 0.053
        turningspeed = 0.07 + (data.getPiloting() * 0.02); // 0.09
        maxspeed = 8 + (data.getPiloting()); // 8
        List weapons = data.getWeapons();
        for (int n = 0; n < weapons.size(); n++) {
            Weapon weapon = (Weapon) weapons.get(n);
            // Engineering
            weapon.setProjectileDamage(weapon.getProjectileDamage()
                    + data.getEngineering());
            // Combat
            weapon.setFirerate(weapon.getFirerate() + data.getCombat());
            weapon.setProjectileSpeed(weapon.getProjectileSpeed()
                    + data.getCombat());
            weapon.setProjectileDamage(weapon.getProjectileDamage()
                    + data.getCombat());
        }
        // Engineering
        data.setShieldstrength(data.getShieldstrength()
                + data.getEngineering());
        currentImage = 1;
    }

    /**
     *  
     */
    public void tick() {
        if (System.currentTimeMillis() - lastCollided > 333) {
            colliding = false;
        }
        double accelx;
        double accely;
        if (accelerating || braking) {
            fuel = fuel - 0.02f + (data.getPiloting() * 0.001f);
            if ((dirfacing > 0) && (dirfacing <= Math.PI / 2)) {
                accelx = Math.cos(dirfacing) * rateofaccel;
                accely = -Math.sin(dirfacing) * rateofaccel;
            } else if ((dirfacing > Math.PI / 2) && (dirfacing <= Math.PI)) {
                accelx = -Math.cos(Math.PI - dirfacing) * rateofaccel;
                accely = -Math.sin(Math.PI - dirfacing) * rateofaccel;
            } else if ((dirfacing > Math.PI) && (dirfacing 
                    <= 3 * Math.PI / 2)) {
                accelx = -Math.sin((3 * Math.PI / 2) - dirfacing)
                        * rateofaccel;
                accely = Math.cos((3 * Math.PI / 2) - dirfacing) * rateofaccel;
            } else {
                accelx = Math.cos(2 * Math.PI - dirfacing) * rateofaccel;
                accely = Math.sin(2 * Math.PI - dirfacing) * rateofaccel;
            }
            if (Math.sqrt(((yspeed + accely) * (yspeed + accely))
                    + ((xspeed + accelx) * (xspeed + accelx))) <= maxspeed) {
                if (accelerating) {
                    xspeed += accelx;
                    yspeed += accely;
                } else {
                    xspeed -= accelx;
                    yspeed -= accely;
                }
            }
        }

        double newX = xloc + xspeed;
        double newY = yloc + yspeed;

        //wraping around the screen
        if (newX <= 0) {
            newX += maxX;
        }
        if (newX >= maxX) {
            newX -= maxX;
        }
        if (newY >= maxY) {
            newY = yloc - 2 * (yloc - maxY);
            yspeed = -yspeed / 2;
        }
        if (newY <= 0) {
            transition = true;
        }

        setPosition(newX, newY);
    }

    /**
     * @param state
     *                  war/peace
     */
    public void toggleWarPeace(String state) {
        this.mode = state;
    }

    /**
     *  
     */
    public void resetPosition() {
        xloc = 300;
        yloc = 585;
        transition = false;
    }

    /**
     *  
     */
    public void collect() {
        cargo += 1;
    }

    /**
     * (non-Javadoc)
     * 
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject #setFiring(boolean)
     */
    public void setFiring(boolean firing) {
        this.firing = firing;
    }

    /**
     *  
     */
    public void interact() {
        dirfacing = 1.8;
    }

    /**
     * @return Returns the mode.
     */
    public String getMode() {
        return mode;
    }

    /**
     * @return Returns the cargo.
     */
    public int getCargo() {
        return cargo;
    }

    /**
     * @param g
     *                  g
     */
    public void renderObject(Graphics2D g) {

    }

    /**
     * (non-Javadoc)
     * 
     * @param damage
     *                  EEEEEERAAALLIM!
     * @return 0 good, -1 dead w/ escape pod, -2 lose
     */
    public int takeDamage(int damage) {
        int dmg = damage;
        dmg -= data.getShieldstrength();

        if (dmg <= 0) {
            dmg = 0;
        } else {
            data.setHitpointsCurrent(data.getHitpointsCurrent() - dmg);
            double newhitpoints = data.getHitpointsCurrent();
            if (newhitpoints <= 0) {
                living = false;
                int[] gadgets = data.getGadgets();
                if (gadgets[0] == 2) {
                    data.getGui().updateServer(data, "port", true);
                } else {
                    data.getGui().updateServer(data, "none", false);
                }
            }
        }

        return 0;
    }

    /**
     * @return Returns the living.
     */
    public boolean isLiving() {
        return living;
    }
    /**
     * @param toTrade
     *                  request to trade
     */
    public void changeMode(boolean toTrade) {
        trade = toTrade;
    }

    /**
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     *          #operateAI(edu.cs2335.SWATLP.client.spacegame.PlayerShip)
     */
    public boolean operateAI(PlayerShip playership) {
        return true;
    }

    /**
     * @return the reputation
     */
    public int getReputation() {
        return this.data.getReputation();

    }

    /**
     * @return Returns the trade.
     */
    public boolean isTrade() {
        return trade;
    }

    /**
     * @return the approachdata
     *  
     */
    public ApproachData getData() {
        return data;
    }

    /**
     * (non-Javadoc)
     * 
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     *          #render(java.awt.Graphics2D)
     */
    public void render(Graphics2D g) {
        double xpos = xloc;
        double ypos = yloc;

        if (accelerating) {
            if ((currentImage / 5) % 4 == 0) {
                currentImage++;
                int width = objectimage.getWidth(null);
                int height = objectimage.getHeight(null);
                g.translate(xpos + width / 2, ypos + height / 2);
                g.rotate(-dirfacing);
                g.drawImage(objectimage, -width / 2, -height / 2, null);
                g.rotate(dirfacing);
                g.translate(-(xpos + width / 2), -(ypos + height / 2));
            } else if ((currentImage / 5) % 4 == 1) {
                currentImage++;
                int width = objectimage2.getWidth(null);
                int height = objectimage2.getHeight(null);
                g.translate(xpos + width / 2, ypos + height / 2);
                g.rotate(-dirfacing);
                g.drawImage(objectimage2, -width / 2, -height / 2, null);
                g.rotate(dirfacing);
                g.translate(-(xpos + width / 2), -(ypos + height / 2));
            } else if ((currentImage / 5) % 4 == 2) {
                currentImage++;
                int width = objectimage3.getWidth(null);
                int height = objectimage3.getHeight(null);
                g.translate(xpos + width / 2, ypos + height / 2);
                g.rotate(-dirfacing);
                g.drawImage(objectimage3, -width / 2, -height / 2, null);
                g.rotate(dirfacing);
                g.translate(-(xpos + width / 2), -(ypos + height / 2));
            } else {
                currentImage++;
                int width = objectimage2.getWidth(null);
                int height = objectimage2.getHeight(null);
                g.translate(xpos + width / 2, ypos + height / 2);
                g.rotate(-dirfacing);
                g.drawImage(objectimage2, -width / 2, -height / 2, null);
                g.rotate(dirfacing);
                g.translate(-(xpos + width / 2), -(ypos + height / 2));
            }
        } else {
            currentImage++;
            int width = objectimage.getWidth(null);
            int height = objectimage.getHeight(null);
            g.translate(xpos + width / 2, ypos + height / 2);
            g.rotate(-dirfacing);
            g.drawImage(objectimage, -width / 2, -height / 2, null);
            g.rotate(dirfacing);
            g.translate(-(xpos + width / 2), -(ypos + height / 2));
        }

        if (colliding) {
            g.setColor(Color.RED);
            g.drawOval((int) getXLoc() + getScreenWidth() / 2 - getRadius(),
                    (int) getYLoc() + getScreenHeight() / 2 - getRadius(),
                    2 * getRadius(), 2 * getRadius());
        }
    }

    /**
     * @return Returns the colliding.
     */
    public boolean isColliding() {
        return colliding;
    }

    /**
     * @param colliding
     *                  The colliding to set.
     */
    public void setColliding(boolean colliding) {
        this.colliding = colliding;
    }

    /**
     * @return Returns the lastCollided.
     */
    public long getLastCollided() {
        return lastCollided;
    }

    /**
     * @param lastCollided
     *                  The lastCollided to set.
     */
    public void setLastCollided(long lastCollided) {
        this.lastCollided = lastCollided;
    }

    /**
     * @return Returns the fuel.
     */
    public float getFuel() {
        return fuel;
    }

    /**
     *  
     */
    public void reduceReputation() {
        this.data.setReputation(data.getReputation() + 1);
        System.err.println("REPUTATION REDUCED!!!");
    }
    /**
     * @return Returns the currentImage.
     */
    public int getCurrentImage() {
        return currentImage;
    }
    /**
     * @param currentImage The currentImage to set.
     */
    public void setCurrentImage(int currentImage) {
        this.currentImage = currentImage;
    }
    /**
     * @return Returns the objectimage2.
     */
    public Image getObjectimage2() {
        return objectimage2;
    }
    /**
     * @param objectimage2 The objectimage2 to set.
     */
    public void setObjectimage2(Image objectimage2) {
        this.objectimage2 = objectimage2;
    }
    /**
     * @return Returns the objectimage3.
     */
    public Image getObjectimage3() {
        return objectimage3;
    }
    /**
     * @param objectimage3 The objectimage3 to set.
     */
    public void setObjectimage3(Image objectimage3) {
        this.objectimage3 = objectimage3;
    }
    /**
     * @return Returns the shiptype.
     */
    public String getShiptype() {
        return shiptype;
    }
    /**
     * @param shiptype The shiptype to set.
     */
    public void setShiptype(String shiptype) {
        this.shiptype = shiptype;
    }
    /**
     * @param cargo The cargo to set.
     */
    public void setCargo(int cargo) {
        this.cargo = cargo;
    }
    /**
     * @param data The data to set.
     */
    public void setData(ApproachData data) {
        this.data = data;
    }
    /**
     * @param fuel The fuel to set.
     */
    public void setFuel(float fuel) {
        this.fuel = fuel;
    }
    /**
     * @param mode The mode to set.
     */
    public void setMode(String mode) {
        this.mode = mode;
    }
    /**
     * @param trade The trade to set.
     */
    public void setTrade(boolean trade) {
        this.trade = trade;
    }
    /**
     * @param transition The transition to set.
     */
    public void setTransition(boolean transition) {
        this.transition = transition;
    }
}