package edu.cs2335.SWATLP.client.spacegame;

import java.awt.Graphics2D;
import java.awt.Image;

import javax.swing.ImageIcon;

/**
 * @author jonathan <p/>
 */
public class PoliceShip extends ScreenObject {

    /**
     * Comment for <code>engaged</code>
     */
    private boolean engaged; 
    
    /**
     * Comment for <code>objectimage</code>
     */
    private Image objectimage2;

    /**
     * Comment for <code>currentImage</code>
     */
    private int currentImage;

    /** exploding? */
    private boolean exploding;

    /**
     * Comment for <code>honorable</code>
     */
    private int honorable;

    /**
     * Comment for <code>search</code>
     */
    private boolean search;

    /**
     * Police Constructor
     */
    public PoliceShip() {
        super("police");

        // TODO generate cargo
        objectimage = new ImageIcon("pics/approach/police.png").getImage();
        objectimage2 = new ImageIcon("pics/approach/police2.png").getImage();
        currentImage = 1;
        this.turningspeed = 0.03;
        dirfacing = (Math.random() * Math.PI * 2);
        engaged = false;
        exploding = false;
        setRadius();
        this.setHitpoints(100);
    }

    /**
     *  
     */
    public void fireWeapon() {
        honorable = 1;
    }

    /**
     * @return Returns the honorable.
     */
    public int getHonorable() {
        return honorable;
    }

    /**
     *  
     */
    public void interact() {
        //dirfacing = 45;
    }

    /**
     * @return Returns the search.
     */
    public boolean isSearch() {
        return search;
    }

    /**
     * 
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject
     *      #operateAI(edu.cs2335.SWATLP.client.spacegame.PlayerShip)
     */
    public boolean operateAI(PlayerShip playership) {
        if (playership.getReputation() >= 4) {
            engaged = true;
        }
        int turn = turnToPlayer(playership);
        switch (turn) {
        case -1:
            this.setTurningleft(true);
            this.setTurningright(false);
            break;
        case 0:
            this.setTurningleft(false);
            this.setTurningright(false);
            break;
        case 1:
            this.setTurningleft(false);
            this.setTurningright(true);
            break;
        default:
            break;
        } //turn alg

        int ac = shouldAccel(playership);
        switch (ac) {
        case -1:
            this.setBraking(true);
            this.setAccel(false);
            break;
        case 0:
            this.setBraking(false);
            this.setAccel(false);
            break;
        case 1:
            this.setBraking(false);
            this.setAccel(true);
            break;
        default:
            break;
        } //accel alg

        setFiring(shouldFire(playership));
        return true;
    }

    /**
     * @param amount
     *            a
     * @return amount > 100
     */
    public boolean processBribe(int amount) {
        if (honorable > 2) {
            return false;
        } else {
            return amount > 100;
        }

    }

    /**
     * @param g
     *            g
     */
    public void render(Graphics2D g) {
        double xpos = xloc;
        double ypos = yloc;

        if ((currentImage / 25) % 2 == 0) {
            currentImage++;
            int width = objectimage.getWidth(null);
            int height = objectimage.getHeight(null);
            g.translate(xpos + width / 2, ypos + height / 2);
            g.rotate(-dirfacing);
            g.drawImage(objectimage, -width / 2, -height / 2, null);
            g.rotate(dirfacing);
            g.translate(-(xpos + width / 2), -(ypos + height / 2));
        } else {
            currentImage++;
            int width = objectimage2.getWidth(null);
            int height = objectimage2.getHeight(null);
            g.translate(xpos + width / 2, ypos + height / 2);
            g.rotate(-dirfacing);
            g.drawImage(objectimage2, -width / 2, -height / 2, null);
            g.rotate(dirfacing);
            g.translate(-(xpos + width / 2), -(ypos + height / 2));
        }
    }

    /**
     *  
     */
    public void requestSearch() {
        search = true;
    }

    /**
     * @param honorable
     *            The honorable to set.
     */
    public void setHonorable(int honorable) {
        this.honorable = honorable;
    }

    /**
     * (non-Javadoc)
     * 
     * @see edu.cs2335.SWATLP.client.spacegame.ScreenObject #takeDamage(int)
     */
    public int takeDamage(int damageDone) {
        hitpoints -= damageDone;
        return 0;
    }

    /**
     *  
     */
    public void tick() {

        double accelx;
        double accely;
        if (accelerating || braking) {
             if ((dirfacing > 0) && (dirfacing <= Math.PI / 2)) {
                 accelx = Math.cos(dirfacing) * rateofaccel;
                 accely = -Math.sin(dirfacing) * rateofaccel;
             } else  if ((dirfacing > Math.PI / 2) && (dirfacing <= Math.PI)) {
                 accelx = -Math.cos(Math.PI - dirfacing) * rateofaccel;
                 accely = -Math.sin(Math.PI - dirfacing) * rateofaccel;
             } else  if ((dirfacing > Math.PI) && (dirfacing 
                     <= 3 * Math.PI / 2)) {
                 accelx = -Math.sin((3 * Math.PI / 2)
                         - dirfacing) * rateofaccel;
                 accely = Math.cos((3 * Math.PI / 2) - dirfacing) * rateofaccel;
             } else {
                 accelx = Math.cos(2 * Math.PI - dirfacing) * rateofaccel;
                 accely = Math.sin(2 * Math.PI - dirfacing) * rateofaccel;
             }
             if (Math.sqrt(((yspeed + accely) * (yspeed + accely))
                     + ((xspeed + accelx) * (xspeed + accelx))) <= maxspeed) {
                 if (accelerating) {
                     xspeed += accelx;
                     yspeed += accely;
                 } else {
                     xspeed -= accelx;
                     yspeed -= accely;
                 }
             }
             
        }
        double newX = xloc + xspeed;
        double newY = yloc + yspeed;

        //wraping around the screen
        if (newX <= 0) {
            newX += maxX;
        }
        if (newX >= maxX) {
            newX -= maxX;
        }
        if (newY <= 0) {
            newY += maxY;
        }
        if (newY >= maxY) {
            newY -= maxY;
        }
        if (newY >= maxY) {
            newY = yloc - 2 * (yloc - maxY);
            yspeed = -yspeed / 2;
        }

        setPosition(newX, newY);
    }
    
    /**
     * @param playership
     *            p
     * @return should fire
     */
    private boolean shouldFire(PlayerShip playership) {
        if (playership.getData().getReputation() >= 5) {
            engaged = true;
        }
        double xdistance = Math.abs(xloc - playership.getXLoc());
        double ydistance = Math.abs(yloc - playership.getYLoc());
//        double distance = Math.sqrt(xdistance * xdistance + ydistance
  //              * ydistance);
        double toPlayer = 0;
        
        double playerX = playership.getXLoc() 
             + playership.getScreenWidth() / 2;
        double playerY = playership.getYLoc() 
             + playership.getScreenHeight() / 2;
        
        if (getYLoc() == playerY) {
            if (getXLoc() > playerX) {
                toPlayer = 0;
            } else {
                toPlayer = Math.PI;
            }
        }
        
        if (getXLoc() == playerX) {
            if (getYLoc() > playerY) {
                toPlayer = 3 * Math.PI / 2;
            } else {
                toPlayer = Math.PI / 2;
            }
        }
        
        if (getXLoc() < playerX) {
            if (getYLoc() < playerY) {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer = Math.PI / 2 - toPlayer;
                toPlayer += 3 * Math.PI / 2;
            } else {
                toPlayer = Math.atan2(ydistance, xdistance);
            }
        }
        
        if (getXLoc() > playerX) {
            if (getYLoc() < playerY) {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer += Math.PI;
            } else {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer = Math.PI / 2 - toPlayer;
                toPlayer += Math.PI / 2;
            }
        }
        /*if (toPlayer < 0) {
            toPlayer *= -1;
        }*/
        toPlayer -= this.getDirFacing();
        if (toPlayer < 0.5) {
            //System.out.println(toPlayer);
            //System.out.println("Should shoot");
            return engaged;
        }
        //System.out.println("Should NOT");
        return false;
    }
    
    /**
     * @param playership
     *            p
     * @return j
     */
    private int shouldAccel(PlayerShip playership) {
        double xdistance = Math.abs(xloc - playership.getXLoc());
        double ydistance = Math.abs(yloc - playership.getYLoc());
        double distance = Math.sqrt(xdistance * xdistance + ydistance
                * ydistance);

        if (distance > 100) {
            return 1;
        }
        if (distance < 100 && (yspeed > 0.1)) {
            yspeed *= .5;
            if (yspeed < 0.4) {
                yspeed = 0;
            }
            return -1;
        }
        if (distance < 100 && (xspeed > 0.1)) {
            xspeed *= .5;
            if (xspeed < 0.4) {
                xspeed = 0;
            }
            return -1;
        }
        return 0;
    }
    
    /**
     * @param playership
     *            p
     * @return -1 left 0 straight 1 right
     */
    private int turnToPlayer(PlayerShip playership) {
        double xdistance = Math.abs(xloc - playership.getXLoc());
        double ydistance = Math.abs(yloc - playership.getYLoc());
//        double distance = Math.sqrt(xdistance * xdistance + ydistance
  //              * ydistance);
        double toPlayer = 0;
        
        double playerX = playership.getXLoc() 
             + playership.getScreenWidth() / 2;
        double playerY = playership.getYLoc() 
             + playership.getScreenHeight() / 2;
        
        if (getYLoc() == playerY) {
            if (getXLoc() > playerX) {
                toPlayer = 0;
            } else {
                toPlayer = Math.PI;
            }
        }
        
        if (getXLoc() == playerX) {
            if (getYLoc() > playerY) {
                toPlayer = 3 * Math.PI / 2;
            } else {
                toPlayer = Math.PI / 2;
            }
        }
        
        if (getXLoc() < playerX) {
            if (getYLoc() < playerY) {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer = Math.PI / 2 - toPlayer;
                toPlayer += 3 * Math.PI / 2;
            } else {
                toPlayer = Math.atan2(ydistance, xdistance);
            }
        }
        
        if (getXLoc() > playerX) {
            if (getYLoc() < playerY) {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer += Math.PI;
            } else {
                toPlayer = Math.atan2(ydistance, xdistance);
                toPlayer = Math.PI / 2 - toPlayer;
                toPlayer += Math.PI / 2;
            }
        }

        if (this.dirfacing > toPlayer) {
            return 1;
        } else if (this.dirfacing < toPlayer) {
            return -1;
        }
        return 0;
    }
    /**
     * @return Returns the currentImage.
     */
    public int getCurrentImage() {
        return currentImage;
    }
    /**
     * @param currentImage The currentImage to set.
     */
    public void setCurrentImage(int currentImage) {
        this.currentImage = currentImage;
    }
    /**
     * @return Returns the engaged.
     */
    public boolean isEngaged() {
        return engaged;
    }
    /**
     * @param engaged The engaged to set.
     */
    public void setEngaged(boolean engaged) {
        this.engaged = engaged;
    }
    /**
     * @return Returns the exploding.
     */
    public boolean isExploding() {
        return exploding;
    }
    /**
     * @param exploding The exploding to set.
     */
    public void setExploding(boolean exploding) {
        this.exploding = exploding;
    }
    /**
     * @return Returns the objectimage2.
     */
    public Image getObjectimage2() {
        return objectimage2;
    }
    /**
     * @param objectimage2 The objectimage2 to set.
     */
    public void setObjectimage2(Image objectimage2) {
        this.objectimage2 = objectimage2;
    }
    /**
     * @param search The search to set.
     */
    public void setSearch(boolean search) {
        this.search = search;
    }
}