/*
 * Created on Apr 6, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.client.spacegame;

import java.awt.Graphics2D;
import java.awt.Image;

//import javax.swing.ImageIcon;

/**
 * @author jonathan <p/>
 */
public abstract class ScreenObject {
    /**
     * Comment for <code>fired</code>
     */
    private boolean fired;
    
    /**
     * Comment for <code>firingtimer</code>
     */
    private long firingtimer;
    /**
     * Comment for <code>accelerating</code>
     */
    protected boolean accelerating;
    /**
     * Comment for <code>braking</code>
     */
    protected boolean braking;

    /**
     * Comment for <code>dir</code>
     */
    protected double dirfacing;
    /**
     * Comment for <code>firing</code>
     */
    protected boolean firing;

    /**
     * Comment for <code>mass</code>
     */
    protected int mass;
    
    /**
     * Comment for <code>maxspeed</code>
     */
    protected double maxspeed = 8;
    
    /**
     * Comment for <code>maxX</code>
     */
    protected int maxX = 600;
    
    /**
     * Comment for <code>maxY</code>
     */
    protected int maxY = 600;
    
    /**
     * Comment for <code>objectimage</code>
     */
    protected Image objectimage;

    /**
     * Comment for <code>radius</code>
     */
    protected int radius;
    
    /**
     * Comment for <code>hitpoints</code>
     */
    protected int hitpoints;
    
    /**
     * Comment for <code>rateofaccel</code>
     */
    protected double rateofaccel = 0.053;

    /**
     * Comment for <code>shield</code>
     */
    protected boolean shield;
    /**
     * Comment for <code>turningleft</code>
     */
    protected boolean turningleft;
    /**
     * Comment for <code>turningright</code>
     */
    protected boolean turningright;
    
    /**
     * Comment for <code>turningspeed</code>
     */
    protected double turningspeed;

    /**
     * Comment for <code>type</code>
     */
    protected String type;

    /**
     * Comment for <code>xloc</code>
     */
    protected double xloc;
    
    /**
     * Comment for <code>dir</code>
     */
    protected double xspeed;

    /**
     * Comment for <code>yloc</code>
     */
    protected double yloc;
    /**
     * Comment for <code>yspeed</code>
     */
    protected double yspeed;




    /**
     * @param type
     *            type
     */
    public ScreenObject(String type) {
        this.type = type;
        this.dirfacing = 0;
        this.braking = false;
        this.accelerating = false;
        this.turningleft = false;
        this.turningright = false;
        this.firing = false;
        this.fired = false;
        firingtimer = System.currentTimeMillis();
       // objectimage = new ImageIcon("pics/approach/trader1").getImage();
    }

    /**
     * 
     */
    public void brake() {
        // TODO Auto-generated method stub
        
    }

    /**
     * @param s
     *            to compare with
     * @return collision
     */
    public boolean checkCollision(ScreenObject s) {
        double minRange = (double) radius + (double) s.getRadius();
        double playerxloc = xloc + objectimage.getWidth(null) / 2;
        double playeryloc = yloc + objectimage.getHeight(null) / 2;
        double testxloc = s.getXLoc() + s.getImage().getWidth(null) / 2;
        double testyloc = s.getYLoc() + s.getImage().getHeight(null) / 2;
        double dist = 0;
        double xDist = Math.max(playerxloc, testxloc)
             - Math.min(playerxloc, testxloc);
        double yDist = Math.max(playeryloc, testyloc)
             - Math.min(playeryloc, testyloc);
        dist = Math.sqrt((xDist * xDist) + (yDist * yDist)) * 1.5;
        return dist < minRange;
    }

    /**
     * @return Returns the dir.
     */
    public double getDirFacing() {
        return dirfacing;
    }
    /**
     * @return Returns the firingtimer.
     */
    public long getFiringtimer() {
        return firingtimer;
    }
    /**
     * @return Returns the objectimage.
     */
    public Image getImage() {
        return objectimage;
    }

    /**
     * @return Returns the radius.
     */
    public int getRadius() {
        return radius;
    }
    
    /**
     * @return height
     */
    public int getScreenHeight() {
        return objectimage.getHeight(null);
    }
    
    /**
     * @return width
     */
    public int getScreenWidth() {
        return objectimage.getWidth(null);
    }

    /**
     * @return Returns the xloc.
     */
    public double getXLoc() {
        return xloc;
    }

    /**
     * @return Returns the speed.
     */
    public double getXSpeed() {
        return xspeed;
    }

    /**
     * @return Returns the yloc.
     */
    public double getYLoc() {
        return yloc;
    }
    
    /**
     * @return speed
     */
    public double getYSpeed() {
        return yspeed;
    }
    
    /**
     * @return Returns the firstbullet.
     */
    public boolean hasFired() {
        return fired;
    }
    
    /**
     * @return Returns the hasfiredonce.
     */
    public boolean hasFiredOnce() {
        return fired;
    }
    /**
     * @return Returns the firing.
     */
    public boolean isFiring() {
        return firing;
    }

    /**
     * @return Returns the turningleft.
     */
    public boolean isTurningleft() {
        return turningleft;
    }
    /**
     * @return Returns the turningright.
     */
    public boolean isTurningright() {
        return turningright;
    }

    /**
     * @param playership p
     * @return if the AI ran
     */
    public abstract boolean operateAI(PlayerShip playership);
    
    /**
     * @param g graphics
     */
    public void render(Graphics2D g) {
   //     ImageObserver ob = new ImageObserver();
        double xpos = xloc;
        double ypos = yloc;
        
        int width = objectimage.getWidth(null);
        int height = objectimage.getHeight(null);
        g.translate(xpos + width / 2, ypos + height / 2);
        g.rotate(-dirfacing);
        g.drawImage(objectimage, -width / 2, -height / 2, null);
        g.rotate(dirfacing);
        g.translate(-(xpos + width / 2), -(ypos + height / 2));
        
      /*          g.rotate(-dirfacing, 
                        (double) xpos + objectimage.getWidth(null) / 2, 
                        (double) ypos + objectimage.getHeight(null) / 2);
            g.drawImage(objectimage, (int) xpos, (int) ypos, null);
                g.rotate(dirfacing, 
                        (double) xpos + objectimage.getWidth(null) / 2, 
                        (double) ypos + objectimage.getHeight(null) / 2);
                        
                        */
    }
    
    /**
     *  @param val v
     */
    public void setAccel(boolean val) {
        accelerating = val;
    }
    
    /**
     * @param val v 
     */
    public void setBraking(boolean val) {
        braking = val;
    }
    
    
    /**
     * @param dirfacing The dirfacing to set.
     */
    public void setDirfacing(double dirfacing) {
        this.dirfacing = dirfacing;
    }
    
    
    /**
     * @param fired fired.
     */
    public void setFired(boolean fired) {
        this.fired = fired;
    }
    
    
    /**
     * @param firing The firing to set.
     */
    public void setFiring(boolean firing) {
        this.firing = firing;
    }
    /**
     * @param firingtimer The firingtimer to set.
     */
    public void setFiringtimer(long firingtimer) {
        this.firingtimer = firingtimer;
    }
    /**
     * @param hasfiredonce The hasfiredonce to set.
     */
    public void setHasFiredOnce(boolean hasfiredonce) {
        this.fired = hasfiredonce;
    }

    /**
     * @param x
     *            x pos
     * @param y
     *            y pos
     */
    public void setPosition(double x, double y) {
        xloc = x;
        yloc = y;
    }
    
    /**
     * 
     */
    public void setRadius() {
        int width = objectimage.getWidth(null);
        int height = objectimage.getHeight(null);
        radius = Math.max(width, height);
    }

    /**
     * @param shield
     *            The shield to set.
     */
    public void setShield(boolean shield) {
        this.shield = shield;
    }
   

    /**
     * @param turningleft The turningleft to set.
     */
    public void setTurningleft(boolean turningleft) {
        this.turningleft = turningleft;
    }
    /**
     * @param turningright The turningright to set.
     */
    public void setTurningright(boolean turningright) {
        this.turningright = turningright;
    }
    /**
     * @param xSpeed The xspeed to set.
     */
    public void setXSpeed(double xSpeed) {
        this.xspeed = xSpeed;
    }
    /**
     * @param ySpeed The yspeed to set.
     */
    public void setYSpeed(double ySpeed) {
        this.yspeed = ySpeed;
    }

    /**
     *  
     */
    public void tick() {
        
        double newX = xloc + xspeed;

        double newY = yloc + yspeed;

        //wraping around the screen
        if (newX < 0) {
            newX += maxX;
        }
        if (newX > maxX) {
            newX -= maxX;
        }
        if (newY > maxY) {
            newY = 3;
        }
        if (newY < 0)  {
            newY = yloc + maxY;
        }
        setPosition(newX, newY);
    }
    
    /**
     * 
     */
    public void turnLeft() {
        if (dirfacing + turningspeed > 2 * Math.PI) {
            dirfacing = turningspeed - (2 * Math.PI - dirfacing);
        } else {
            dirfacing += turningspeed;
        }
    }
    
    /**
     * @return Returns the hitpoints.
     */
    public int getHitpoints() {
        return hitpoints;
    }
    /**
     * @param damage dmg
     * @return  alive,dead,dead
     */
    public abstract int takeDamage(int damage);
    

    /**
     * 
     */
    public void turnRight() {
        if (dirfacing - turningspeed < 0) {
            dirfacing = 2 * Math.PI - (turningspeed - dirfacing);
        } else {
            dirfacing -= turningspeed;
        } 
    }

    /**
     * @return Returns the accelerating.
     */
    public boolean isAccelerating() {
        return accelerating;
    }
    /**
     * @param accelerating The accelerating to set.
     */
    public void setAccelerating(boolean accelerating) {
        this.accelerating = accelerating;
    }
    /**
     * @return Returns the mass.
     */
    public int getMass() {
        return mass;
    }
    /**
     * @param mass The mass to set.
     */
    public void setMass(int mass) {
        this.mass = mass;
    }
    /**
     * @return Returns the maxspeed.
     */
    public double getMaxspeed() {
        return maxspeed;
    }
    /**
     * @param maxspeed The maxspeed to set.
     */
    public void setMaxspeed(double maxspeed) {
        this.maxspeed = maxspeed;
    }
    /**
     * @return Returns the maxX.
     */
    public int getMaxX() {
        return maxX;
    }
    /**
     * @param maxX The maxX to set.
     */
    public void setMaxX(int maxX) {
        this.maxX = maxX;
    }
    /**
     * @return Returns the maxY.
     */
    public int getMaxY() {
        return maxY;
    }
    /**
     * @param maxY The maxY to set.
     */
    public void setMaxY(int maxY) {
        this.maxY = maxY;
    }
    /**
     * @return Returns the objectimage.
     */
    public Image getObjectimage() {
        return objectimage;
    }
    /**
     * @param objectimage The objectimage to set.
     */
    public void setObjectimage(Image objectimage) {
        this.objectimage = objectimage;
    }
    /**
     * @return Returns the rateofaccel.
     */
    public double getRateofaccel() {
        return rateofaccel;
    }
    /**
     * @param rateofaccel The rateofaccel to set.
     */
    public void setRateofaccel(double rateofaccel) {
        this.rateofaccel = rateofaccel;
    }
    /**
     * @return Returns the turningspeed.
     */
    public double getTurningspeed() {
        return turningspeed;
    }
    /**
     * @param turningspeed The turningspeed to set.
     */
    public void setTurningspeed(double turningspeed) {
        this.turningspeed = turningspeed;
    }
    /**
     * @return Returns the type.
     */
    public String getType() {
        return type;
    }
    /**
     * @param type The type to set.
     */
    public void setType(String type) {
        this.type = type;
    }
    /**
     * @return Returns the xloc.
     */
    public double getXloc() {
        return xloc;
    }
    /**
     * @param xloc The xloc to set.
     */
    public void setXloc(double xloc) {
        this.xloc = xloc;
    }
    /**
     * @return Returns the xspeed.
     */
    public double getXspeed() {
        return xspeed;
    }
    /**
     * @param xspeed The xspeed to set.
     */
    public void setXspeed(double xspeed) {
        this.xspeed = xspeed;
    }
    /**
     * @return Returns the yloc.
     */
    public double getYloc() {
        return yloc;
    }
    /**
     * @param yloc The yloc to set.
     */
    public void setYloc(double yloc) {
        this.yloc = yloc;
    }
    /**
     * @return Returns the yspeed.
     */
    public double getYspeed() {
        return yspeed;
    }
    /**
     * @param yspeed The yspeed to set.
     */
    public void setYspeed(double yspeed) {
        this.yspeed = yspeed;
    }
    /**
     * @return Returns the braking.
     */
    public boolean isBraking() {
        return braking;
    }
    /**
     * @return Returns the dirfacing.
     */
    public double getDirfacing() {
        return dirfacing;
    }
    /**
     * @return Returns the shield.
     */
    public boolean isShield() {
        return shield;
    }
    /**
     * @return Returns the fired.
     */
    public boolean isFired() {
        return fired;
    }
    /**
     * @param hitpoints The hitpoints to set.
     */
    public void setHitpoints(int hitpoints) {
        this.hitpoints = hitpoints;
    }
    /**
     * @param radius The radius to set.
     */
    public void setRadius(int radius) {
        this.radius = radius;
    }
}