/*
 * Created on Apr 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.server.main;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.Socket;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

/**
 * @author macguy <p/>TODO To change the template for this generated type
 *         comment go to Window - Preferences - Java - Code Style - Code
 *         Templates
 */
public class ServerGUI extends JFrame {

    /** Button for saving the game. */
    private JButton savegame;

    /** Button for broadcasting a message. */
    private JButton broadcast;

    /** Button for starting/shutting down the server. */
    private JButton activate;
    
    /** Button for quitting the servergui. */
    private JButton quit;
    
    /**
     * Comment for <code>message</code>
     */
    private JTextField message;
    /**
     * Comment for <code>port</code>
     */
    private JTextField port;
    
    /**
     * Comment for <code>portlabel</code>
     */
    private JLabel portlabel;
    
    /**
     * Comment for <code>topbuttons</code>
     */
    private JPanel topbuttons;
    /**
     * Comment for <code>chatpane</code>
     */
    private JPanel chatpane;
    
    /**
     * Comment for <code>server</code>
     */
    private Server server;
    /**
     * Comment for <code>window</code>
     */
    private ServerGUI window;
    /**
     * Comment for <code>running</code>
     */
    private boolean running;
    /**
     * Comment for <code>portnum</code>
     */
    private int portnum;
    
    /**
     * 
     */
    public ServerGUI() {
        super("SWATLP Server");
        int screenwidth = Toolkit.getDefaultToolkit().getScreenSize().width;
        int screenheight = Toolkit.getDefaultToolkit().getScreenSize().height;
        running = false;
        window = this;
        setLocation((screenwidth - 480) / 2, (screenheight - 200) / 2);
        setResizable(false);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                quit();
            }
        });
        topbuttons = new JPanel();
        chatpane = new JPanel();
        savegame = new JButton("Save Game");
        savegame.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent act) {
                if (running) {
                server.saveGame();
                }
            }
        });
        broadcast = new JButton("Broadcast");
        broadcast.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent act) {
                broadcastMessage();
            }
        });
        activate = new JButton("Start Server");
        activate.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent act) {
                activateServer();
            }
        });
        quit = new JButton("Quit");
        quit.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent act) {
                quit();
            }
        });
        portlabel = new JLabel("Port:");
        message = new JTextField();
        message.setPreferredSize(new Dimension(350, 25));
        port = new JTextField();
        port.setPreferredSize(new Dimension(50, 25));
        port.setText("30303");
        topbuttons.add(activate);
        topbuttons.add(savegame);
        topbuttons.add(quit);
        topbuttons.add(portlabel);
        topbuttons.add(port);
        chatpane.add(message);
        chatpane.add(broadcast);
        getContentPane().setLayout(
                new BoxLayout(getContentPane(), BoxLayout.PAGE_AXIS));
        getContentPane().add(topbuttons);
        getContentPane().add(chatpane);
        pack();
    }
    
    /**
     * 
     */
    private void quit() {
        if (running) {
            server.shutdownServer();
        }
        window.dispose();
    }
    
    /**
     * 
     */
    private void activateServer() {
        if (running) {
            try {
                Socket shutdownsocket = new Socket("localhost", portnum);
                PrintWriter output = new PrintWriter(shutdownsocket
                        .getOutputStream());
                output.println("EXIT");
                output.close();
                shutdownsocket.close();
            } catch (IOException e) {
                return;
            }
            running = false;
            activate.setText("Start Server");
        } else {
            try {
                portnum = Integer.parseInt(port.getText());
                if (portnum < 1 || portnum > 65535) {
                    throw new NumberFormatException();
                }
            } catch (NumberFormatException e) {
                displayError("Invalid Port",
                "Enter a number between 1 and 65535.");
                return;
            }
            server = new Server();
            server.setPortnum(portnum);
            Thread serverthread = new Thread(server);
            serverthread.start();
            running = true;
            activate.setText("Stop Server");
        }
    }
    
    /**
     * 
     */
    public void broadcastMessage() {
        if (running && !message.getText().equals("")) {
            server.sendMessage("MAINMSG~Server Message: ~" + message.getText());
        }
    }
    
    /**
     * Displays an error message
     * @param titl  the category of the error
     * @param errormessage  the errormessage to display
     */
    public void displayError(String titl, String errormessage) {
        if (JOptionPane.
                showConfirmDialog(window,
                                  errormessage,
                                  titl,
                                  JOptionPane.DEFAULT_OPTION,
                                  JOptionPane.ERROR_MESSAGE)
                == JOptionPane.YES_OPTION) {
                return;
        }
    }
    
    /**
     * @param args a
     */
    public static void main(String[] args) {
        ServerGUI thegui = new ServerGUI();
        thegui.setVisible(true);
    }
    /**
     * @return Returns the activate.
     */
    public JButton getActivate() {
        return activate;
    }
    /**
     * @param activate The activate to set.
     */
    public void setActivate(JButton activate) {
        this.activate = activate;
    }
    /**
     * @return Returns the broadcast.
     */
    public JButton getBroadcast() {
        return broadcast;
    }
    /**
     * @param broadcast The broadcast to set.
     */
    public void setBroadcast(JButton broadcast) {
        this.broadcast = broadcast;
    }
    /**
     * @return Returns the chatpane.
     */
    public JPanel getChatpane() {
        return chatpane;
    }
    /**
     * @param chatpane The chatpane to set.
     */
    public void setChatpane(JPanel chatpane) {
        this.chatpane = chatpane;
    }
    /**
     * @return Returns the message.
     */
    public JTextField getMessage() {
        return message;
    }
    /**
     * @param message The message to set.
     */
    public void setMessage(JTextField message) {
        this.message = message;
    }
    /**
     * @return Returns the port.
     */
    public JTextField getPort() {
        return port;
    }
    /**
     * @param port The port to set.
     */
    public void setPort(JTextField port) {
        this.port = port;
    }
    /**
     * @return Returns the portlabel.
     */
    public JLabel getPortlabel() {
        return portlabel;
    }
    /**
     * @param portlabel The portlabel to set.
     */
    public void setPortlabel(JLabel portlabel) {
        this.portlabel = portlabel;
    }
    /**
     * @return Returns the portnum.
     */
    public int getPortnum() {
        return portnum;
    }
    /**
     * @param portnum The portnum to set.
     */
    public void setPortnum(int portnum) {
        this.portnum = portnum;
    }
    /**
     * @return Returns the quit.
     */
    public JButton getQuit() {
        return quit;
    }
    /**
     * @param quit The quit to set.
     */
    public void setQuit(JButton quit) {
        this.quit = quit;
    }
    /**
     * @return Returns the running.
     */
    public boolean isRunning() {
        return running;
    }
    /**
     * @param running The running to set.
     */
    public void setRunning(boolean running) {
        this.running = running;
    }
    /**
     * @return Returns the savegame.
     */
    public JButton getSavegame() {
        return savegame;
    }
    /**
     * @param savegame The savegame to set.
     */
    public void setSavegame(JButton savegame) {
        this.savegame = savegame;
    }
    /**
     * @return Returns the server.
     */
    public Server getServer() {
        return server;
    }
    /**
     * @param server The server to set.
     */
    public void setServer(Server server) {
        this.server = server;
    }
    /**
     * @return Returns the topbuttons.
     */
    public JPanel getTopbuttons() {
        return topbuttons;
    }
    /**
     * @param topbuttons The topbuttons to set.
     */
    public void setTopbuttons(JPanel topbuttons) {
        this.topbuttons = topbuttons;
    }
    /**
     * @return Returns the window.
     */
    public ServerGUI getWindow() {
        return window;
    }
    /**
     * @param window The window to set.
     */
    public void setWindow(ServerGUI window) {
        this.window = window;
    }
}