package edu.cs2335.SWATLP.server.main;

import java.io.Serializable;

/**
 * Kernel behind the weapons
 */
public class Weapon implements Serializable {

    /** Name of the weapon. */
    private String name;

    /** Firing rate of the weapon. */
    private int firerate;

    /** Angle of the spread between bullets. */
    private int spreadangle;

    /** Number of simultaneous bullets. */
    private int bullets;

    /** Number of gunslots it takes up. */
    private int gunslots;

    /** Projectile speed. */
    private int projectileSpeed;

    /** Projectile damage. */
    private int projectileDamage;

    /**
     * Weapon Constructor
     * 
     * @param name
     *            name of the weapon
     */
    public Weapon(String name) {
        this.name = name;
        if (name.equals("cannon")) {
            firerate = 1;
            spreadangle = 0;
            bullets = 1;
            gunslots = 1;
            projectileSpeed = 5;
            projectileDamage = 15;
        } else if (name.equals("Ultimate")) {
            firerate = 5;
            spreadangle = 5;
            bullets = 3;
            gunslots = 10;
            projectileSpeed = 10;
            projectileDamage = 50;
        }
    }

    /**
     * @return Returns the gun name.
     */
    public String getName() {
        return name;
    }

    /**
     * @return Returns the firerate.
     */
    public int getFirerate() {
        return firerate;
    }

    /**
     * @return Returns the spreadangle.
     */
    public int getSpreadangle() {
        return spreadangle;
    }

    /**
     * @return Returns the number of bullets.
     */
    public int getBullets() {
        return bullets;
    }

    /**
     * @return Returns the gunslots the weapon takes up.
     */
    public int getGunslots() {
        return gunslots;
    }
    /**
     * @param bullets The bullets to set.
     */
    public void setBullets(int bullets) {
        this.bullets = bullets;
    }
    /**
     * @param firerate The firerate to set.
     */
    public void setFirerate(int firerate) {
        this.firerate = firerate;
    }
    /**
     * @param gunslots The gunslots to set.
     */
    public void setGunslots(int gunslots) {
        this.gunslots = gunslots;
    }
    /**
     * @param name The name to set.
     */
    public void setName(String name) {
        this.name = name;
    }
    /**
     * @param spreadangle The spreadangle to set.
     */
    public void setSpreadangle(int spreadangle) {
        this.spreadangle = spreadangle;
    }
    /**
     * @return Returns the projectileDamage.
     */
    public int getProjectileDamage() {
        return projectileDamage;
    }
    /**
     * @param projectileDamage The projectileDamage to set.
     */
    public void setProjectileDamage(int projectileDamage) {
        this.projectileDamage = projectileDamage;
    }
    /**
     * @return Returns the projectileSpeed.
     */
    public int getProjectileSpeed() {
        return projectileSpeed;
    }
    /**
     * @param projectileSpeed The projectileSpeed to set.
     */
    public void setProjectileSpeed(int projectileSpeed) {
        this.projectileSpeed = projectileSpeed;
    }
}