/*
 * Created on Apr 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.server.port;

import edu.cs2335.SWATLP.server.main.Player;

/**
 * @author macguy <p/>TODO To change the template for this generated type
 *         comment go to Window - Preferences - Java - Code Style - Code
 *         Templates
 */
public class Bank {

    /**
     * Bank Constructor
     */
    private Bank() {
    }

    /**
     * Checks the current balance of the player.
     * 
     * @param aplayer
     *            bankaccount
     * @return bankaccount
     */
    public static int checkBalance(Player aplayer) {
        return aplayer.getBankaccount();
    }

    /**
     * Deposits money into the player's bank account.
     * 
     * @param depositor
     *            The player depositing money.
     * @param amount
     *            The amount of money being deposited.
     */
    public static void deposit(Player depositor, int amount) {
        depositor.depositMoneyIntoBank(amount);
    }

    /**
     * Withdraws money from the player's bank account.
     * 
     * @param aplayer
     *            The player withdrawing money.
     * @param amount
     *            The amount of money being withdrawn.
     */
    public static void withdraw(Player aplayer, int amount) {
        aplayer.withdrawMoneyFromBank(amount);
    }

    /**
     * Offers a loan to the player.
     * 
     * @param aplayer
     *            a
     * @return loan
     */
    public static boolean canGetLoan(Player aplayer) {
        if (aplayer.getReputation() <= 2) {
            return true;
        }

        return false;
    }

    /**
     * Takes a loan out from the bank.
     * @param aplayer  the player
     * @param amount   the amount of the loan
     */
    public static void takeALoan(Player aplayer, int amount) {
        aplayer.addMoney(amount);
        aplayer.setDebt(amount);
    }

    /**
     * Charges a 10% fee on the loan every time the player warps
     * 
     * @param aplayer
     *            The player who's being charged.
     * @return amount
     */
    public static int loanFeeCharge(Player aplayer) {
        int amounttopay = aplayer.getDebt() / 10;
        int cash = aplayer.getCashonhand();
        int bank = aplayer.getBankaccount();
        if (cash >= amounttopay) {
            aplayer.setCashonhand(cash - amounttopay);
            return amounttopay;
        } else if (cash < amounttopay && cash + bank >= amounttopay) {
            aplayer.setBankaccount(aplayer.getBankaccount()
                    - (amounttopay - cash));
            aplayer.setCashonhand(0);
            return amounttopay;
        } else {
            // police attempt to capture you, your rep goes up 1
            // IF police catch, the ship is sold (net worth)... gadgets and all
            //    and that money is used to pay off the loan owed to the bank.
            //    You are fined by police also and then given your remaining
            //    credits and provided a basic ship
            // IF police catch and the ship being sold does not pay off the
            //    loan then you start the game over at your home port
            aplayer.setReputation(aplayer.getReputation() + 1);
            return -1;
        }
    }

    /**
     * Pay off a debt from the bank.
     * 
     * @param debtor
     *            The player who has a debt.
     * @param amt the amt to pay off
     */
    public static void payDebt(Player debtor, int amt) {
        debtor.payDebt(amt);
        
    }
}