/*
 * Created on Apr 7, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package edu.cs2335.SWATLP.server.port;

import edu.cs2335.SWATLP.server.main.Player;
import edu.cs2335.SWATLP.server.main.Ship;

/**
 * @author macguy <p/>TODO To change the template for this generated type
 *         comment go to Window - Preferences - Java - Code Style - Code
 *         Templates
 */
public class Marketplace {

    /**
     * Marketplace Constructor
     */
    private Marketplace() {
    }

    /**
     * Buys a good from the marketplace.
     * 
     * @param buyer
     *            The player buying the good.
     * @param goodtype
     *            The type of good being purchased.
     * @param amount
     *            The amount of good being purchased.
     * @param price
     *            The price of the good.
     */
    public static void buyGood(Player buyer, String goodtype, int amount,
            int price) {
        Ship theship = buyer.getShip();

        // if the trade good is already on the ship
        for (int n = 0; n < theship.getCargo().size(); n++) {
            TradeGood good = ((TradeGood) theship.getCargo().get(n));
            String type = good.getGoodtype();
            if (type.equals(goodtype)) {
                int newamnt = good.getAmount() + amount;
                if (amount + theship.getCargo().size() 
                        > theship.getCargoSize()) {
                    // not enough space on the ship
                    return;
                } else {
                    int temp = price;
                    if (buyer.spend(temp * amount) == 0) {
                        good.setAmount(newamnt);
                        return;
                    } else {
                        // not enough $$$
                        return;
                    }
                }
            }
        }

        // if the trade good was not on the ship
        buyer.spend(price * amount);
        buyer.getShip().addToCargo(new TradeGood(goodtype, amount));
        //return;
    }

    /**
     * Sells a good to the marketplace.
     * 
     * @param seller
     *            The player selling the good.
     * @param goodtype
     *            The type of being sold.
     * @param amount
     *            The amount of the good being sold.
     * @param price
     *            The price of the good.
     */
    public static void sellGood(Player seller, String goodtype, int amount,
            int price) {
        Ship theship = seller.getShip();

        for (int n = 0; n < theship.getCargo().size(); n++) {
            TradeGood good = ((TradeGood) theship.getCargo().get(n));
            String type = good.getGoodtype();
            if (type.equals(goodtype)) {
                int newamnt = good.getAmount() - amount;
                if (newamnt < 0) {
                    // TODO error, cannot sell more than you have
                    return;
                }
                good.setAmount(newamnt);
                seller.addMoney(price * amount);
                return;
            }
        }
    }
}