package edu.cs2335.SWATLP.server.port;

import java.io.Serializable;

/**
 * The trade good
 */
public class TradeGood implements Serializable {

    /** The type of good. */
    private String goodtype;

    /** The amount of the good. */
    private int amount;

    /**
     * TradeGood Constructor
     * 
     * @param type
     *            The type of good.
     * @param amount
     *            The amount of the good.
     */
    public TradeGood(String type, int amount) {
        goodtype = type;
        this.amount = amount;
    }

    /**
     * @return Returns the amount.
     */
    public int getAmount() {
        return amount;
    }

    /**
     * @param amount
     *            The amount to set.
     */
    public void setAmount(int amount) {
        this.amount = amount;
    }

    /**
     * @return Returns the goodtype.
     */
    public String getGoodtype() {
        return goodtype;
    }

    /**
     * @return Returns the value of the good.
     */
    public int getValue() {
        if (goodtype.equals("GAME")) {
            return amount * 300;
        } else if (goodtype.equals("ORE")) {
            return amount * 600;
        } else if (goodtype.equals("MMM")) {
            return amount * 900;
        } else if (goodtype.equals("WEAPONS")) {
            return amount * 900;
        } else if (goodtype.equals("FOOD")) {
            return amount * 400;
        } else if (goodtype.equals("WATER")) {
            return amount * 300;
        } else if (goodtype.equals("MEDICINE")) {
            return amount * 300;
        } else if (goodtype.equals("ROBOTS")) {
            return amount * 1200;
        } else {
            return 0;
        }
    }
    /**
     * @param goodtype The goodtype to set.
     */
    public void setGoodtype(String goodtype) {
        this.goodtype = goodtype;
    }
}